﻿<%@ Page Title="Camera Portal" Language="C#" MasterPageFile="AdminMaster.master" AutoEventWireup="true" Inherits="iSpyCentral.admin.API" Codebehind="API.aspx.cs" %>
<asp:Content runat="server" ContentPlaceHolderID="HeadContent">
<script type="text/javascript">
    function GenerateKey() {
        $.ajax({
            type: "POST",
            url: "/webservices/UserAdmin.asmx/GenerateApiKey",
            data: '{appName:"' + $("#txtAppName").val() + '"}',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function (response) {
                if (response.d === "OK") {
                    document.location.reload(true);
                } else {
                    $("#error").html(response.d);
                    $("#error").show();
                }
                    
            },
            failure: null
        });
    }
</script>
    <style type="text/css">.apiKey { font-weight:bold}</style>
</asp:Content>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <div class="top-blocks">

    <div class="right">
    <a name="settings"></a>
    <h2 class="contentheading about">API Access</h2>
    <div class="contentdescription">
    <div class="row">
       <div class="col-md-12">
        <div class="well-lg">
        <h3>Create your own apps</h3>
        <p class="lead">Create an API Key here and start writing your own apps to connect to and control <strong>iSpy</strong>. We'll issue you with an access key that you can use in your applications to request access to any client&#39;s server.</p>
        <br />
<asp:PlaceHolder runat="server" ID="phKeys">
    <div class="table-responsive">
        <table class="table table-striped table-bordered">
            <thead>
                <tr><th>Application</th><th>API Key</th><th>Status</th></tr>
            </thead>
            <tbody>
            <%=HTML %>
            </tbody>
        </table>
    </div>
</asp:PlaceHolder>
        <form class="form-horizontal" role="form" method="POST">
            <table class="table table-striped table-bordered">
                <tr><td>App Name</td><td><input type="text" id="txtAppName" value=""/></td></tr>
                <tr><td></td><td><input type="button" id="btnGenerate" value="Generate Key" onclick="GenerateKey()" class="btn btn-primary"/></td></tr>
            </table>
        </form>
        <div id="error" class="alert alert-danger" style="display:none" ></div>
        </div>
    </div>
    </div>
    <div class="row">
       <div class="col-md-12">
        <div class="well-lg">
        <h3>Getting Started</h3>
            <p>Once you have an API Key you can request access to a client&#39;s server by directing them to:<br/>
                <pre><%=SiteURL %>/monitor/user.aspx?APIKey=[YOUR API KEY]#/page/api-access</pre>
            </p>
            <p>When they have granted your application access they will be given an access token that they can then use in your application to complete authorization.</p>
            <p>You will need to provide your clients with the ability to enter and save this token and store it for future use.</p>
            <p>You can then use the token and API Key to call our simple REST API webservice to get the details of their connected instances:</p>
            <pre><%=SiteURL %>/webservices/API.aspx?token=[TOKEN]&apiKey=[API KEY]</pre>
            <p>This returns a JSON object that will either contain an error message or a configuration object:</p>
            <pre>{"error":"Error message is here"}</pre>
            or
            <pre>
{
    "configuration": {
        "connectedServers":[
            {
                "name":"Server1",
                "wanPort":8090,
                "lanPort":8090,
                "overrideURL":"",
                "version":"1.3.6.0",
                "ssl":false,
                "connected":true,
                "loopback":true,
                "Auth":"eb05c798-1aad-4c8c-83f6-d5c213a88270",
                "serverIP":"200.198.47.5",
                "localIP":"192.168.1.8",
                "useLANIP":true,
                "clientIP":"200.198.47.5",
                "platform":"iSpy"
            }
        ]
    }
}
            </pre>
            <p>Using the configuration you can build a URL to access their server. There may be zero or more connected servers. Here is an example javascript function to determine the connection URL:</p>
            <pre>
 function(server) {
    var serverAddress;
    server.isLocal = true;

        if ((server.clientIP === server.serverIP) && server.useLANIP && server.localIP !== "") {
            //Internal IP Access
            serverAddress = (server.ssl ? "https" : "http") + "://" + server.localIP + ":" + server.lanPort + "/";
        } else {
            if (server.overrideURL !== "") {
                serverAddress = server.overrideURL;
            } else {
                //External IP Access
                serverAddress = (server.ssl ? "https" : "http") + "://" + server.serverIP + ":" + server.wanPort + "/";
            }
            server.isLocal = false;
        }
            

    return serverAddress;
}
</pre>
            <h3>Notes</h3>
            <ul class="list list-bullet">
                <li>Once you have the server address you can use any of the <a href="http://www.ispyconnect.com/userguide-http.aspx">http commands</a> to interface with the client's server.</li>
                <li>You can retrieve a detailed object list (cameras and microphones from iSpy) by calling <b>http://[server url]/loadobject.json?cmd=loadobjects&amp;Auth=[server Auth]</b></li>
                <li>There is websocket server running at <b>http://[server url]/websocket?Auth=[server Auth]</b> that provides realtime alert and recording notifications</li>
                <li>For other API calls to <strong>iSpy</strong> you can use <a href="http://www.telerik.com/fiddler/fiddlercore">fiddler</a> whilst using the monitor to view the requests and JSON responses.</li>
            </ul>
        </div>
        </div>
    </div>
    </div>
    </div>
    </div>

</asp:Content>
<asp:Content ID="SubFooter" ContentPlaceHolderID="SubFooterContent" runat="server">
</asp:Content>