﻿if (typeof $ === 'undefined') { throw new Error('iSpyConnect requires jQuery'); }
var App = angular.module('iSpyConnect', ['ngRoute', 'ngAnimate', 'ngStorage', 'ngCookies', 'pascalprecht.translate', 'ui.bootstrap', 'ui.router', 'oc.lazyLoad', 'cfp.loadingBar', 'ui.utils', 'ui.bootstrap-slider'])
    .run(["$rootScope", "$state", "$stateParams", '$localStorage', function ($rootScope, $state, $stateParams, $localStorage) {
        // Set reference to access them from any scope
        $rootScope.$state = $state;
        $rootScope.$stateParams = $stateParams;
        $rootScope.$storage = $localStorage;
        iSpy.rootScope = $rootScope;

        // Scope Globals
        // ----------------------------------- 
        $rootScope.app = {
            name: 'iSpyConnect',
            description: 'Video Surveillance Software2',
            year: ((new Date()).getFullYear()),
            viewAnimation: 'ng-fadeInLeft2',
            layout: {
                isFixed: true,
                isBoxed: false,
                isRTL: false
            },
            sidebar: {
                isCollapsed: false,
                slide: false
            },
            themeId: 0,
            theme: {
                sidebar: 'bg-inverse',
                brand:   'bg-inverse',
                topbar:  'bg-white'
            }
        };
    
        // User information
        $rootScope.user = {
            name:     '',
            job:      '',
            picture:  'app/img/user/acc.png'
        };

    }
    ]);

// Application Controller
// ----------------------------------- 

App.controller('AppController',
  ['$rootScope', '$scope', '$state', '$window', '$localStorage', '$timeout', '$translate','toggleStateService', 'colors','browser', 'cfpLoadingBar', '$http', 'support', 'toaster',
  function($rootScope, $scope, $state, $window, $localStorage, $timeout, $translate, toggle, colors, browser, cfpLoadingBar, $http, support, toaster) {
      "use strict";

      if(support.touch)
          $('html').addClass('touch');

      // Loading bar transition
      // ----------------------------------- 
    
      var latency;
      $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {

          if (toState.name == "server") {
              var osrv = iSpy.config.connectedServers[toParams.index];
              iSpy.api.serverClick(osrv);
              event.preventDefault();
              return;
          }
          if($('.app-container > section').length) // check if bar container exists
              latency = $timeout(function() {
                  cfpLoadingBar.start();
              }, 0); // sets a latency Threshold
      });
      $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
          event.targetScope.$watch("$viewContentLoaded", function () {
              $timeout.cancel(latency);
              cfpLoadingBar.complete();
          });
      });

      // State Events Hooks
      // ----------------------------------- 

      // Hook not found
      $rootScope.$on('$stateNotFound',
        function(event, unfoundState, fromState, fromParams) {
            console.log(unfoundState.to); // "lazy.state"
            console.log(unfoundState.toParams); // {a:1, b:2}
            console.log(unfoundState.options); // {inherit:false} + default options
        });

      // Hook success
      $rootScope.$on('$stateChangeSuccess',
        function(event, toState, toParams, fromState, fromParams) {
            // display new view from top
            $window.scrollTo(0, 0);
        });

      // Create your own per page title here
      $rootScope.pageTitle = function() {
          return $rootScope.app.name + ' - ' + $rootScope.app.description;
      };

      // Restore layout settings
      // ----------------------------------- 

      if( angular.isDefined($localStorage.settings) )
          $rootScope.app = $localStorage.settings;
      else
          $localStorage.settings = $rootScope.app;

      $rootScope.$watch("app.layout", function () {
          $localStorage.settings = $rootScope.app;
      }, true);

    
      // Allows to use branding color with interpolation
      // {{ colorByName('primary') }}
      $scope.colorByName = colors.byName;

      // Restore application classes state
      toggle.restoreState( $(document.body) );

      $rootScope.cancel = function($event) {
          $event.stopPropagation();
      };

      $rootScope.menuItemClick = function ($event, item) {
          if (item.server) {
              $event.stopPropagation();
              $event.preventDefault();
              iSpy.api.serverClick(item.server);
          }
      };

      $rootScope.pop = function (type, title, text) {
          toaster.pop(type, $translate.instant(title), $translate.instant(text));
      };

      var jp = $("#jquery_jplayer_video_1");
      if (jp) {
          jp.jPlayer({
              ready: function(event) {
                  iSpy.videoPlayer = $(this);
                  if (event.jPlayer.status.noFullWindow) {
                      var $anc = $($(this).jPlayer("option", "cssSelectorAncestor"));
                      $anc.find('.jp-screen-control').hide();
                      $anc.find('.jp-bar').css({ "right": "0" });
                  }

                  var fix_iOS_flash = function() {
                      var w = $(this).data("jPlayer").ancestorJq.width(),
                          h = w * 9 / 16; // Change to suit your aspect ratio. Used 16:9 HDTV ratio.
                      $(this).jPlayer("option", "size", {
                          width: w + "px",
                          height: h + "px"
                      });
                  };
                  var plt = $.jPlayer.platform;
                  if (plt.ipad || plt.iphone || plt.ipod || event.jPlayer.flash.used) {
                      $(window).on("resize", function() {
                          fix_iOS_flash();
                      });
                      fix_iOS_flash();
                  }
              },
              timeFormat: {
                  padMin: false
              },
              swfPath: "/monitor/app/flat-bundle/js",
              supplied: "m4v,mp3",
              cssSelectorAncestor: "#jp_container_video_1",
              // See the CSS for more info on changing the size.
              size: {
                  width: "100%",
                  height: "auto",
                  cssClass: "jp-flat-video-responsive"
              },
              sizeFull: {
                  cssClass: "jp-flat-video-full"
              },
              autohide: {
                  full: false,
                  restored: false
              },
              // While playing, allow the GUI to hide
              play: function() {
                  $(this).jPlayer("option", "autohide", {
                      full: true,
                      restored: true
                  });
                  // Avoid multiple jPlayers playing together.
                  $(this).jPlayer("pauseOthers");
              },
              // When paused, show the GUI
              pause: function() {
                  $(this).jPlayer("option", "autohide", {
                      full: false,
                      restored: false
                  });
              },
              // Enable clicks on the video to toggle play/pause
              click: function(event) {
                  if (event.jPlayer.status.paused) {
                      $(this).jPlayer("play");
                  } else {
                      $(this).jPlayer("pause");
                  }
              },
              useStateClassSkin: true,
              autoBlur: false,
              smoothPlayBar: !($.jPlayer.browser.msie && $.jPlayer.browser.version < 9), // IE8 did not like the hidden animated progress bar.
              remainingDuration: true,
              keyEnabled: true,
              keyBindings: {
                  // Disable some of the default key controls
                  loop: null,
                  muted: null,
                  volumeUp: null,
                  volumeDown: null
              }
          });

          $("#jquery_jplayer_audio_1").jPlayer({
              ready: function(event) {
                  iSpy.audioPlayer = $(this);
              },
              play: function() { // Avoid multiple jPlayers playing together.
                  $(this).jPlayer("pauseOthers");
              },
              timeFormat: {
                  padMin: false
              },
              swfPath: "js",
              supplied: "mp3",
              cssSelectorAncestor: "#jp_container_audio_1",
              useStateClassSkin: true,
              autoBlur: false,
              smoothPlayBar: true,
              remainingDuration: true,
              keyEnabled: true,
              keyBindings: {
                  // Disable some of the default key controls
                  loop: null,
                  muted: null,
                  volumeUp: null,
                  volumeDown: null
              },
              wmode: "window"
          });
      }


      iSpy.initialise($rootScope, browser, $localStorage);
  }]);

/**=========================================================
 * Module: config.js
 * App routes and resources configuration
 =========================================================*/

App.config(['$stateProvider', '$urlRouterProvider', '$controllerProvider', '$compileProvider', '$filterProvider', '$provide', '$ocLazyLoadProvider', '$translateProvider', 'appDependencies', '$locationProvider',
    function ($stateProvider, $urlRouterProvider, $controllerProvider, $compileProvider, $filterProvider, $provide, $ocLazyLoadProvider, $translateProvider, appDependencies, $locationProvider) {
        'use strict';

        $locationProvider.html5Mode(true);
        App.controller = $controllerProvider.register;
        App.directive  = $compileProvider.directive;
        App.filter     = $filterProvider.register;
        App.factory    = $provide.factory;
        App.service    = $provide.service;
        App.constant   = $provide.constant;
        App.value = $provide.value;

        $translateProvider.preferredLanguage('en');

        // LAZY LOAD MODULES
        // ----------------------------------- 

        $ocLazyLoadProvider.config({
            debug: false,
            events: true,
            modules: appDependencies.modules
        });


        // default route to summary
        $urlRouterProvider.otherwise('/app/summary');
        var v = 1;
        // 
        // App Routes
        // -----------------------------------   
        $stateProvider
          .state('app', {
              url: '/app',
              abstract: true,
              templateUrl: basepath('app.html?v='+v),
              controller: 'AppController',
              resolve: requireDeps('icons', 'screenfull', 'toaster', 'animate', 'jplayer', 'jquery-ui', 'slider', 'jquery-touch', 'colorpicker.module')
          })
          .state('app.timeline', {
              url: '/timeline',
              templateUrl: basepath('timeline.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.files', {
              url: '/files',
              templateUrl: basepath('files.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.commands', {
              url: '/commands',
              templateUrl: basepath('commands.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.videowall', {
              url: '/videowall',
              templateUrl: basepath('videowall.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.accountsummary', {
              url: '/summary',
              templateUrl: basepath('summary.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.accountpermissions', {
              url: '/permissions',
              templateUrl: basepath('permissions.html?v=' + v),
              controller: 'iSpyController'
          })
        .state('app.live', {
            url: '/live',
            templateUrl: basepath('live.html?v=' + v),
            controller: 'iSpyController'
        })
          .state('app.accountlogs', {
              url: '/logs',
              templateUrl: basepath('logs.html?v=' + v),
              controller: 'iSpyController'
          })
        .state('app.serverlogs', {
            url: '/serverlogs',
            templateUrl: basepath('serverlogs.html?v=' + v),
            controller: 'iSpyController'
        })
          .state('app.recharge', {
              url: '/recharge',
              templateUrl: basepath('recharge.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.accountpaymenthistory', {
              url: '/paymenthistory',
              templateUrl: basepath('paymenthistory.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.subscribe', {
              url: '/subscribe',
              templateUrl: basepath('subscribe.html?v=' + v),
              controller: 'iSpyController'
          })
            .state('app.subscribed', {
                url: '/subscribed',
                templateUrl: basepath('subscribed.html?v=' + v),
                controller: 'iSpyController'
            })
          .state('app.embedcamera', {
              url: '/embedcamera',
              templateUrl: basepath('embedcamera.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.embedviewer', {
              url: '/embedviewer',
              templateUrl: basepath('embedviewer.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.snapshots', {
              url: '/snapshots',
              templateUrl: basepath('snapshots.html?v=' + v),
              controller: 'iSpyController'
          })
          .state('app.livestills', {
                url: '/livestills',
                templateUrl: basepath('livestills.html?v=' + v),
                controller: 'iSpyController'
          })
          .state('server', {
            url: '/server',
            params: {index:null}


          })
        // 
        // CUSTOM RESOLVE FUNCTION
        //   Add your own resolve properties
        //   following this object extend
        //   method
        // ----------------------------------- 
        // .state('app.yourRouteState', {
        //   url: '/route_url',
        //   templateUrl: 'your_template.html',
        //   controller: 'yourController',
        //   resolve: angular.extend(
        //     requireDeps(...), {
        //     // YOUR CUSTOM RESOLVES HERE
        //     }
        //   )
        // })
        ;

        // Change here your views base path
        function basepath(uri) {
            return 'app/views/' + uri;
        }

        // Generates a resolve object by passing script names
        // previously configured in constant.appDependencies
        // Also accept functions that returns a promise
        function requireDeps() {
            var _args = arguments;
            return {
                deps: ['$ocLazyLoad','$q', function ($ocLL, $q) {
                    // Creates a promise chain for each argument
                    var promise = $q.when(1); // empty promise
                    for(var i=0, len=_args.length; i < len; i ++){
                        promise = addThen(_args[i]);
                    }
                    return promise;

                    // creates promise to chain dynamically
                    function addThen(_arg) {
                        // also support a function that returns a promise
                        if(typeof _arg == 'function')
                            return promise.then(_arg);
                        else
                            return promise.then(function() {
                                // if is a module, pass the name. If not, pass the array
                                var whatToLoad = getRequired(_arg);
                                // simple error check
                                if(!whatToLoad) return $.error('Route resolve: Bad resource name [' + _arg + ']');
                                // finally, return a promise
                                return $ocLL.load( whatToLoad );
                            });
                    }
                    // check and returns required data
                    // analyze module items with the form [name: '', files: []]
                    // and also simple array of script files (for not angular js)
                    function getRequired(name) {
                        if (appDependencies.modules)
                            for(var m in appDependencies.modules)
                                if(appDependencies.modules[m].name && appDependencies.modules[m].name === name)
                                    return appDependencies.modules[m];
                        return appDependencies.scripts && appDependencies.scripts[name];
                    }

                }]};
        }


    }]).config(['$tooltipProvider', function ($tooltipProvider) {

        $tooltipProvider.options({appendToBody: true});

    }]).config(['$translateProvider', function ($translateProvider) {

        $translateProvider.useStaticFilesLoader({
            prefix : 'app/langs/',
            suffix : '.json'
        });
        
        $translateProvider.useLocalStorage();

    }]).config(['cfpLoadingBarProvider', function(cfpLoadingBarProvider) {
        cfpLoadingBarProvider.includeBar = true;
        cfpLoadingBarProvider.includeSpinner = false;
        cfpLoadingBarProvider.latencyThreshold = 500;
        cfpLoadingBarProvider.parentSelector = '.app-container > section';
    }])
.controller('NullController', function() {});

/**=========================================================
 * Module: constants.js
 * Define constants to inject across the application
 =========================================================*/

App
  .constant('appDependencies', {
      // jQuery based and standalone scripts
      scripts: {
          'jquery-ui':          ['app/vendor/jquery-ui/jquery-ui.min.js'],
          'jquery-touch':       ['app/vendor/jqueryui-touch-punch/jquery.ui.touch-punch.min.js'],
          'animate':            ['app/vendor/animate.css/animate.min.css'],
          'icons':              ['app/vendor/fontawesome/css/font-awesome.min.css'],
          'screenfull':         ['app/vendor/screenfull/dist/screenfull.min.js'],
          'slider':             ['app/vendor/seiyria-bootstrap-slider/dist/css/bootstrap-slider.css', 'app/vendor/seiyria-bootstrap-slider/dist/bootstrap-slider.js'],
          'jplayer': ['app/flat-bundle/css/flat.audio.css', 'app/flat-bundle/css/flat.video.css','app/flat-bundle/js/jquery.jplayer.min.js']
      },
      // Angular based script (use the right module name)
      modules: [
        {name: 'toaster',           files: ['app/vendor/angularjs-toaster/toaster.js',
                                             'app/vendor/angularjs-toaster/toaster.css']},
        {name: 'angular-chosen',    files: ['app/vendor/chosen_v1.2.0/chosen.jquery.min.js',
                                            'app/vendor/chosen_v1.2.0/chosen.min.css',
                                            'app/vendor/angular-chosen/angular-chosen.js']},
        {name: 'ui.calendar',       files: ['app/vendor/fullcalendar/dist/fullcalendar.min.js',
                                            'app/vendor/fullcalendar/dist/fullcalendar.css',
                                            'app/vendor/angular-ui-calendar/src/calendar.js']
        },
        {
            name: 'colorpicker.module', files: ['app/vendor/colorpicker/bootstrap-colorpicker-module.min.js',
                                               'app/vendor/colorpicker/colorpicker.min.css']
        }

      ]

  })
  // Same colors as defined in the css
  .constant('appColors', {
      'primary':                '#43a8eb',
      'success':                '#88bf57',
      'info':                   '#8293b9',
      'warning':                '#fdaf40',
      'danger':                 '#eb615f',
      'inverse':                '#363C47',
      'turquoise':              '#2FC8A6',
      'pink':                   '#f963bc',
      'purple':                 '#c29eff',
      'orange':                 '#F57035',
      'gray-darker':            '#2b3d51',
      'gray-dark':              '#515d6e',
      'gray':                   '#A0AAB2',
      'gray-light':             '#e6e9ee',
      'gray-lighter':           '#f4f5f5'
  })
  // Same MQ as defined in the css
  .constant('appMediaquery', {
      'desktopLG':             1200,
      'desktop':                992,
      'tablet':                 768,
      'mobile':                 480
  })
;


/**=========================================================
 * Module: BootstrapSliderDirective
 * Initializes the jQuery UI slider controls
 =========================================================*/

App.directive('bootstrapSlider', function() {
    'use strict';
    return {
        restrict: 'A',
        controller: ["$scope", "$element", function($scope, $element) {
            var $elem = $($element);
            if ($.fn.bootstrapSlider)
                $elem.bootstrapSlider();
        }]
    };
});




App.service('language', ["$translate", function($translate) {
    'use strict';
    // Internationalization
    // ----------------------

    var Language = {
        data: {
            // Handles language dropdown
            listIsOpen: false,
            // list of available languages
            available: {
                'en': 'English',
                'de': 'Deutsche',
                'es': 'Español',
                'fr': 'Français',
                'it': 'Italiano',
                'pt': 'Português',
                'zh': '中文'
      },
                selected: 'English'
            },
            // display always the current ui language
            init: function () {
                var proposedLanguage = $translate.proposedLanguage() || $translate.use();
                var preferredLanguage = $translate.preferredLanguage(); // we know we have set a preferred one in App.config
                this.data.selected = this.data.available[ (proposedLanguage || preferredLanguage) ];
                return this.data;

            },
            set: function (localeId, ev) {
                // Set the new idiom
                $translate.use(localeId);
                // save a reference for the current language
                this.data.selected = this.data.available[localeId];
                // finally toggle dropdown
                this.data.listIsOpen = ! this.data.listIsOpen;
            }
        };

    return Language;
}]);
/**=========================================================
 * Module: HeaderNavController
 * Controls the header navigation
 =========================================================*/

App.controller('HeaderNavController', ['$scope', function($scope) {
    'use strict';
    $scope.headerMenuCollapsed = true;
    $scope.iSpy = iSpy;

    $scope.toggleHeaderMenu = function() {
        $scope.headerMenuCollapsed = !$scope.headerMenuCollapsed;
    };

    $scope.summaryicon = "";
    var hasError = false;
    $scope.addLog = function (action, result, error, title) {
        var log = { action: action, result: result, error: error, title: title, time: new Date() };
        iSpy.Log.splice(0, 0, log);
        if (iSpy.Log.length > iSpy.MaxLogLength) {
            iSpy.Log.pop();
        }
        if (log.error) {
            hasError = true;
            $scope.summaryicon = "point point-warning point-lg";
            $scope.$apply();
        }
        //if (!hasError) {
        //    $scope.summaryicon = "point point-success point-lg";
        //}
    };
    iSpy.LogScope = $scope;

    $scope.addLog("Logging", "Started", false, "Logging has been initialised");

    $scope.reset = function() {
        $scope.summaryicon = "";
    }
    $scope.clear = function() {
        iSpy.Log = [];
        $scope.summaryicon = "";
    }
}]);
/**=========================================================
 * Module: SettingsController.js
 * Handles app setting
 =========================================================*/

App.controller('SettingsController', ["$scope", "$rootScope", "$localStorage", "language", function($scope, $rootScope, $localStorage, language) {
    'use strict';
    $scope.app = $rootScope.app;

    $scope.themes = [
      {sidebar: 'bg-inverse', brand: 'bg-info', topbar:  'bg-white'},
      {sidebar: 'bg-inverse', brand: 'bg-inverse', topbar:  'bg-white'},
      {sidebar: 'bg-inverse', brand: 'bg-purple', topbar:  'bg-white'},
      {sidebar: 'bg-inverse', brand: 'bg-success', topbar:  'bg-white'},
      {sidebar: 'bg-white br', brand: 'bg-inverse', topbar:  'bg-inverse'},
      {sidebar: 'bg-inverse', brand: 'bg-info', topbar:  'bg-info'},
      {sidebar: 'bg-white br', brand: 'bg-purple', topbar:  'bg-purple'},
      {sidebar: 'bg-white br', brand: 'bg-primary', topbar:  'bg-primary'}
    ];

    $scope.setTheme = function($idx) {
        $scope.app.theme = $scope.themes[$idx];
        setTimeout(iSpy.helper.setTheme, 500);
    };

    // Init internationalization service
    $scope.language = language.init();
    $scope.language.set = angular.bind(language,language.set);

  
}]);


/**=========================================================
 * Module: FormInputController.js
 * Controller for input components
 =========================================================*/

App.controller('iSpySearchFromController', iSpySearchFromController);

function iSpySearchFromController($scope) {
    'use strict';

    // Datepicker
    // ----------------------------------- 

    this.today = function() {
        this.dt = new Date();
    };
    this.today();

    this.clear = function () {
        this.dt = null;
    };

    // Disable weekend selection
    this.disabled = function(date, mode) {
        return false; //( mode === 'day' && ( date.getDay() === 0 || date.getDay() === 6 ) );
    };

    this.toggleMin = function() {
        this.minDate = this.minDate ? null : new Date();
    };
    this.toggleMin();

    this.open = function($event) {
        $event.preventDefault();
        $event.stopPropagation();
		this.opened = true;
    };

    this.dateOptions = {
        formatYear: 'yy',
        startingDay: 1
    };

    this.dt = iSpy.searchOptions.fromDate || iSpy.searchOptions.tempFromDate;

    // Timepicker
    // ----------------------------------- 

    this.hstep = 1;
    this.mstep = 15;

    this.options = {
        hstep: [1, 2, 3],
        mstep: [1, 5, 10, 15, 25, 30]
    };

    this.ismeridian = true;
    this.toggleMode = function() {
        this.ismeridian = ! this.ismeridian;
    };

    this.update = function() {
        this.dt = d;
    };

    this.changed = function () {
		iSpy.searchOptions.tempFromDate = this.dt;
        console.log('Time changed to: ' + this.dt);
    };

    this.clear = function() {
        this.dt = null;
    };
}

iSpySearchFromController.$inject = ["$scope"];

/**=========================================================
 * Module: FormInputController.js
 * Controller for input components
 =========================================================*/

App.controller('iSpySearchToController', iSpySearchToController);

function iSpySearchToController($scope) {
    'use strict';

    // Datepicker
    // ----------------------------------- 

    this.today = function() {
        this.dt = new Date();
    };
    this.today();

    this.clear = function () {
        this.dt = null;
    };

    // Disable weekend selection
    this.disabled = function(date, mode) {
        return false; //( mode === 'day' && ( date.getDay() === 0 || date.getDay() === 6 ) );
    };

    this.toggleMin = function() {
        this.minDate = this.minDate ? null : new Date();
    };
    this.toggleMin();

    this.open = function($event) {
        $event.preventDefault();
        $event.stopPropagation();
		this.opened = true;
    };

    this.dateOptions = {
        formatYear: 'yy',
        startingDay: 1
    };

    this.dt = iSpy.searchOptions.toDate  || iSpy.searchOptions.tempToDate;

    // Timepicker
    // ----------------------------------- 

    this.hstep = 1;
    this.mstep = 15;

    this.options = {
        hstep: [1, 2, 3],
        mstep: [1, 5, 10, 15, 25, 30]
    };

    this.ismeridian = true;
    this.toggleMode = function() {
        this.ismeridian = ! this.ismeridian;
    };

    this.update = function() {
        this.dt = d;
    };

    this.changed = function () {
		iSpy.searchOptions.tempToDate = this.dt;
        console.log('Time changed to: ' + this.dt);
    };

    this.clear = function() {
        this.dt = null;
    };
}

iSpySearchToController.$inject = ["$scope"];

/**=========================================================
 * Module: SummaryController.js
 * Handles app setting
 =========================================================*/

App.controller('SummaryController', ["$scope", "colors", function($scope, colors) {
    'use strict';

}]);

/**=========================================================
 * Module: SearchFormController.js
 * Provides autofill for top navbar search form
 =========================================================*/

App.controller('SearchFormController', ["$scope", "$state", "$translate", function ($scope, $state, $translate) {
    'use strict';
  
    var routes = $state.get(),
    blackList = ['app', 'page']; // routes that don't want to show

    $scope.routeSelected = undefined;

    $scope.states = routes.filter(function(item){

        return ( blackList.indexOf(item.name) < 0 ? true : false);

    }).map(function(item){

        return item.name;

    });

    $scope.onRouteSelect = function ($item, $model, $label) {

        // move to route when match is selected
        if($model) {
            $state.go($model);
            $scope.routeSelected = undefined;
        }

    };
  

}]);
App.controller('Wizard', ['$scope','$interval', '$translate',"toaster",function($scope, $interval, $translate, toaster) {
    var poll;
    var osrv = iSpy.currentServer;
    $scope.iSpy = iSpy;
    $scope.activeStep = 1;
    $scope.searching = false;
    
    $scope.getMakes = function (val) {
        return iSpy.api.commandDeferred(osrv, "loadmakes&search=" + val).then(function (osrv, resp) { return resp.makes; });
    };

    $scope.getModels = function (val) {
        return iSpy.api.commandDeferred(osrv, "loadmodels&make=" + iSpy.wizard.make + "&search=" + val).then(function (osrv, resp) { return resp.models; });
    };
    
    $scope.search = function(fullScan) {
        if ( angular.isDefined(poll) ) return;
        $(".scanButtons").attr('disabled', 'disabled');

        iSpy.api.command(osrv, "scannetwork&full=" + fullScan + "&ports=" + iSpy.wizard.ports, function (osrv, data) {
            if (data.running) {
                toaster.pop("success", $translate.instant("s.ScanningNetwork"), $translate.instant("s.PleaseWait"));
                $scope.searching = true;
                poll = $interval(function () {
                    getResults();
                }, 1000);
            }
            if (data.error) {
                shutdown();
                toaster.pop("error", "s.Error", data.error);
            }
            $scope.$apply();
        });
        
    }

    function getResults()
    {
        iSpy.api.command(osrv,"getscannetworkresults",function (osrv,response) {
            iSpy.wizard.results = response.results;
            if (response.finished) {
                shutdown();
                toaster.pop("success", $translate.instant("s.Finished"), $translate.instant("s.ScanComplete"));
            }
            $scope.$apply();
        });
    }
    function shutdown() {
        if (angular.isDefined(poll)) {
            $interval.cancel(poll);
            poll = undefined;
        }
        $scope.searching = false;
        $(".scanButtons").removeAttr('disabled');
    }


    $scope.connect = function () {
        $scope.activeStep = 3;
        shutdown();
        var cmd = "scandevice";
        cmd += "&make=" + encodeURIComponent(iSpy.wizard.make);
        cmd += "&model=" + encodeURIComponent(iSpy.wizard.model);
        cmd += "&username=" + encodeURIComponent(iSpy.wizard.username);
        cmd += "&password=" + encodeURIComponent(iSpy.wizard.password);
        cmd += "&channel=" + encodeURIComponent(iSpy.wizard.channel);
        cmd += "&url=" + encodeURIComponent(iSpy.wizard.url);

        iSpy.api.command(osrv, cmd,function (osrv, response) {
            if (response.running) {
                $scope.searching = true;
                toaster.pop("success", $translate.instant("s.ScanningCamera"), $translate.instant("s.PleaseWait"));
                poll = $interval(function () {
                    getConnections();
                }, 1000);
            }
            if (response.error) {
                shutdown();
                toaster.pop("error", $translate.instant("s.Error"), response.error);
            }
            $scope.$apply();
        });

    }

    function getConnections() {
        iSpy.api.command(osrv, "getscandeviceresults", function(osrv, response) {
            iSpy.wizard.connections = response.results;
            if (response.finished) {
                shutdown();
                toaster.pop("success", $translate.instant("s.Finished"), $translate.instant("s.ScanComplete"));
            }
            $scope.$apply();
        });
    }

    $scope.finish = function (result) {
        iSpy.api.completeWizard(osrv, result);
    }

    $scope.setURL = function(result) {
        iSpy.wizard.url = "http://" + result.IPAddress + ":" + result.port + "/";
        $scope.connect();

    }

    $scope.$on('$destroy', function () {
        // Make sure that the interval is destroyed too
        shutdown();
    });
}]);

/**=========================================================
 * Module: SidebarController
 * Provides functions for sidebar markup generation.
 * Also controls the collapse items states
 =========================================================*/

App.controller('SidebarController', ['$rootScope', '$scope', '$location', '$http', '$timeout', 'sidebarmenu', 'appMediaquery', '$window',
  function($rootScope, $scope, $location, $http, $timeout, sidebarmenu, appMediaquery, $window ){
      'use strict';
      var currentState = $rootScope.$state.current.name;
      var $win  = $($window);
      var $html = $('html');
      var $body = $('body');

      // Load menu from json file
      // ----------------------------------- 
      sidebarmenu.load();
    
      // Adjustment on route changes
      $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
          currentState = toState.name;
          // Hide sidebar automatically on mobile
          $('body.aside-toggled').removeClass('aside-toggled');

          $rootScope.$broadcast('closeSidebarMenu');
      });

      // Normalize state on resize to avoid multiple checks
      $win.on('resize orientationchange', function() {
          if( isMobile() )
              $body.removeClass('aside-collapsed');
          else
              $body.removeClass('aside-toggled');
      });

      $rootScope.$watch('app.sidebar.isCollapsed', function(newValue, oldValue) {
          // Close subnav when sidebar change from collapsed to normal
          $rootScope.$broadcast('closeSidebarMenu');
          $rootScope.$broadcast('closeSidebarSlide');
      });

      // Check item and children active state
      var isActive = function(item) {

          if(!item || !item.sref) return false;

          var path = item.sref, prefix = '#';
          if(path === prefix) {
              var foundActive = false;
              angular.forEach(item.subnav, function(value, key) {
                  if(isActive(value)) foundActive = true;
              });
              return foundActive;
          }
          else {
              return (currentState === path);
          }
      };


      $scope.getSidebarItemClass = function(item) {
          return (item.type == 'heading' ? 'nav-heading' : '') +
                 (isActive(item) ? ' active' : '') ;
      };


      // Handle sidebar collapse items
      // ----------------------------------- 
      var collapseList = [];

      $scope.addCollapse = function($index, item) {
          collapseList[$index] = true; //!isActive(item);
      };

      $scope.isCollapse = function($index) {
          return collapseList[$index];
      };

      $scope.collapseAll = function() {
          collapseAllBut(-1);
      };

      $scope.toggleCollapse = function($index) {

          // States that doesn't toggle drodopwn
          if( (isSidebarCollapsed() && !isMobile()) || isSidebarSlider()  ) return true;
      


          collapseAllBut($index);
          collapseList[$index] = !collapseList[$index];
    
          return true;

      };

      function collapseAllBut($index) {
          angular.forEach(collapseList, function(v, i) {
              if($index !== i)
                  collapseList[i] = true;
          });
      }

      // Helper checks
      // ----------------------------------- 

      function isMobile() {
          return $win.width() < appMediaquery.tablet;
      }
      function isTouch() {
          return $html.hasClass('touch');
      }
      function isSidebarCollapsed() {
          return $rootScope.app.sidebar.isCollapsed;
      }
      function isSidebarToggled() {
          return $body.hasClass('aside-toggled');
      }
      function isSidebarSlider() {
          return $rootScope.app.sidebar.slide;
      }

  }]);

/**=========================================================
 * Module: SidebarDirective
 * Wraps the sidebar. Handles collapsed state and slide
 =========================================================*/

App.directive('sideBar', ['$rootScope', '$window', '$timeout', '$compile', 'appMediaquery', 'support', '$http', '$templateCache',
    function($rootScope, $window, $timeout, $compile, appMediaquery, support, $http, $templateCache) {
        'use strict';
  
        var $win  = $($window);
        var $html = $('html');
        var $body = $('body');
        var $scope;
        var $sidebar;
        var $sidebarNav;
        var $sidebarButtons;

        return {
            restrict: 'E',
            template: '<nav class="sidebar" ng-transclude></nav>',
            transclude: true,
            replace: true,
            link: function(scope, element, attrs) {
      
                $scope   = scope;
                $sidebar = element;
                $sidebarNav = element.children('.sidebar-nav');
                $sidebarButtons = element.find('.sidebar-buttons');

                // depends on device the event we use
                var eventName = isTouch() ? 'click' : 'mouseenter' ;
                $sidebarNav.on( eventName, '.nav > li', function() {
          
                    if( isSidebarCollapsed() && !isMobile() ) {
                        toggleMenuItem( $(this) );
                        if( isTouch() ) {
                            sidebarAddBackdrop();
                        }
                    }

                });

                // Check for click to slide sidebar navigation menu
                $sidebarNav.on('click', '.nav > li', function() {
                    if( isSidebarSlider() && !isSidebarCollapsed()) {
                        sidebarSliderToggle(this);
                    }
                });
      
                // Check for click to slide sidebar bottom item
                $sidebarButtons.on('click', '.btn-sidebar', function() {
                    // call parent method
                    $scope.collapseAll();
                    // slide sidebar 
                    sidebarSliderToggle(this);
                });

                // expose a close function to use a go back
                $sidebarNav.on('click', '.sidebar-close', function(){
                    sidebarSliderClose();
                });

                // if something ask us to close the sidebar menu
                $scope.$on('closeSidebarMenu', function() {
                    sidebarCloseFloatItem();
                    iSpy.helper.layoutChanged();
                });
                // if something ask us to close the sidebar slide
                $scope.$on('closeSidebarSlide', function() {
                    sidebarSliderClose();
                    iSpy.helper.layoutChanged();
                });
      
            }
        };

        // Sidebar slide mode
        // ----------------------------------- 
  
        function sidebarSliderClose() {
            if( !$sidebar.hasClass('sidebar-slide')) return 0;

            if( support.transition ) {
                return $sidebar
                  .on(support.transition.end, removeMenuDom)
                  .removeClass('sidebar-slide').length;
            }
            else {
                $timeout(removeMenuDom, 500);
                return $sidebar.removeClass('sidebar-slide').length;
            }

            function removeMenuDom() {
                if(support.transition)
                    $sidebar.off(support.transition.end);
                $sidebarNav
                  .find('.nav-slide').hide()
                  .filter('.sidebar-subnav').remove();
            }
        }

        // expect an level 1 li element
        function sidebarSliderToggle(element) {

            var $el = $(element),
                // Find a template
                $item = $el; //$el.siblings('.sidebar-slide-template');
            // if not exists, find a submenu UL
            if( ! $item.hasClass('btn-sidebar'))
                $item = $el.children('ul');
            // make sure other slider are closed
            if( sidebarSliderClose() )
                return;

            if($item.length) {

                var templatePath = $item.attr('compile');
                var newItem, templateContent;

                // Compile content when it contains angular
                if( templatePath ) {
                    templateContent = $templateCache.get(templatePath);
                    if( templateContent ) {
                        prepareItemTemplate( templateContent, templatePath );
                    }
                    else {
                        $http.get(templatePath).success(function(data) {
                            // cache the template markup
                            $templateCache.put(templatePath, data);
                            prepareItemTemplate( data, templatePath );
                        });
          
                    }
                }
                else {
                    newItem = $item.clone();
                    addSlideItemToDom(newItem);
                }
            }
        }

        function prepareItemTemplate(markup, id) {
            if( ! $scope.sbSlideItems ) $scope.sbSlideItems = {};
    
            if( ! $scope.sbSlideItems[id]  ) {
                // create an element and compile it
                $scope.sbSlideItems[id] = $compile(markup)($scope.$parent);

            }

            // append to dom
            addSlideItemToDom($scope.sbSlideItems[id]);
        }

        function addSlideItemToDom(newItem) {
            // the first the item is not in dom so we add it
            if ( ! newItem.inDom ) {
                newItem.inDom = true;
                newItem = newItem.prependTo($sidebarNav).addClass('nav-slide');
            }
            else {
                // nex time only show a hidden item
                newItem.show();
            }
    
            $timeout(function() {
                $sidebar.addClass('sidebar-slide')
                        .scrollTop(0);
            }, 100);

            // Actives the items
            newItem.on('click.slide.subnav', 'li:not(.sidebar-subnav-header)', function(e){
                e.stopPropagation();
                $(this).off('click.slide.subnav')
                  .siblings('li').removeClass('active')
                  .end().addClass('active');

            });
        }

        // Handles hover to open items on 
        // collapsed menu
        // ----------------------------------- 
        function toggleMenuItem($listItem) {

            sidebarCloseFloatItem();

            var ul = $listItem.children('ul');

            if( !ul.length )
                return;

            var navHeader = $('.navbar-header');
            var mar =  $rootScope.app.layout.isFixed ?  parseInt( navHeader.outerHeight(true), 0) : 0;

            var subNav = ul.clone(true,true).appendTo( '.sidebar-wrapper' );
    
            var itemTop = ($listItem.position().top + mar) - $sidebar.scrollTop();
            var vwHeight = $win.height();

            subNav
              .addClass('nav-floating')
              .css({
                  position: $rootScope.app.layout.isFixed ? 'fixed' : 'absolute',
                  top:      itemTop,
                  bottom:   (subNav.outerHeight(true) + itemTop > vwHeight) ? 0 : 'auto'
              });

            subNav.on('mouseleave', function() {
                subNav.remove();
            });
        }

        function sidebarCloseFloatItem() {
            $('.dropdown-backdrop').remove();
            $('.sidebar-subnav.nav-floating').remove();
        }

        function sidebarAddBackdrop() {
            var $backdrop = $('<div/>', { 'class': 'dropdown-backdrop'} );
            $backdrop.insertAfter($sidebar).on("click", function () {
                sidebarCloseFloatItem();
            });
        }


        function isTouch() {
            return $html.hasClass('touch');
        }
        function isSidebarCollapsed() {
            return $rootScope.app.sidebar.isCollapsed;
        }
        function isSidebarToggled() {
            return $body.hasClass('aside-toggled');
        }
        function isMobile() {
            return $win.width() < appMediaquery.tablet;
        }
        function isSidebarSlider() {
            return $rootScope.app.sidebar.slide;
        }

    }]);       
        
App.controller('iSpyController', ['$scope', '$timeout', "$modal", "$state", '$rootScope', function ($scope, $timeout, $modal, $state, $rootScope) {
    'use strict';
    $scope.iSpy = iSpy;
    iSpy.currentScope = $scope;
    iSpy.modal = $modal;
    $scope.Math = window.Math;
    $scope.onlyNumbers = /^\d+$/;
    iSpy.helper.setTheme();

    $scope.changeURL = function(pageName) {
        $state.go(pageName);
    }

    $scope.init = function (pageName) {
        if (iSpy.initialised) {
            $scope.$watch('$viewContentLoaded', function () {
                $timeout(function () {
                switch (pageName) {
                    case "recharge":
                        iSpy.clearBoundEvents();
                        iSpy.recharge.bindPage();
                        break;
                    case "embedviewer":
                    case "subscribed":
                    case "account":
                        iSpy.clearBoundEvents();
                        break;
                    case "serverlogs":
                        iSpy.clearBoundEvents();
                        iSpy.serverLogs.bindPage();
                        break;
                    case "logs":
                        iSpy.clearBoundEvents();
                        iSpy.logs.bindPage();
                        break;
                    case "paymentHistory":
                        iSpy.clearBoundEvents();
                        iSpy.paymentHistory.bindPage();
                        break;
                    case "subscribe":
                        iSpy.clearBoundEvents();
                        iSpy.subscribe.bindPage();
                        break;
                    case "timeline":
                        iSpy.clearBoundEvents();
                        iSpy.timeline.bindPage();
                        break;
                    case "commands":
                        iSpy.clearBoundEvents();
                        iSpy.commands.bindPage();
                        break;
                    case "embedcamera":
                        iSpy.clearBoundEvents();
                        iSpy.embed.camera.bindPage();
                        break;
                    case "files":
                        iSpy.clearBoundEvents();
                        iSpy.files.bindPage();
                        break;
                    case "snapshots":
                        iSpy.clearBoundEvents();
                        iSpy.snapshots.bindPage();
                        break;
                    case "videowall":
                        iSpy.clearBoundEvents();
                        iSpy.videowall.bindPage();
                        break;
                    case "live":
                        iSpy.clearBoundEvents();
                        iSpy.tools.playSource();
                        iSpy.PTZController = new iSpy.ptz($("#livevideo")[0]);
                        iSpy.commands.setButtons();
                        break;
                    case "livestills":
                        iSpy.clearBoundEvents();
                        iSpy.livestills.bindPage();
                        break;
                    }
                }, 200);
            });
        } else {
            $timeout(function() { $scope.init(pageName); }, 100);
        };
    };

    $scope.apply = function() {
        $timeout(function () { $scope.$apply(); });
    }

    $scope.open = function (size, page, param, okfunc, cancelfunc) {

        var modalInstance = $modal.open({
            templateUrl: 'app/views/' + page,
            controller: modalInstanceCtrl,
            size: size
        });

        modalInstance.result.then(function () {
            if (okfunc != null) {
                okfunc(param);
            }
            $timeout(function() {
                $rootScope.$apply();
            }, 1000);
        }, function () {
            if (cancelfunc != null) {
                cancelfunc(param);
            }
            $timeout(function () {
                $rootScope.$apply();
            }, 1000);
            return false;
        });

    };

    // Please note that $modalInstance represents a modal window (instance) dependency.
    // It is not the same as the $modal service used above.

    var modalInstanceCtrl = function ($scope2, $modalInstance) {

        $scope2.ok = function () {
            if (iSpy.api.modal.ok())
                $modalInstance.close('closed');
        };

        $scope2.cancel = function () {
            if (iSpy.api.modal.cancel())
                $modalInstance.dismiss('cancel');
        };
    };
    modalInstanceCtrl.$inject = ["$scope", "$modalInstance"];  
}]);


App.controller('NotificationsController', [
    '$scope', function($scope) {
        'use strict';
    $scope.iSpy = iSpy;
    $scope.NotificationsText = "t.Enable";
    $scope.NewRecordings = false;
    $scope.Alerts = false;
    $scope.AlertAudio = false;

    var n = window.Notification;
    if (!n) {
        $scope.NotificationsText = "t.Unavailable";
    } else {
        if (n.permission == "granted") {
            $scope.NotificationsText = "t.Active";
        }
    }
    $scope.DisableDesktopNotifications = iSpy.helper.readCookie("DisableDesktopNotifications") == "true";
    $scope.NewRecordings = iSpy.helper.readCookie("NotifyRecordings") == "true";
    $scope.Alerts = iSpy.helper.readCookie("NotifyAlerts") == "true";
    $scope.AlertAudio = iSpy.helper.readCookie("NotifyAlertAlarm") == "true";
      
    }]);
/**=========================================================
 * Module: ModalController
 * Provides a simple way to implement bootstrap modals from templates
 =========================================================*/

App.controller('ModalController', ["$scope", "$modal", "$log", function ($scope, $modal, $log) {
    'use strict';
    $scope.open = function (size,page, okfunc, param) {

        var modalInstance = $modal.open({
            templateUrl: 'app/views/'+page,
            controller: ModalInstanceCtrl,
            size: size
        });

        var state = $('#modal-state');
        modalInstance.result.then(function () {
            if (okfunc!=null)
                okfunc(param);
        });
    };

    // Please note that $modalInstance represents a modal window (instance) dependency.
    // It is not the same as the $modal service used above.

    var ModalInstanceCtrl = function ($scope2, $modalInstance) {

        $scope2.ok = function () {
            $modalInstance.close('closed');
        };

        $scope2.cancel = function () {
            $modalInstance.dismiss('cancel');
        };
    };
    ModalInstanceCtrl.$inject = ["$scope", "$modalInstance"];

}]);

App.directive('numericOnly', function () {
    return {
        require: 'ngModel',
        link: function (scope, element, attrs, modelCtrl) {

            modelCtrl.$parsers.push(function (inputValue) {
                var transformedInput = inputValue.replace(/[^\d.-]/g, '');

                if (transformedInput != inputValue) {
                    modelCtrl.$setViewValue(transformedInput);
                    modelCtrl.$render();
                }

                return transformedInput;
            });
        }
    };
});
/**=========================================================
 * Module: TitleCaseFilter.js
 * Convert any case to title
 =========================================================*/

App.filter('titlecase', function() {
    'use strict';
    return function(s) {
        s = ( s === undefined || s === null ) ? '' : s;
        return s.toString().toLowerCase().replace( /\b([a-z])/g, function(ch) {
            return ch.toUpperCase();
        });
    };
});

App.filter("sanitize", ['$sce', function ($sce) {
    return function (htmlCode) {
        return $sce.trustAsHtml(htmlCode);
    }
}]);

/**=========================================================
 * Module: AnimateEnabledDirective.js
 * Enable or disables ngAnimate for element with directive
 =========================================================*/

App.directive('animateEnabled', ['$animate', function ($animate) {
    'use strict';
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            scope.$watch(function () {
                return scope.$eval(attrs.animateEnabled, scope);
            }, function (newValue) {
                $animate.enabled(!!newValue, element);
            });
        }
    };
}]);
/**=========================================================
 * Module: EmptyAnchorDirective.js
 * Disables null anchor behavior
 =========================================================*/

App.directive('href', function() {
    'use strict';
    return {
        restrict: 'A',
        compile: function(element, attr) {
            return function(scope, element) {
                if((attr.ngClick || attr.href === '' || attr.href === '#')
                    && (!element.hasClass('dropdown-toggle')) ){
                    element.on('click', function(e){
                        e.preventDefault();
                        // e.stopPropagation();
                    });
                }
            };
        }
    };
});
/**=========================================================
 * Module: FullscreenDirective
 * Toggle the fullscreen mode on/off
 =========================================================*/

App.directive('toggleFullscreen', function() {
    'use strict';

    return {
        restrict: 'A',
        link: function(scope, element, attrs) {

            if (screenfull.enabled) {

                element.on('click', function (e) {
                    e.preventDefault();

                    screenfull.toggle();

                    // Switch icon indicator
                    if(screenfull.isFullscreen)
                        $(this).children('em').removeClass('fa-expand').addClass('fa-compress');
                    else
                        $(this).children('em').removeClass('fa-compress').addClass('fa-expand');
        
                });

            } else {
                element.remove();
            }
        }
    };

});


/**=========================================================
 * Module: ResetKeyDirective.js
 * Removes a key from the browser storage via element click
 =========================================================*/

App.directive('resetKey',  ['$state', '$rootScope', function($state, $rootScope) {
    'use strict';

    return {
        restrict: 'EA',
        link: function(scope, element, attrs) {
      
            var resetKey = attrs.resetKey;

            element.on('click', function (e) {
                e.preventDefault();

                if(resetKey) {
                    delete $rootScope.$storage[resetKey];
                    $state.go($state.current, {}, {reload: true});
                }
                else {
                    $.error('No storage key specified for reset.');
                }
            });
        }
    };

}]);
/**=========================================================
 * Module: ToggleStateDirective.js
 * Toggle a classname from the BODY
 * Elements must have [toggle-state="CLASS-NAME-TO-TOGGLE"]
 * [no-persist] to avoid saving the sate in browser storage
 =========================================================*/

App.directive('toggleState', ['toggleStateService', function(toggle) {
    'use strict';
  
    return {
        restrict: 'A',
        link: function(scope, element, attrs) {

            var $body = angular.element('body');

            $(element)
              .on('click', function (e) {
                  e.preventDefault();
                  var classname = attrs.toggleState;
          
                  if(classname) {
                      if( $body.hasClass(classname) ) {
                          $body.removeClass(classname);
                          if( ! attrs.noPersist)
                              toggle.removeState(classname);
                      }
                      else {
                          $body.addClass(classname);
                          if( ! attrs.noPersist)
                              toggle.addState(classname);
                      }
            
                  }

              });
        }
    };
  
}]);

App.service('sidebarmenu', ["$rootScope", "$http", function($rootScope, $http) {
    'use strict';
    var menuJson = 'app/js/sidebar.json';
    var menuURL  = menuJson + '?v=' + (new Date().getTime()); // jumps cache

    return {
        load: function() {

            $http.get(menuURL)
              .success(function (items) {
                    $rootScope.menuItems = items;

              })
              .error(function(data, status, headers, config) {

                  alert('Failure loading menu');

              });
        }
    };

}]);

/**=========================================================
 * Module: BrowserDetectionService.js
 * Browser detection service
 =========================================================*/

App.service('browser', function(){
    "use strict";

    var matched, browser;

    var uaMatch = function( ua ) {
        ua = ua.toLowerCase();

        var match = /(opr)[\/]([\w.]+)/.exec( ua ) ||
          /(chrome)[ \/]([\w.]+)/.exec( ua ) ||
          /(version)[ \/]([\w.]+).*(safari)[ \/]([\w.]+)/.exec( ua ) ||
          /(webkit)[ \/]([\w.]+)/.exec( ua ) ||
          /(opera)(?:.*version|)[ \/]([\w.]+)/.exec( ua ) ||
          /(msie) ([\w.]+)/.exec( ua ) ||
          ua.indexOf("trident") >= 0 && /(rv)(?::| )([\w.]+)/.exec( ua ) ||
          ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec( ua ) ||
          [];

        var platform_match = /(ipad)/.exec( ua ) ||
          /(iphone)/.exec( ua ) ||
          /(android)/.exec( ua ) ||
          /(windows phone)/.exec( ua ) ||
          /(win)/.exec( ua ) ||
          /(mac)/.exec( ua ) ||
          /(linux)/.exec( ua ) ||
          /(cros)/i.exec( ua ) ||
          [];

        return {
            browser: match[ 3 ] || match[ 1 ] || "",
            version: match[ 2 ] || "0",
            platform: platform_match[ 0 ] || ""
        };
    };

    matched = uaMatch( window.navigator.userAgent );
    browser = {};

    if ( matched.browser ) {
        browser[ matched.browser ] = true;
        browser.version = matched.version;
        browser.versionNumber = parseInt(matched.version);
    }

    if ( matched.platform ) {
        browser[ matched.platform ] = true;
    }

    // These are all considered mobile platforms, meaning they run a mobile browser
    if ( browser.android || browser.ipad || browser.iphone || browser[ "windows phone" ] ) {
        browser.mobile = true;
    }

    // These are all considered desktop platforms, meaning they run a desktop browser
    if ( browser.cros || browser.mac || browser.linux || browser.win ) {
        browser.desktop = true;
    }

    // Chrome, Opera 15+ and Safari are webkit based browsers
    if ( browser.chrome || browser.opr || browser.safari ) {
        browser.webkit = true;
    }

    // IE11 has a new token so we will assign it msie to avoid breaking changes
    if ( browser.rv )
    {
        var ie = "msie";

        matched.browser = ie;
        browser[ie] = true;
    }

    // Opera 15+ are identified as opr
    if ( browser.opr )
    {
        var opera = "opera";

        matched.browser = opera;
        browser[opera] = true;
    }

    // Stock Android browsers are marked as Safari on Android.
    if ( browser.safari && browser.android )
    {
        var android = "android";

        matched.browser = android;
        browser[android] = true;
    }

    // Assign the name and platform variable
    browser.name = matched.browser;
    browser.platform = matched.platform;
    return browser;

});
/**=========================================================
 * Module: ColorsService.js
 * Services to retrieve global colors
 =========================================================*/
 
App.factory('colors', ['appColors', function(appColors) {
    'use strict';
    return {
        byName: function(name) {
            return (appColors[name] || '#fff');
        }
    };

}]);

/**=========================================================
 * Module: SupportService.js
 * Checks for features supports on browser
 =========================================================*/

App.service('support', ["$document", "$window", function($document, $window) {
    'use strict';
    var support = {};
    var doc = $document[0];

    // Check for transition support
    // ----------------------------------- 
    support.transition = (function() {

        var transitionEnd = (function() {

            var element = doc.body || doc.documentElement,
                transEndEventNames = {
                    WebkitTransition: 'webkitTransitionEnd',
                    MozTransition: 'transitionend',
                    OTransition: 'oTransitionEnd otransitionend',
                    transition: 'transitionend'
                }, name;

            for (name in transEndEventNames) {
                if (element.style[name] !== undefined) return transEndEventNames[name];
            }
        }());

        return transitionEnd && { end: transitionEnd };
    })();

    // Check for animation support
    // ----------------------------------- 
    support.animation = (function() {

        var animationEnd = (function() {

            var element = doc.body || doc.documentElement,
                animEndEventNames = {
                    WebkitAnimation: 'webkitAnimationEnd',
                    MozAnimation: 'animationend',
                    OAnimation: 'oAnimationEnd oanimationend',
                    animation: 'animationend'
                }, name;

            for (name in animEndEventNames) {
                if (element.style[name] !== undefined) return animEndEventNames[name];
            }
        }());

        return animationEnd && { end: animationEnd };
    })();

    // Check touch device
    // ----------------------------------- 
    support.touch                 = (
        ('ontouchstart' in window && navigator.userAgent.toLowerCase().match(/mobile|tablet/)) ||
        ($window.DocumentTouch && document instanceof $window.DocumentTouch)  ||
        ($window.navigator['msPointerEnabled'] && $window.navigator['msMaxTouchPoints'] > 0) || //IE 10
        ($window.navigator['pointerEnabled'] && $window.navigator['maxTouchPoints'] > 0) || //IE >=11
        false
    );

    return support;
}]);
/**=========================================================
 * Module: ToggleStateService.js
 * Services to share toggle state functionality
 =========================================================*/

App.service('toggleStateService', ['$rootScope', function($rootScope) {
    'use strict';
    var storageKeyName  = 'toggleState';

    // Helper object to check for words in a phrase //
    var WordChecker = {
        hasWord: function (phrase, word) {
            return new RegExp('(^|\\s)' + word + '(\\s|$)').test(phrase);
        },
        addWord: function (phrase, word) {
            if (!this.hasWord(phrase, word)) {
                return (phrase + (phrase ? ' ' : '') + word);
            }
        },
        removeWord: function (phrase, word) {
            if (this.hasWord(phrase, word)) {
                return phrase.replace(new RegExp('(^|\\s)*' + word + '(\\s|$)*', 'g'), '');
            }
        }
    };

    // Return service public methods
    return {
        // Add a state to the browser storage to be restored later
        addState: function(classname){
            var data = $rootScope.$storage[storageKeyName];
      
            if(!data)  {
                data = classname;
            }
            else {
                data = WordChecker.addWord(data, classname);
            }

            $rootScope.$storage[storageKeyName] = data;
        },

        // Remove a state from the browser storage
        removeState: function(classname){
            var data = $rootScope.$storage[storageKeyName];
            // nothing to remove
            if(!data) return;

            data = WordChecker.removeWord(data, classname);

            $rootScope.$storage[storageKeyName] = data;
        },
    
        // Load the state string and restore the classlist
        restoreState: function($elem) {
            var data = $rootScope.$storage[storageKeyName];
      
            // nothing to restore
            if(!data) return;
            $elem.addClass(data);
        }

    };

}]);

/**=========================================================
 * Module: TouchDragService.js
 * Services to add touch drag to a dom element
 =========================================================*/

App.service('touchDrag', ['$document', 'browser', function ($document, browser) {
    'use strict';
    return {
        touchHandler: function (event) {
            var touch = event.changedTouches[0];

            var simulatedEvent = document.createEvent("MouseEvent");
            simulatedEvent.initMouseEvent({
                touchstart: "mousedown",
                touchmove: "mousemove",
                touchend: "mouseup"
            }[event.type], true, true, window, 1,
            touch.screenX, touch.screenY,
            touch.clientX, touch.clientY, false,
            false, false, false, 0, null);

            touch.target.dispatchEvent(simulatedEvent);
            event.preventDefault();
        },
        addTo: function (element) {
            element = element || $document;
            if (browser.mobile) {
                element.addEventListener("touchstart", this.touchHandler, true);
                element.addEventListener("touchmove", this.touchHandler, true);
                element.addEventListener("touchend", this.touchHandler, true);
                element.addEventListener("touchcancel", this.touchHandler, true);
            }
        }
    };
}]);