﻿var iSpy = {
    safe: function (v) {
        return v.replace(/\\/g, "\\\\").replace(/\"/g, "\\\"");
    },
    login: function() {
        $("#divLoginFailed").hide();
        $("#btnLogin").attr('disabled', 'disabled');
        $.ajax({
            type: "POST",
            url: "/webservices/UserAdmin.asmx/Login2",
            data: '{username: "' + iSpy.safe($("#txtLoginUsername").val()) + '",password: "' + iSpy.safe($("#txtLoginPassword").val()) + '" }',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: iSpy.loginResult,
            failure: iSpy.helper.webMethodFailed
        });
    },
    register: function(val) {
        $("#divRegisterFailed").hide();
        $("#btnRegister").attr('disabled', 'disabled');
        $.ajax({
            type: "POST",
            url: "/webservices/UserAdmin.asmx/Register",
            data: '{username: "' + iSpy.safe($("#txtRegisterUsername").val()) + '",password: "' + iSpy.safe($("#txtRegisterPassword").val()) + '",passwordConfirm: "' + iSpy.safe($("#txtRegisterPasswordConfirm").val()) + '",email: "' + iSpy.safe($("#txtRegisterEmail").val()) + '",phoneNumber: "' + iSpy.safe($("#txtRegisterPhoneNumber").val()) + '",countryCode: "' + $("#ddlRegisterCountryCode").val() + '",test: "' + val + '" }',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: iSpy.registerResult,
            failure: iSpy.helper.webMethodFailed
        });
    },
    update: function () {
        $("#divUpdateFailed").hide();
        $("#btnUpdate").attr('disabled', 'disabled');
        $.ajax({
            type: "POST",
            url: "/webservices/UserAdmin.asmx/Update",
            data: '{username: "' + iSpy.safe($("#txtUpdateUsername").val()) + '",password: "' + iSpy.safe($("#txtUpdatePassword").val()) + '",passwordConfirm: "' + iSpy.safe($("#txtUpdatePasswordConfirm").val()) + '",email: "' + iSpy.safe($("#txtUpdateEmail").val()) + '",phoneNumber: "' + iSpy.safe($("#txtUpdatePhoneNumber").val()) + '",timeZone: "' + iSpy.safe($("#txtUpdateTimeZone").val()) + '",enableReset:' + $("#chkEnableReset").is(':checked') + ',newsletter:' + $("#chkNewsletters").is(':checked') +',useSSL:'+$("#chkForceSSL").is(':checked')+'}',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: iSpy.updateResult,
            failure: iSpy.helper.webMethodFailed
        });
    },
    recover: function() {
        $("#divRecoverFailed").hide();
        $("#btnRecover").attr('disabled', 'disabled');
        $.ajax({
            type: "POST",
            url: "/webservices/UserAdmin.asmx/Recover",
            data: '{email: "' + iSpy.safe($("#txtRecoverEmail").val()) + '" }',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: iSpy.recoverResult,
            failure: iSpy.helper.webMethodFailed
        });
    },
    unlock: function() {
        $("#divUnlockFailed").hide();
        $("#btnUnlock").attr('disabled', 'disabled');
        $.ajax({
            type: "POST",
            url: "/webservices/UserAdmin.asmx/Unlock",
            data: '{password: "' + $("#txtUnlockPassword").val() + '" }',
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: iSpy.unlockResult,
            failure: iSpy.helper.webMethodFailed
        });
    },
    apiPermissions: {
        deletePermission: function (id) {
            $("#btnDeletePermission").attr('disabled', 'disabled');
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/DeleteApiPermission",
                data: "{id: " + id + " }",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: iSpy.reloadResult,
                failure: iSpy.helper.webMethodFailed
            });
        },
        addPermission: function (id) {
            $("#btnAddPermission").attr('disabled', 'disabled');
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/AddApiPermission",
                data: "{id: " + id + " }",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: iSpy.reloadResult,
                failure: iSpy.helper.webMethodFailed
            });
        }

    },
    oauth: {
        allow: function () {
            $("#btnAllow").attr('disabled', 'disabled');
            var o = window.oauthConfig;
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/AllowOAuth",
                data: '{client: "' + o.client +'", redirectUri: "' + o.redirectUri + '", state: "' + o.state + '" }',
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function(r) {
                    location.href = r.d;
                },
                failure: iSpy.helper.webMethodFailed
            });
        },
        deny: function () {
            var o = window.oauthConfig;
            location.href = o.redirectUri + "?error=access_denied";
        }
    },
    translate:function(txt) {
        var t = angular.element(document.body).injector().get('$translate');
        return t.instant(txt);            
    },
    //RESULT METHODS
    reloadResult: function() {
        location.reload(true);
    },
    unlockResult: function(response) {
        if (response.d === "OK") {
            $("#divUnlockFailed").hide();
            location.href = "/monitor";
        } else {
            $("#btnUnlock").removeAttr('disabled');
            $("#divUnlockFailed").html(iSpy.translate(response.d));
            $("#divUnlockFailed").show();
        }
    },
    loginResult: function(response) {
        if (response.d === "OK") {
            $("#divLoginFailed").hide();
            if ($("#chkLoginRemember").is(":checked")) {
                iSpy.helper.createCookie("un", $("#txtLoginUsername").val(), 30);
                iSpy.helper.createCookie("pwd", $("#txtLoginPassword").val(), 30);
            } else
                iSpy.helper.eraseCookie("pwd");
            location.reload(true);
        } else {
            $("#btnLogin").removeAttr('disabled');
            $("#divLoginFailed").show();
            if (response.d !== "NOK") {
                $("#divLoginFailed").html(iSpy.translate(response.d));
            }

        }
    },
    registerResult: function(response) {
        if (response.d === "OK") {
            $("#divRegisterFailed").hide();
            iSpy.helper.createCookie("un", $("#txtRegisterUsername").val(), 30);
            if ($("#chkLoginRemember").is(":checked")) {
                iSpy.helper.createCookie("pwd", $("#txtRegisterPassword").val(), 30);
            } else
                iSpy.helper.eraseCookie("pwd");
            location.reload(true);
        } else {
            $("#btnRegister").removeAttr('disabled');
            $("#divRegisterFailed").show();
            $("#divRegisterFailed").html(iSpy.translate(response.d));
        }
    },
    updateResult: function (response) {
        if (response.d === "OK") {
            $("#divUpdateFailed").hide();
            iSpy.helper.createCookie("un", $("#txtUpdateUsername").val(), 30);
            location.href = "/monitor";
        } else {
            $("#btnUpdate").removeAttr("disabled");
            $("#divUpdateFailed").show();
            $("#divUpdateFailed").html(iSpy.translate(response.d));
        }
    },
    recoverResult: function(response) {
        $("#btnRecover").removeAttr('disabled');
        if (response.d === "OK") {
            $("#divRecoverFailed").hide();
            $("#divRecoverSuccess").show();
        } else {
            $("#divRecoverFailed").show();
            $("#divRecoverFailed").html(iSpy.translate(response.d));
        }
    },
    helper: {
        createCookie: function(name, value, days) {
            var expires = "";
            if (days) {
                var date = new Date();
                date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
                expires = "; expires=" + date.toGMTString();
            }
            document.cookie = name + "=" + value + expires + "; path=/";
        },
        readCookie: function(name) {
            var nameEq = name + "=";
            var ca = document.cookie.split(";");
            for (var i = 0; i < ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) === " ") c = c.substring(1, c.length);
                if (c.indexOf(nameEq) === 0) return c.substring(nameEq.length, c.length);
            }
            return null;
        },
        eraseCookie: function(name) {
            iSpy.helper.createCookie(name, "", -1);
        },
        webMethodFailed: function(response) {
            alert(response.d);
        }
    }
}