﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="account.aspx.cs" Inherits="iSpyConnect.monitor.app.pages.account" %>
<div class="center-block mt-xl wd-xl">
   <!-- START panel-->
   <div class="panel panel-inverse">
      <div class="panel-heading text-center">
         <img src="app/img/logo-single.png" alt="Image" class="center-block img-rounded" />
      </div>
      <div class="panel-body">
         <p class="text-center pv text-bold">
             <div class="pull-right" data-ng-controller="LanguageController">
                 <div dropdown="dropdown" is-open="language.listIsOpen" class="btn-group btn-group-sm">
                     <div dropdown-toggle>{{language.selected}}
                         <span class="caret"></span>
                     </div>
                     <ul role="menu" class="dropdown-menu dropdown-menu-right animated fadeInLeft2">
                         <li data-ng-repeat="(localeId, langName) in language.available"><a data-ng-click="language.set(localeId, $event)">{{langName}}</a>
                         </li>
                     </ul>
                 </div>
             </div>

             {{ 't.ACCOUNT.UpdateDetails' | translate }}
         </p>
          <form role="form" class="mb-lg">
            <div class="form-group has-feedback">
               <input id="txtUpdateUsername" type="text" placeholder="{{ 't.ACCOUNT.YourUsername' | translate }}" autocomplete="off" class="form-control" value="<%=U.Username %>"/>
               <span class="fa fa-user form-control-feedback text-muted"></span>
            </div>
            <div class="form-group has-feedback">
               <input id="txtUpdateEmail" type="email" placeholder="{{ 't.ACCOUNT.YourEmail' | translate }}" autocomplete="off" class="form-control" value="<%=U.EmailAddress %>"/>
               <span class="fa fa-envelope form-control-feedback text-muted"></span>
            </div>
            <div class="form-group has-feedback">
               <input id="txtUpdatePassword" type="password" placeholder="{{ 't.ACCOUNT.YourPassword' | translate }}" autocomplete="off" class="form-control" value="NOTCHANGED"/>
               <span class="fa fa-lock form-control-feedback text-muted"></span>
            </div>
            <div class="form-group has-feedback">
               <input id="txtUpdatePasswordConfirm" type="password" placeholder="{{ 't.ACCOUNT.ConfirmPassword' | translate }}" autocomplete="off" class="form-control" value="NOTCHANGED" />
               <span class="fa fa-lock form-control-feedback text-muted"></span>
            </div>
            <div class="checkbox c-checkbox mt0">
               <label>
                  <input type="checkbox" value="" id="chkEnableReset" <%=(U.EnableReset!=null && Convert.ToBoolean(U.EnableReset))?"checked=\"checked\"":"" %> />
                  <span class="fa fa-check"></span>{{ 't.ACCOUNT.EnableReset' | translate }}</label>
            </div>
            <div class="checkbox c-checkbox mt0">
               <label>
                  <input type="checkbox" value="" id="chkForceSSL" <%=(U.UseSSL!=null && Convert.ToBoolean(U.UseSSL))?"checked=\"checked\"":"" %> />
                  <span class="fa fa-check"></span>{{ 't.ACCOUNT.ForceSSL' | translate }}</label>
            </div>
            <div class="form-group has-feedback">
               <input id="txtUpdatePhoneNumber" type="text" placeholder="{{ 't.ACCOUNT.Mobile' | translate }}" autocomplete="off" class="form-control" value="<%=U.MobileNumber %>"/>
               <span class="fa fa-phone form-control-feedback text-muted"></span>
                <span class="help-block m-b-none">{{ 't.ACCOUNT.IncludeCodes' | translate }} - <a href="/countrycodes.aspx" target="_blank">{{ 't.ACCOUNT.CountryCodes' | translate }}</a></span>
            </div>
            <div class="form-group has-feedback">
               <input id="txtUpdateTimeZone" type="text" placeholder="{{ 't.ACCOUNT.TimeZone' | translate }}" autocomplete="off" class="form-control" value="<%=U.TimeZone %>"/>
               <span class="fa fa-clock-o form-control-feedback text-muted"></span>
                <span class="help-block m-b-none">{{ 't.ACCOUNT.HoursOffset' | translate }}</span>
            </div>
              <div class="checkbox c-checkbox mt0">
               <label>
                  <input type="checkbox" value="" id="chkNewsletters" <%=U.Newsletter?"checked=\"checked\"":"" %> />
                  <span class="fa fa-check"></span>{{ 't.ACCOUNT.OptIn' | translate }}</label>
            </div>
              <div style="margin-top:5px;clear:both;">
                 <div class="alert alert-danger" style="display:none" id="divUpdateFailed">{{ 't.ACCOUNT.UpdateFailed' | translate }}</div>
             </div>
             <button class="btn btn-block btn-primary mt-lg" onclick="iSpy.update()" id="btnUpdate">{{ 't.Update' | translate }}</button>
             
          </form>
      </div>
   </div>
   <div class="text-center mt"><a href="/monitor/#" class="text-muted">{{ 't.Back' | translate }}</a>
   </div>
   <!-- END panel-->
   <div data-ng-include="'app/pages/page-footer.html'" class="p-lg text-center"></div>
</div>
