﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="login.aspx.cs" Inherits="iSpyConnect.monitor.app.pages.login" %>
<div class="center-block mt-xl wd-xl">
   <!-- START panel-->
   <div class="panel panel-inverse">
      <div class="panel-heading text-center">
         <a href="/" target="_self"><img src="app/img/logo-single.png" alt="Image" class="center-block img-rounded" /></a>
      </div>
      <div class="panel-body">
         <p class="text-center pv text-bold">
             <div class="pull-right" data-ng-controller="LanguageController">
                 <div dropdown="dropdown" is-open="language.listIsOpen" class="btn-group btn-group-sm">
                     <div dropdown-toggle>{{language.selected}}
                         <span class="caret"></span>
                     </div>
                     <ul role="menu" class="dropdown-menu dropdown-menu-right animated fadeInLeft2">
                         <li data-ng-repeat="(localeId, langName) in language.available"><a data-ng-click="language.set(localeId, $event)">{{langName}}</a>
                         </li>
                     </ul>
                 </div>
             </div>

             {{ 't.LOGIN.Title' | translate }}
             
         </p>
         <form role="form" class="mb-lg">
            <div class="form-group has-feedback">
               <input id="txtLoginUsername" type="text" placeholder="{{ 't.LOGIN.Username' | translate }}" autocomplete="off" autocorrect="off" autocapitalize="off" class="form-control" value="<%=Username %>" />
               <span class="fa fa-user form-control-feedback text-muted"></span>
            </div>
            <div class="form-group has-feedback">
               <input id="txtLoginPassword" type="password" placeholder="{{ 't.LOGIN.Password' | translate }}" class="form-control" autocorrect="off" autocapitalize="off" />
               <span class="fa fa-lock form-control-feedback text-muted"></span>
            </div>
            <div class="checkbox c-checkbox pull-left mt0">
               <label>
                  <input type="checkbox" value="" id="chkLoginRemember" />
                  <span class="fa fa-check"></span>{{ 't.LOGIN.Remember' | translate }}</label>
            </div>
             <div style="margin-top:5px;clear:both">
                 <div class="alert alert-danger" style="display:none" id="divLoginFailed">{{ 't.LOGIN.LoginFailed' | translate }}</div>
             </div>
            <button class="btn btn-block btn-info mt-lg" onclick="iSpy.login()" id="btnLogin">{{ 't.LOGIN.Login' | translate }}</button>
         </form>
         <p class="text-center text-muted">{{ 't.LOGIN.Or' | translate }}</p>
          
         <a ui-sref="page.register" class="btn btn-block btn-default">
            <strong>{{ 't.LOGIN.RegisterAccount' | translate }}</strong>
         </a>
      </div>
   </div>
   <div class="text-center mt"><a ui-sref="page.recover" class="text-muted">{{ 't.LOGIN.ForgotPassword' | translate }}</a>
   </div>
   <!-- END panel-->
   <div data-ng-include="'app/pages/page-footer.html'" class="p-lg text-center"></div>
</div>