var iSpy = {
    loaded: false,
    config: null,
    RTC: false,
    intervals: {},
    currentScope: null,
    currentServer: null,
    timeline1: null,
    themeColor: "#ccc",
    Message: "",
    files1: null,
    newObject: false,
    videoPlayer: null,
    audioPlayer: null,
    currentPlayer: null,
    touchClickDelay: 300,
    touchClickRadius: 20,
    connectionErrors: [],
    initialised: false,
    defaultCredits: 10,
    timelineOptions: {
        preventFuture: false,
        maxScale: "seconds",
        minScale: "years",
        font: "verdana",
        fontsize: 11,
        verticalSpacing: 4,
        rulerLines: true,
        thumbWidth: 95,
        thumbHeight: 72,
        lineStyle: "#ccc",
        textStyle: "#333",
        startDate: null,
        endDate: null,
        minEventWidth: 25,
        accuracy: 3, //1=best, 2..3...4.. faster
        colWidth: 95,
        frictionCoefficient: 0.96,
        includeSections: true,
        sectionColor: "#363C47",
        sectionTextColor: "#fff",
        fitToWindow: false,
        fitToContainer: true,
        hideNoEvents: false,
        onHeaderClicked: function (ob, e) {
            iSpy.live.media.Open(ob.obj, e);
        },
        onEventClicked: function (ob) { iSpy.tools.loadMedia(ob.obj); }
    },
    MaxFileOperations: 150,
    Log: [],
    MaxLogLength: 20,
    LogScope: null,
    graph: null,
    liveViewers: [],
    renderObjects: [],
    minFlash: "10.1.102.64",
    browser: null,
    oldAPI: false,
    storage: null,
    flashSupported: false,
    timeFormat: "MMM dd yyyy hh:mm:ss t",
    timeFormatSmall: "MMM dd HH:mm:ss",
    serverCommsTimeout: 15000,
    downloadLinks: [],
    deviceAdded: null,
    lastDownTarget: null,
    ObjectLoaded: false,
    MinScrollBarHeight: 50,
    ScrollBarWidth: 30,
    ScrollBarStyle: "rgba(51,51,51,0.8)",
    wizard: { make: "", model: "", username: "", password: "", channel: 0, url: "http://", ports: "80,8080", results: [], connections: [] },
    searchOptions: {
        fromDate: null,
        toDate: null,
        doSearch: false,
        tempFromDate: null,
        tempToDate: null
    },
    initialise: function (rootScope, browser, localStorage) {

        iSpy.rootScope = rootScope;
        iSpy.browser = browser;
        iSpy.storage = localStorage;
        iSpy.flashSupported = false;
        iSpy.timelineOptions.endDate = (new Date()).addHours(24);
        iSpy.timelineOptions.startDate = (new Date()).addHours(0 - (24 * 7));

        $(document.body).on("mousedown touchstart", function (event) {
            iSpy.lastDownTarget = event.target;
        });



        function init() {
            if (iSpy.config.subscribed) {
                iSpy.config.subscriptionDate = new Date(iSpy.config.subscriptionDate);
                iSpy.config.subscriptionDateString = iSpy.config.subscriptionDate.toDateString();
            } else {
                iSpy.config.subscriptionDateString = "N/A";
            }
            if (iSpy.config.locked) {
                location.href = "lock.aspx#/page/lock";
            }

            iSpy.overlay = $("#overlay");
            iSpy.overlay.on("click", iSpy.helper.hideOverlay);

            $("#jp_wrapper").on("click",
                function (e) {
                    if (typeof e.stopPropagation != "undefined") {
                        e.stopPropagation();
                    } else {
                        e.cancelBubble = true;
                    }
                }
            );
            $("#jp_wrapper").hide();
            $("#snapshotImg").hide();
            iSpy.thumb = $("<div />").appendTo("body");

            iSpy.rootScope.user.name = iSpy.config.accountDetails.username;
            iSpy.rootScope.user.job = iSpy.config.accountType;

            if (!iSpy.flashSupported) {
                iSpy.LogScope.addLog("Flash", "Player v" + iSpy.minFlash + " min. not found. Using HTML5 instead.", false);
            }
            var i, p;
            if (iSpy.config.connectedServers.length > 0) {
                //setup parent relationships to servers/objects
                for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                    p = iSpy.config.connectedServers[i];
                    p.eventList = [];
                    p.include = true;
                    p.selected = false;
                    p.url = iSpy.helper.serverAddress(p);
                    p.isAccess = false;
                    p.Permission = null;
                    p.type = "Server";

                    if (p.iSpyAccessID > -1) {
                        for (var k = 0; k < iSpy.config.accessServers.length; k++) {
                            var op = iSpy.config.accessServers[k];
                            if (op.id === p.iSpyAccessID) {
                                p.Permissions = op;
                            }
                        }
                        p.isAccess = true;

                    }
                    p.objectCount = 0;
                    p.versionNumeric = parseInt(p.version.replace(/\./g, ""));
                    p.gotObjectList = false;

                    if (!p.hasExtendedAPI) {
                        iSpy.oldAPI = true;
                        p.include = false;
                        iSpy.LogScope.addLog(p.name, p.name + " is using the old API. See the account / summary page for more information", true);
                    } else {
                        if (p.isBlocked) {
                            p.include = false;
                            var t = p.name + ": " + iSpy.helper.translate("t.UnavailableRemotely");
                            iSpy.LogScope.addLog(p.name, t, true);
                            iSpy.config.warning += t;
                        } else {
                            iSpy.api.command(p, "loadAPI", iSpy.api.attachAPI, iSpy.api.loadAPIFailed);
                            iSpy.helper.initServerObjectList(p);
                        }

                    }
                }
                iSpy.helper.eventManager.loadEvents();
            }

            var mnu = iSpy.helper.findID(iSpy.rootScope.menuItems, "id", "mnuServers");
            for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                p = iSpy.config.connectedServers[i];
                if (p.include)
                    mnu[0].subnav.push({ "text": p.name, "sref": "server({index:" + i + "})", "translate": "" });
            }

            iSpy.helper.images.loadImages();
            iSpy.intervals.PTZPoller = window.setInterval(iSpy.helper.pollPTZ, 200);

            iSpy.initialised = true;
        }

        $.ajax({
            type: "GET",
            url: "/monitor/app/js/config.aspx",
            dataType: "json"
        }).done(
            function (response) {
                iSpy.config = response.configuration;
                var chkReadyState = setInterval(function () {
                    if (document.readyState === "complete") {
                        if (iSpy.rootScope && iSpy.rootScope.menuItems) {
                            var mnu = iSpy.helper.findID(iSpy.rootScope.menuItems, "id", "mnuServers");
                            if (mnu && mnu.length > 0) {
                                if (mnu[0].subnav) {
                                    // loaded the menu, time to kick ass and chew bubblegum
                                    clearInterval(chkReadyState);
                                    init();
                                }
                            }
                        }


                    }
                }, 100);
            }).error(function () {
                alert("Sorry there was an error loading the configuration data. Please open /monitor/app/js/config.aspx and send the code displayed to sean@ispyconnect.com.");
            });

        var oneWeekAgo = new Date();
        oneWeekAgo.setDate(oneWeekAgo.getDate() - 7);
        iSpy.searchOptions.fromDate = oneWeekAgo;
        iSpy.searchOptions.toDate = iSpy.searchOptions.tempToDate = (new Date()).addHours(24);
        iSpy.graph = $("#cnvGraph");

    },
    clearBoundEvents: function () {
        if (iSpy.timeline1 != null) {
            iSpy.timeline1.deinit();
            delete iSpy.timeline1;
        }
        if (iSpy.files1 != null) {
            iSpy.files1.deinit();
            delete iSpy.files1;
        }
        if (iSpy.snapshots1 != null) {
            iSpy.snapshots1.deinit();
            delete iSpy.snapshots1;
        }
        if (iSpy.videowall1 != null) {
            iSpy.videowall1.deinit();
            delete iSpy.videowall1;
        }
        if (iSpy.livestills1 != null) {
            iSpy.livestills1.deinit();
            delete iSpy.livestills1;
        }
        iSpy.helper.hideThumb();
    },
    render: {
        onchange: function (itm) {
            var cmd = itm.command;
            if (cmd) {
                var id = $(event.srcElement).val();

                if (cmd === "editaction") {
                    var d = iSpy.currentRenderObject.data;
                    var a = iSpy.helper.findID(d, "id", "chkActive")[0].value;
                    var m = iSpy.helper.findID(d, "id", "ddlMode")[0].value;
                    cmd += "&active=" + a + "&mode=" + m + "&ident=" + d.ident;
                }
                cmd += "&id=" + encodeURIComponent(id);
                var o;
                iSpy.api.command(iSpy.currentRenderObject.obj, cmd, function (obj, data) {
                    switch (data.task) {
                        case "filllist":
                            o = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", data.target)[0];
                            o.options = data.list;
                            if (o.options.length === 0)
                                o.options = [{ "value": "", "text": "None" }];
                            break;
                        case "bindActionView":
                        case "rendersourceeditor":
                            iSpy.currentRenderObject.data.sections[0].items = data.sections[0].items;
                            break;
                    }
                    if (data.target === "ptzhomecommand") {
                        o = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", "txtPTZURL");
                        o[0].value = data.url;
                    }
                    iSpy.rootScope.$apply();
                });
            }
            iSpy.api.liveUpdate(itm);
        },
        LevelRenderer: function (canvas) {
            var framePending;
            var domElement = canvas;
            var width = domElement.width;
            var height = domElement.height;
            var context = domElement.getContext("2d");
            context.translate(0.5, 0.5);
            var level = 0;
            var obj = null;
            var loading = false;

            var sens = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", "arrSensitivity")[0];
            var gain = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", "numGain")[0];

            function render() {
                context.canvas.width = width;
                context.canvas.height = height;
                context.clearRect(-1, -1, context.canvas.width + 2, context.canvas.height + 2);

                var min = sens.value[0];
                var max = sens.value[1];

                var mintrigger = width * (min / 100);
                var maxTrigger = width * (max / 100);

                context.fillStyle = "rgba(255,255,255,0.7)";
                context.fillRect(0, 0, width, height);

                var mx = Math.min(width, width * (gain.value * level));
                if (mx < mintrigger || mx > maxTrigger)
                    context.fillStyle = "rgba(67,168,235,0.8)";
                else
                    context.fillStyle = "rgba(233,69,94,0.8)";

                context.fillRect(0, 5, mx, height - 10);
                context.stroke();

                context.beginPath();
                context.strokeStyle = "rgba(0,0,255,1)";

                context.moveTo(mintrigger, 0);
                context.lineTo(mintrigger, height);

                context.moveTo(maxTrigger, 0);
                context.lineTo(maxTrigger, height);
                context.closePath();
                context.stroke();



                framePending = false;
            };

            function loadLevel() {
                if (loading)
                    return;
                loading = true;
                iSpy.api.command(obj, "querylevel", function (obj2, data) {
                    level = data.level;
                    loading = false;
                    render();
                }, function () { loading = false; });

            }

            function init() {
                obj = iSpy.currentRenderObject.obj;
                iSpy.intervals.volumeInterval = window.setInterval(loadLevel, 100);
                render();
            }

            this.deinit = function () {
                window.clearInterval(iSpy.intervals.volumeInterval);

            };


            init();
        },
        ZoneRenderer: function (canvas, options, data) {
            var that = this;
            var framePending = false;
            var domElement = canvas;
            var width = domElement.width;
            var height = domElement.height;
            var context = domElement.getContext("2d");
            context.translate(0.5, 0.5);
            var mxy = { x: 0, y: 0 };
            var oxy = null;
            var isResize = false;
            var m = false;
            var currentZone = null;
            var hitTargets = [];
            var imgSource = null;
            var obj;
            var interval = null;
            var imageloading = false;
            var level = 0;
            var czs = { x: 0, y: 0 };



            var dAttr = canvas.attributes["data"].value.replace(/'/g, "\"");
            if (dAttr !== "") {
                data = JSON.parse(dAttr);
            }

            var sens, gain;



            function drawGrab(z, x, y) {
                context.beginPath();
                context.moveTo(x - 20, y - 5);
                context.lineTo(x - 5, y - 5);
                context.lineTo(x - 5, y - 20);
                context.closePath();
                context.stroke();
            }

            function drawZone(z, col) {
                context.fillStyle = col;
                var x = (z.x / 100) * width;
                var y = (z.y / 100) * height;
                var w = (z.w / 100) * width;
                var h = (z.h / 100) * height;

                context.fillRect(x, y, w, h);
                context.beginPath();
                context.rect(x, y, w, h);
                context.closePath();
                context.stroke();

                hitTargets.push(new iSpy.helper.HitTarget(x, y, x + w, h + y, z));

                if (options.isPiP) {
                    var cl = iSpy.currentRenderObject.obj.parent.objectList;
                    for (var i = 0; i < cl.length; i++) {
                        if (cl[i].id === z.id && cl[i].typeID === 2) {
                            context.fillStyle = "#fff";
                            context.fillText(cl[i].name, x + 2, y + 10);
                            break;
                        }
                    }
                }

                if (z === currentZone) {
                    drawGrab(z, x + w, y + h);
                }
            }

            function render() {
                context.canvas.width = width;
                context.canvas.height = height;
                context.clearRect(-1, -1, context.canvas.width + 2, context.canvas.height + 2);
                var col;
                hitTargets = [];

                if (imgSource != null) {
                    context.drawImage(imgSource, 0, 0, width, height);
                }
                context.strokeStyle = "rgba(0,0,0,1)";
                for (var i = 0; i < data.length; i++) {
                    var z = data[i];
                    if (z !== currentZone)
                        drawZone(z, "rgba(255,255,255,0.5)");
                }
                if (currentZone != null) {
                    col = "rgba(67,168,235,0.8)";
                    if (m && !isResize && (mxy.x < 0 || mxy.x > width || mxy.y < 0 || mxy.y > height))
                        col = "rgba(233,69,94,0.8)";
                    drawZone(currentZone, col);
                }

                if (options.isMotion) {
                    //draw overlay motion markers
                    var min = sens.value[0];
                    var max = sens.value[1];

                    context.fillStyle = "rgba(255,255,255,0.7)";
                    context.fillRect(0, height - 20, width, 20);
                    //draw motion

                    context.beginPath();
                    context.strokeStyle = "rgba(0,0,255,1)";
                    var mintrigger = width * (min / 100);
                    var maxTrigger = width * (max / 100);
                    context.moveTo(mintrigger, height - 20);
                    context.lineTo(mintrigger, height);

                    context.moveTo(maxTrigger, height - 20);
                    context.lineTo(maxTrigger, height);
                    context.closePath();
                    context.stroke();

                    var mx = Math.min(width, width * (gain.value * level));
                    if (mx < mintrigger || mx > maxTrigger)
                        context.fillStyle = "rgba(67,168,235,0.8)";
                    else
                        context.fillStyle = "rgba(233,69,94,0.8)";
                    context.fillRect(0, height - 15, mx, 10);
                    context.stroke();
                }

                framePending = false;
            };





            function mousemove(e) {
                mxy = iSpy.helper.mouseXY(domElement, e);

                iSpy.helper.setCursor(e, "pointer");
                if (m) {
                    if (currentZone != null) {
                        var d;
                        if (isResize) {
                            currentZone.w = Math.max(5, (mxy.x / width) * 100 - currentZone.x);
                            currentZone.h = Math.max(5, (mxy.y / height) * 100 - currentZone.y);
                            d = currentZone.x + currentZone.w;
                            if (d > 100) {
                                currentZone.w -= (d - 100);
                            }
                            d = currentZone.y + currentZone.h;
                            if (d > 100) {
                                currentZone.h -= (d - 100);
                            }
                            iSpy.helper.setCursor(e, "nwse-resize");
                        } else {
                            currentZone.x = Math.min(100, Math.max(0, czs.x - ((oxy.x - mxy.x) / width) * 100));
                            currentZone.y = Math.min(100, Math.max(0, czs.y - ((oxy.y - mxy.y) / height) * 100));
                            d = currentZone.x + currentZone.w;
                            if (d > 100) {
                                currentZone.x -= (d - 100);
                            }
                            d = currentZone.y + currentZone.h;
                            if (d > 100) {
                                currentZone.y -= (d - 100);
                            }
                        }
                    }
                }
                that.refresh();
            };



            function mousedown(e) {
                m = false;
                if (e.target !== domElement)
                    return;

                e.preventDefault();
                oxy = iSpy.helper.mouseXY(domElement, e);
                m = true;
                var n = true;
                var i;
                for (i = hitTargets.length - 1; i >= 0; i--) {
                    var o = hitTargets[i];
                    if (oxy.x > o.X && oxy.y > o.Y && oxy.x < o.X2 && oxy.y < o.Y2) {
                        currentZone = o.obj;
                        var d = iSpy.helper.calcDist(oxy, { x: o.X2, y: o.Y2 });
                        isResize = d < 15;
                        czs = { x: currentZone.x, y: currentZone.y };
                        n = false;
                        break;
                    }
                }

                if (n) {
                    var x = Math.min(96, (oxy.x / width) * 100);
                    var y = Math.min(96, (oxy.y / height) * 100);
                    var z = { x: x, y: y, w: 5, h: 5 };
                    if (options.isPiP) {
                        z.id = parseInt($("#PiPDeviceList").val());
                        for (i = 0; i < data.length; i++) {
                            if (data[i].id === z.id) {
                                data.splice(i, 1);
                                break;
                            }
                        }


                    }
                    currentZone = z;
                    if (!options.multiZone) {
                        data = [];
                    }
                    data.push(z);
                    isResize = true;
                    that.refresh();

                }

            }
            function mouseup(e) {
                mxy = iSpy.helper.mouseXY(domElement, e);
                if (m) {
                    if (currentZone != null) {
                        if (!isResize) {
                            if (mxy.x < 0 || mxy.y < 0 || mxy.x > width || mxy.y > height) {
                                data.splice(data.indexOf(currentZone), 1);
                                currentZone = null;
                            }
                        }
                    }

                    var url = obj.parent.url + "saveobject.json?auth=" + obj.parent.auth + "&lc=" + iSpy.helper.languageCode();
                    url += "&ot=" + obj.typeID + "&oid=" + obj.id;

                    var otemp = { "name": options.name, "zones": data };
                    var jso = JSON.stringify(otemp);
                    $.ajax({
                        type: "POST",
                        url: url,
                        data: jso,
                        contentType: "application/json; charset=utf-8",
                        dataType: "json",
                        success: null,
                        failure: iSpy.helper.webMethodFailed
                    });
                }
                oxy = null;
                czs = null;
                m = false;
                isResize = false;

                render();
            }

            function loadFrame() {
                if (!imageloading) {
                    if (!$(domElement).is(":visible")) {
                        return;
                    }
                    var imgFeed = new Image(width, height);
                    imgFeed.src = iSpy.helper.unique(options.url);
                    imageloading = true;
                    $(imgFeed).on('load', function (e) {
                        if (interval == null)
                            return;
                        imgSource = e.target;
                        imageloading = false;
                    });
                    $(imgFeed).on('error', function () {
                        if (interval == null)
                            return;
                        imageloading = false;
                    });

                    if (options.isMotion) {
                        iSpy.api.command(obj, "querylevel", function (obj2, data2) {
                            level = data2.level;
                        });
                    }
                }
                render();
            }

            function init() {
                if (options.isMotion) {
                    sens = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", "arrSensitivity")[0];
                    gain = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", "numGain")[0];
                }
                obj = iSpy.currentRenderObject.obj;

                interval = window.setInterval(loadFrame, 100);
                loadFrame();
                render();
            }



            $(document.body).on("mousemove touchmove", mousemove);
            $(document.body).on("mouseup touchend touchcancel", mouseup);
            $(domElement).on("mousedown touchstart", mousedown);

            this.refresh = function () {
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.deinit = function () {
                $(document.body).off("mousemove touchmove", mousemove);
                $(document.body).off("mouseup touchend touchcancel", mouseup);
                window.clearInterval(interval);
            };

            init();
        }
    },
    account: {
        signOut: function () {
            location.href = "/default.aspx?logout=y";
        },
        deleteAccount: function () {
            $("#btnDeleteAccount").attr("disabled", "disabled");
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/DeleteAccount",
                data: "",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (response) {
                    if (response.d === "OK") {
                        iSpy.account.signOut();
                    } else {
                        $("#btnDeleteAccount").removeAttr("disabled");
                        iSpy.helper.msg("s.Error", response.d, "error");
                    }
                },
                failure: iSpy.helper.webMethodFailed
            });
        },
        saveServerSettings: function (osrv) {
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/SaveServerSettings",
                data: "{auth: \"" + osrv.auth + '",overrideURL:"' + osrv.overrideURL + "\",useLAN:" + osrv.useLANIP + ",notify:" + osrv.notify + "}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (response) {
                    if (response.d === "OK") {
                        iSpy.rootScope.pop("success", "s.SettingsSaved", "s.SettingsUpdated");
                    } else {
                        iSpy.rootScope.pop("error", "s.Error", response.d);
                    }
                    iSpy.rootScope.$apply();
                },
                failure: iSpy.helper.webMethodFailed
            });
        },
        claimGift: function () {
            $("#btnClaim").attr("disabled", "disabled");
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/ClaimGift",
                data: "{code: \"" + $("#txtGiftCode").val() + "\"}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (response) {
                    $("#btnClaim").removeAttr("disabled");
                    if (response.d === "OK") {
                        iSpy.helper.reload();
                    } else {
                        $("#txtGiftCode").parent().addClass("has-error");
                        iSpy.helper.msg("s.Error", response.d, "error");
                    }
                },
                failure: iSpy.helper.webMethodFailed
            });
        },
        filterAccess: function (server) {
            return server.iSpyAccessID === -1;
        }
    },
    permissions: {
        save: function () {
            var perms = "";
            for (var i = 0; i < iSpy.config.accessPermissions.length; i++) {
                var o = iSpy.config.accessPermissions[i];
                perms += o.id + "|" + o.email + "|" + o.readOnly + "|" + o.ptz + "|" + o.accessMask + "|false\n";
            }
            $("#btnSavePermissions").attr("disabled", "disabled");
            $.ajax({
                type: "POST",
                url: "/webservices/UserAdmin.asmx/SavePermissions",
                data: "{permissions: \"" + perms + "\"}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (response) {
                    $("#btnSavePermissions").removeAttr("disabled");
                    if (response.d === "OK") {
                        iSpy.helper.msg("s.Success", "s.PermissionsUpdated", "success");
                        iSpy.permissions.reloadPermissions();
                    } else {
                        iSpy.helper.msg("s.Error", response.d, "error");
                    }
                },
                failure: iSpy.helper.webMethodFailed
            });
        },
        deletePerm: function (perm) {
            iSpy.config.accessPermissions = iSpy.config.accessPermissions.filter(function (j) { return j !== perm; });
        },
        showPermissionLink: function (perm) {
            iSpy.Message = "The link to accept this request is:<br/><br/><b>"+iSpy.config.URL +"/accept_invite.aspx?ident=" + perm.ident + "</b><br/><br/>We've sent an email to <a href=\"mailto:" + perm.email + "\">" + perm.email + "</a> with instructions. If they don't receive this email then send them this link manually to give them access.";
            iSpy.currentScope.open("lg", "partials/ispy_generic.html", null, null, null);
        },
        addPerm: function () {
            iSpy.config.accessPermissions.push({ "id": -1, "email": "", "readOnly": false, "ptz": true, "accessMask": "" });
            iSpy.rootScope.$apply();
        },
        reloadPermissions: function () {
            $.ajax({
                type: "GET",
                url: "/monitor/app/js/config.aspx?subset=accessPermissions",
                dataType: "json",
                success: function (response) {
                    iSpy.config.accessPermissions = response;
                    iSpy.rootScope.$apply();
                },
                failure: iSpy.helper.webMethodFailed
            });
        }
    },
    live: {
        getFlashObject: function (id) {
            for (var i = 0; i < iSpy.liveViewers.length; i++) {
                if (iSpy.liveViewers[i].options.divID === id) {
                    return iSpy.liveViewers[i];
                }
            }
            return null;
        },
        removeFlashObject: function (id) {
            for (var i = 0; i < iSpy.liveViewers.length; i++) {
                if (iSpy.liveViewers[i].options.divID === id) {
                    iSpy.liveViewers[i] = null;
                    iSpy.liveViewers.splice(i, 1);
                    break;
                }
            }
        },
        controls: {
            snapshotResult: function (obj, data) {
                if (data.status === "ok") {
                    iSpy.rootScope.pop("success", "s.FileSaved", "s.SnapshotSaved");
                } else
                    iSpy.rootScope.pop("error", "s.SaveFailed", data.status);
                iSpy.rootScope.$apply();

            },
            showhide: function (options) {
                var fc = $("#" + options.divID);
                var r = $("#reveal_" + options.divID);
                if (options.controlBar) {
                    r.removeClass("fa-chevron-up").addClass("fa-chevron-down");
                    fc.animate({ height: options.height + options.dragBarHeight + 20 }, 500);
                } else {
                    r.removeClass("fa-chevron-down").addClass("fa-chevron-up");
                    fc.animate({ height: options.height + options.dragBarHeight + options.expandHeight }, 500);
                }

                options.controlBar = !options.controlBar;
            },
            buildControlBar: function (options) {

                function buildButton(txt, icon, divid, cmd) {
                    var btnb = $("<a role=\"button\" class=\"btn btn-inverse btn-sm fa fa-" + icon + "\" title=\"" + txt + "\"></a>");
                    jQuery.data(btnb[0], "cfg", { divID: divid, command: cmd });
                    btnb.on("mouseup", function (e) {
                        var cfg = jQuery.data(this, "cfg");
                        iSpy.live.controls.command(cfg.divID, cfg.command);
                        e.cancelBubble = true;
                        //do not stopPropagation!
                    });
                    return btnb;
                }

                var container = $("#controlbar_" + options.divID);
                container.html("");

                if (options.obj.active) {
                    if (options.states.playing)
                        container.append(buildButton("stop", "stop", options.divID, "stop"));
                    else
                        container.append(buildButton("play", "play", options.divID, "play"));

                    if (options.obj.micID > -1) {
                        if (options.states.listening)
                            container.append(buildButton("stop listening", "volume-up", options.divID, "mute"));
                        else
                            container.append(buildButton("listen", "volume-off", options.divID, "listen"));
                    }

                    if (!options.readOnly) {
                        if (options.states.recording)
                            container.append(buildButton("stop recording", "circle", options.divID, "record"));
                        else
                            container.append(buildButton("record", "circle-o", options.divID, "record"));

                        if (options.states.hastalk) {
                            if (iSpy.flashSupported) {
                                if (options.states.talking)
                                    container.append(buildButton("stop talking", "microphone-slash", options.divID, "stoptalk"));
                                else
                                    container.append(buildButton("talk", "microphone", options.divID, "talk"));
                            }
                            container.append(buildButton("text to speech", "text-width", options.divID, "text"));
                        }
                        if (options.obj.typeID === 2)
                            container.append(buildButton("save snapshot", "instagram", options.divID, "snapshot"));
                    }
                    if (options.ptz) {
                        if (options.obj.ptzID > -1 || options.obj.ptzID === -5)
                            container.append(buildButton("PTZ Commands", "list", options.divID, "ptzcommands"));
                    }
                    if (!options.readOnly)
                        container.append(buildButton("power off", "power-off", options.divID, "switchoff"));

                } else {
                    if (!options.readOnly)
                        container.append(buildButton("power on", "power-off", options.divID, "switchon"));
                }

                if (options.obj.typeID === 2) {
                    if (options.states.expanded)
                        container.append(buildButton("restore", "compress", options.divID, "restore"));
                    else
                        container.append(buildButton("expand", "expand", options.divID, "expand"));

                }
                if (!options.readOnly) {
                    container.append(buildButton("settings", "gears", options.divID, "settings"));
                }



            },
            command: function (id, cmd) {
                var fo = iSpy.live.getFlashObject(id);
                fo.options.obj.divID = fo.options.divID;

                if (fo != null) {
                    switch (cmd) {
                        case "play":
                            fo.start();
                            break;
                        case "stop":
                            fo.stop();
                            break;
                        case "record":
                            {
                                if (fo.options.states.recording) {
                                    cmd = "recordstop";
                                }
                                iSpy.api.command(fo.options.obj, cmd, function (obj) {
                                    iSpy.live.controls.reload(obj.divID);
                                });
                            }
                            return;
                        case "listen":
                            fo.listen();
                            break;
                        case "mute":
                            fo.mute();
                            break;
                        case "talk":
                            fo.talk();
                            break;
                        case "stoptalk":
                            fo.stopTalk();
                            break;
                        case "mainmenu":
                            var d = $("#other_" + fo.options.divID);
                            d.fadeOut('fast', function () {
                                $(this).hide();
                                var h = $("#maincontrols_" + fo.options.divID);
                                h.show();
                            });
                            break;
                        case "text":
                            var html = "<div style=\"padding:4px\" class=\"input-group\" style=\"z-index:1000\">[back]<input x-webkit-speech type=\"text\" class=\"form-control\" value=\"\" id=\"texttospeech_" + fo.options.divID + "\" onkeypress=\"iSpy.live.controls.textToSpeech('" + fo.options.divID + "',event)\"/><span class=\"input-group-btn\"><button type=\"button\" onclick=\"iSpy.live.controls.textToSpeech('" + fo.options.divID + "')\" class=\"btn btn-info\">Send</button></span></div>";
                            iSpy.live.controls.navPage(fo, html);
                            break;
                        case "snapshot":
                            iSpy.api.command(fo.options.obj, "snapshot", iSpy.live.controls.snapshotResult);
                            break;
                        case "expand":
                            fo.expand();
                            break;
                        case "restore":
                            fo.restore();
                            break;
                        case "close":
                            fo.shutdown();
                            break;
                        case "ptzcommands":
                            iSpy.api.command(fo.options.obj, "getptzcommands&ptzid=" + fo.options.obj.ptzID, function (obj, data) {
                                iSpy.live.controls.loadPTZ(obj.divID, data);
                            });
                            break;
                        case "switchoff":
                            fo.stop();
                            iSpy.api.command(fo.options.obj, "switchoff", function (obj) {
                                iSpy.live.controls.reload(obj.divID);
                            });
                            break;
                        case "switchon":
                            iSpy.api.command(fo.options.obj, "switchon", function (obj) {
                                iSpy.live.controls.reload(obj.divID);
                                fo.start(true);
                            });
                            break;
                        case "settings":
                            iSpy.api.tools.editObject(fo.options.obj);
                            break;
                    }

                    iSpy.live.controls.buildControlBar(fo.options);
                }
            },
            navPage: function (fo, html) {
                var d = $("#maincontrols_" + fo.options.divID);
                d.fadeOut('fast', function () {
                    $(this).hide();
                    var h = $("#other_" + fo.options.divID);
                    html = html.replace("[back]", "<span class=\"input-group-btn\"><button type=\"button\" class=\"btn btn-inverse\" id=\"btnPTZBack_" + fo.options.divID + "\"><div class=\"fa fa-arrow-left\"></div></button></span>");
                    h.html(html);
                    h.show();

                    var ptzsend = $("#btnPTZSend_" + fo.options.divID);
                    if (ptzsend) {

                        var txtSend = $("#texttospeech_" + fo.options.divID);
                        txtSend.on("mouseup", function (e) {
                            e.cancelBubble = true;
                            txtSend.focus();
                        });

                        ptzsend.on("mouseup", function (e) {
                            iSpy.live.controls.ptzCommand(fo.options.divID);
                            e.cancelBubble = true;
                        });

                    }
                    $("#btnPTZBack_" + fo.options.divID).on("mouseup", function (e) {
                        iSpy.live.controls.command(fo.options.divID, 'mainmenu');
                        e.cancelBubble = true;
                    });
                });
            },
            loadPTZ: function (id, data) {
                var fo = iSpy.live.getFlashObject(id);
                if (fo == null)
                    return;

                var html = "<div style=\"padding:4px\" class=\"input-group\">[back]<select class=\"form-control\" id=\"ptzcommand_" + fo.options.divID + "\">";
                for (var i = 0; i < data.elements.length; i++) {
                    var d = data.elements[i];
                    html += "<option value=\"" + d.value + "\">" + d.text + "</option>";
                }
                html += "</select><span class=\"input-group-btn\"><button type=\"button\" id=\"btnPTZSend_" + fo.options.divID + "\" class=\"btn btn-info\">Send</button></span></div>";
                iSpy.live.controls.navPage(fo, html);


            },
            ptzCommand: function (id) {
                var fo = iSpy.live.getFlashObject(id);
                if (fo == null)
                    return;
                var cmd = $("#ptzcommand_" + id).val();
                fo.options.PtzController.ptzcommand(cmd);

            },
            reload: function (id) {
                var fo = iSpy.live.getFlashObject(id);
                if (fo == null)
                    return;
                iSpy.api.command(fo.options.obj, "getobjectstatus", function (osrv, data) {
                    iSpy.live.renderControls(id, data);
                });
            },
            textToSpeech: function (id, ev) {
                if (ev != null) {
                    if (ev.keyCode !== 13) {
                        return;
                    }
                }
                var fo = iSpy.live.getFlashObject(id);
                var txt = $("#texttospeech_" + id).val();
                fo.stopTalk();
                iSpy.api.command(fo.options.obj, "synthtocam&text=" + escape(txt));
                $("#texttospeech_" + id).val("");
            }
        },
        renderControls: function (id, cfg) {
            var fo = iSpy.live.getFlashObject(id);
            if (fo == null)
                return;

            fo.options.obj.active = cfg.online;

            if (fo.options.obj.typeID === 1) {
                if (cfg.online)
                    fo.options.obj.ImageObject = iSpy.helper.images.MicOn;
                else
                    fo.options.obj.ImageObject = iSpy.helper.images.MicOff;
            }

            fo.options.states.recording = cfg.recording;
            fo.options.states.hastalk = cfg.talk;
            if (cfg.online && fo.options.states.startup) {
                fo.options.states.startup = false;
                fo.start(true);
            }
            iSpy.live.controls.buildControlBar(fo.options);
        },
        media: {
            Open: function (obj, ev) {
                var oServer = obj.parent;
                var id = obj.parent.auth + "_" + obj.typeID + obj.id;

                var io = iSpy.live.getFlashObject(id);

                if (io == null) {
                    var opts = { width: 320, height: 240, divID: id, keepAR: true, overlay: false, url: iSpy.helper.serverAddress(oServer), obj: obj };
                    if (obj.typeID === 1)
                        opts.height = 40;
                    io = new iSpy.live.media.Camera(opts);
                    iSpy.liveViewers.push(io);
                }

                if (ev != null) {
                    var mxy = iSpy.helper.mouseXY(document.body, ev);

                    mxy.x = Math.round(mxy.x / 20) * 20;
                    mxy.y = Math.round(mxy.y / 20) * 20;

                    io.container.css({ top: mxy.y, left: mxy.x });
                } else
                    io.container.css({ top: 100, left: 100 });

            },
            Camera: function (options) {
                var that = this;
                options.states = { playing: false, talking: false, listening: false, recording: false, expanded: false, startup: true, hastalk: false, draggingDisabled: false };
                this.options = options;

                options.readOnly = false;
                options.ptz = options.obj.typeID === 2; //cameras only
                var oServer = options.obj.parent;
                if (oServer.Permissions != null) {
                    options.ptz = oServer.Permissions.ptz;
                    options.readOnly = oServer.Permissions.readOnly;
                }
                this.container = null;

                var hasPtz = options.ptz;
                this.options.expandHeight = hasPtz ? 140 : 80;
                this.options.dragBarHeight = 30;
                var liveVideoObject = null;

                function swfLoadEvent(e, fn) {
                    if (typeof fn !== "function") {
                        return false;
                    }
                    iSpy.flashLoader = window.setInterval(function (e2, fn2) {
                        if (typeof e2.ref.PercentLoaded !== "undefined" && e2.ref.PercentLoaded()) {
                            if (e2.ref.PercentLoaded() === 100) {
                                window.clearInterval(iSpy.flashLoader);
                                fn2(e);
                            }
                        }
                    }, 100, e, fn);
                    return true;
                }

                this.Html5Cam = function (container) {
                    var that2 = this;
                    var w = container.width();
                    var h = container.height();
                    var canvas = $('<canvas width=\"' + w + '\" height=\"' + h + '\"/>');
                    canvas.appendTo(container[0]);
                    var domElement = canvas[0];
                    var context = domElement.getContext("2d");
                    var framePending;
                    var imgSource = null;
                    var interval = null;
                    var imageloading = false;
                    var audio = null;

                    var t = "Stopped";
                    context.font = "13px verdana";

                    function render() {
                        framePending = false;
                        var wt;
                        switch (options.obj.typeID) {
                            case 1:
                                wt = context.measureText(options.obj.name + ": " + t).width;
                                context.fillStyle = "#222";
                                context.fillRect(0, 0, context.canvas.width, context.canvas.height);
                                context.fillStyle = "#fff";
                                context.fillText(options.obj.name + ": " + t, w / 2 - wt / 2, h / 2 - 2);

                                break;
                            case 2:
                                if (imgSource != null) {
                                    context.drawImage(imgSource, 0, 0, w, h);
                                } else {
                                    context.fillStyle = "#222";
                                    context.fillRect(0, 0, context.canvas.width, context.canvas.height);
                                    context.fillStyle = "#fff";
                                    wt = context.measureText(options.obj.name + ": " + t).width;
                                    context.fillText(options.obj.name + ": " + t, w / 2 - wt / 2, h / 2 - 2);
                                }
                                break;
                        }
                        context.stroke();
                    }
                    function setPlaying() {
                        t = "Playing";
                        render();
                    }
                    that2.startAudio = function () {
                        if (audio != null)
                            that2.stopAudio();

                        audio = $('<audio hidden="hidden" autoplay="autoplay" preload="none"></audio>');

                        var micid;
                        if (options.obj.typeID === 1)
                            micid = options.obj.id;
                        else
                            micid = options.obj.micID;

                        var source = $("<source type=\"audio/mpeg; codecs=mp3\" src=\"" + options.url + "audiofeed.mp3?micid=" + micid + "&auth=" + options.obj.parent.auth + "\"/>");
                        var source2 = $("<source type=\"audio/wave\" src=\"" + options.url + "audiofeed.wav?micid=" + micid + "&auth=" + options.obj.parent.auth + "\"/>");
                        source.appendTo(audio);
                        source2.appendTo(audio);
                        audio.on("playing", setPlaying);
                        t = "Buffering...";
                        audio[0].load();
                        audio[0].play();
                        render();
                    }

                    that2.stopAudio = function () {
                        if (audio != null) {
                            audio[0].src = "";
                        }
                        audio = null;
                        t = "Stopped";
                        render();
                    }
                    that2.startTalk = function () {
                        //not supported
                    }

                    that2.stopTalk = function () {
                        //not supported
                    }
                    function loadFrame() {
                        if (imageloading)
                            return;
                        var imgFeed = new Image(w, h);
                        imgFeed.src = options.url + "livefeed?auth=" + options.obj.parent.auth + "&size=" + w + "x" + h + "&keepAR=true&oid=" + options.obj.id + "&r=" + Math.random();
                        imageloading = true;
                        $(imgFeed).on("load", function (e) {
                            if (interval == null)
                                return;
                            imgSource = e.target;
                            render();
                            imageloading = false;
                        });
                        $(imgFeed).on("error", function () {
                            if (interval == null)
                                return;
                            imageloading = false;
                        });
                    }
                    that2.startVideo = function () {
                        imgSource = null;
                        w = container.width();
                        h = container.height();
                        imageloading = false;
                        if (interval != null)
                            window.clearInterval(interval);
                        interval = window.setInterval(loadFrame, 50);
                        t = "Connecting...";

                        canvas.width(w);
                        canvas.height(h);
                        context.canvas.width = w;
                        context.canvas.height = h;
                        render();
                    }
                    that2.shutdown = function () {

                    }

                    this.stopVideo = function () {
                        if (interval != null)
                            window.clearInterval(interval);
                        interval = null;
                        imgSource = null;
                        t = "Stopped";

                        render();
                    }

                    render();
                }

                var lng = hasPtz ? "" : "lng";//
                this.container = jQuery("<div class=\"flashContainer\" id=\"" + options.divID + "\"><div id=\"dragbar_" + options.divID + "\" class=\"dragbar\"><a role=\"button\" class=\"btn btn-xs btn-inverse\" title=\"close\" onclick=\"iSpy.live.controls.command('" + options.divID + "','close')\" style=\"position:absolute;right:2px;top:2px;\"><span class=\"fa fa-times-circle fa-lg\"> </span></a>" + options.obj.parent.name + ": " + options.obj.name + "</div><div id=\"constrain_" + options.divID + "\"><div id=\"flash_" + options.divID + "\"></div></div><div id=\"maincontrols_" + options.divID + "\"><div id=\"ptz_" + options.divID + "\"></div><div class=\"controlbar" + lng + "\" id=\"controlbar_" + options.divID + "\"></div></div><div id=\"other_" + options.divID + "\"></div><div id=\"reveal_" + options.divID + "\" class=\"reveal fa fa-chevron-down\"></div></div>");
                this.container.bind("mousedown", function () {
                    for (var i = 0; i < iSpy.liveViewers.length; i++) {
                        var lv = iSpy.liveViewers[i];
                        lv.container.css("zIndex", 500);
                    }
                    that.container.css("zIndex", 501);
                });
                this.container.appendTo(document.body);

                if (hasPtz) {
                    options.PtzController = new iSpy.tools.PtzController(options.obj);
                    options.PtzController.init($("#ptz_" + options.divID));
                }
                $("#reveal_" + options.divID).bind("mouseup", function () {
                    iSpy.live.controls.showhide(options);
                });

                options.obj.liveDivID = options.divID;

                $("#constrain_" + options.divID).width(options.width).height(options.height);
                $("#" + options.divID).width(options.width).height(options.height + options.dragBarHeight + (options.controlBar ? options.expandHeight : 20));
                iSpy.api.command(options.obj, "getobjectstatus", function (obj, data) {
                    iSpy.live.renderControls(obj.liveDivID, data);
                });
                $("#" + options.divID).draggable({ grid: [10, 10] });
                liveVideoObject = new that.Html5Cam($("#constrain_" + options.divID));



                this.stop = function () {
                    if (liveVideoObject == null)
                        return;

                    liveVideoObject.stopVideo();
                    liveVideoObject.stopAudio();
                    liveVideoObject.stopTalk();


                    options.states.playing = false;
                    options.states.listening = false;
                    options.states.talking = false;
                };

                this.start = function (auto) {
                    if (liveVideoObject == null)
                        return;
                    if (options.obj.typeID === 2) {
                        liveVideoObject.startVideo(options.url, options.obj.parent.auth, options.obj.id, options.width, options.height);
                        options.states.playing = true;
                    } else {
                        if (iSpy.flashSupported || !auto) {
                            that.listen();
                            options.states.playing = true;
                        }
                    }
                }
                this.shutdown = function () {
                    if (liveVideoObject == null)
                        return;

                    liveVideoObject.stopVideo();
                    liveVideoObject.stopAudio();
                    liveVideoObject.stopTalk();

                    try {
                        liveVideoObject.shutdown();
                    } catch (e) {
                    }


                    $("#" + options.divID).remove();
                    if (options.PtzController != null)
                        options.PtzController.deinit();
                    liveVideoObject = null;
                    iSpy.live.removeFlashObject(options.divID);
                }
                this.talk = function () {
                    if (liveVideoObject == null)
                        return;
                    var addr = options.url.toLowerCase();
                    addr = addr.replace("http://", "");
                    addr = addr.replace("https://", "");
                    addr = addr.replace("/", "");
                    var info = addr.split(':');
                    liveVideoObject.startTalk(info[0], info[1], options.obj.id, true);
                    options.states.talking = true;
                }
                this.stopTalk = function () {
                    if (liveVideoObject == null)
                        return;
                    liveVideoObject.stopTalk();
                    options.states.talking = false;
                }
                this.listen = function () {
                    if (liveVideoObject == null)
                        return;
                    var micid;
                    if (options.obj.typeID === 1)
                        micid = options.obj.id;
                    else
                        micid = options.obj.micID;

                    if (micid > -1) {
                        liveVideoObject.startAudio(options.url, options.obj.parent.auth, micid);
                        options.states.listening = true;
                    } else {
                        options.states.listening = false;
                    }

                }
                this.mute = function () {
                    if (liveVideoObject == null)
                        return;
                    if (options.obj.micID > -1) {
                        liveVideoObject.stopAudio();
                        options.states.listening = false;
                    }
                }
                this.expand = function () {
                    options.width = 640;
                    options.height = 480;
                    options.states.expanded = true;

                    $("#constrain_" + options.divID).width(options.width).height(options.height);
                    $("#" + options.divID).width(options.width).height(options.height + options.dragBarHeight + (options.controlBar ? options.expandHeight : 20));

                    if (options.states.playing) {
                        that.start();
                    }
                }
                this.restore = function () {
                    options.width = 320;
                    options.height = 240;
                    options.states.expanded = false;
                    $("#constrain_" + options.divID).width(options.width).height(options.height);

                    $("#" + options.divID).width(options.width).height(options.height + options.dragBarHeight + (options.controlBar ? options.expandHeight : 20));

                    if (options.states.playing) {
                        that.start();
                    }
                }


            }
        }
    },
    logs: {
        bindPage: function () {
            if (iSpy.config.subscribed) {
                if (iSpy.config.logs == null) {
                    iSpy.logs.reload();
                }
            }
        },
        reload: function () {
            $.ajax({
                type: "GET",
                url: "/monitor/app/js/config.aspx?subset=logs",
                dataType: "json",
                success: function (response) {
                    iSpy.config.logs = response;
                    iSpy.rootScope.$apply();
                },
                failure: iSpy.helper.webMethodFailed
            });
        }
    },
    subscribe: {
        bindPage: function () {
            if (iSpy.config.subscriptionTypes == null) {
                $.ajax({
                    type: "GET",
                    url: "/monitor/app/js/config.aspx?subset=subscriptions",
                    dataType: "json",
                    success: function (response) {
                        iSpy.config.subscriptionTypes = response;
                        iSpy.rootScope.$apply();
                    },
                    failure: iSpy.helper.webMethodFailed
                });
            }
        },
        choosePlan: function (plan) {
            //FYI: we cross-check the amount on the paypal notification page so if this is hacked it won't work.
            var iframe = $("#pp_frame").contents();
            if (plan.isPrePay) {
                iframe.find("#btnCMD").val("_xclick");
                iframe.find("#amount").val(plan.price);
            } else {
                iframe.find("#btnCMD").val("_xclick-subscriptions");
                iframe.find("#amt_sub").val(plan.price);
            }
            iframe.find("#item_name").val(plan.description);
            iframe.find("#currency_code").val(iSpy.config.currency);
            iframe.find("#notify_url").val("http://www.ispyconnect.com/IPN.aspx?subtypeid=" + plan.id);
            iframe.find("#item_number").val(iSpy.config.accountDetails.id);
            iframe.find('#paypalForm').submit();
        },
        filter1: function (plan) {
            return plan.servers === 1;
        },
        filter3: function (plan) {
            return plan.servers === 3;
        },
        filter5: function (plan) {
            return plan.servers === 5;
        },
        filter10: function (plan) {
            return plan.servers === 10;
        }
    },
    recharge: {
        bindPage: function () {
            if (iSpy.config.rechargeList == null) {
                iSpy.recharge.reload();
            }
        },
        reload: function () {
            $.ajax({
                type: "GET",
                url: "/monitor/app/js/config_rtc.aspx?subset=rechargeList",
                dataType: "json",
                success: function (response) {
                    iSpy.config.rechargeList = response;
                    iSpy.currentScope.apply();
                },
                failure: iSpy.helper.webMethodFailed
            });
        },
        recharge: function () {
            //FYI: we cross-check the amount on the paypal notification page so if this is hacked it won't work.
            var o = $('input[name=smsAmount]:checked');
            var rid = parseInt(o.attr("rid"));
            for (var i = 0; i < iSpy.config.rechargeList.length; i++) {
                var r = iSpy.config.rechargeList[i];
                if (r.id === rid) {
                    var iframe = $("#pp_frame").contents();
                    iframe.find("#amount").val(r.price);
                    iframe.find("#notify_url").val(iSpy.config.URL + "/IPN.aspx?rechargeid=" + r.id);
                    iframe.find("#item_number").val(iSpy.config.accountDetails.id);
                    iframe.find("#currency_code").val(iSpy.config.currency);
                    iframe.find('#paypalForm').submit();
                    break;
                }
            }
        }
    },
    paymentHistory: {
        bindPage: function () {
            if (iSpy.config.paymentHistory == null) {
                iSpy.paymentHistory.reload();
            }
        },
        reload: function () {
            $.ajax({
                type: "GET",
                url: "/monitor/app/js/config.aspx?subset=paymentHistory",
                dataType: "json",
                success: function (response) {
                    iSpy.config.paymentHistory = response;
                    iSpy.rootScope.$apply();
                },
                failure: iSpy.helper.webMethodFailed
            });
        }
    },
    global: {
        Search: function () {
            if (iSpy.searchOptions.tempFromDate != null)
                iSpy.searchOptions.fromDate = iSpy.searchOptions.tempFromDate;
            if (iSpy.searchOptions.tempToDate != null)
                iSpy.searchOptions.toDate = iSpy.searchOptions.tempToDate;

            if (iSpy.files1 != null)
                iSpy.files1.SetRange();

            if (iSpy.snapshots1 != null)
                iSpy.snapshots1.SetRange();

        }
    },
    timeline: {
        bindPage: function () {
            iSpy.clearBoundEvents();
            iSpy.timeline1 = new iSpy.timeline.Manager();
            iSpy.timeline1.init($("#timeline"));
        },
        Manager: function () {
            var that = this;
            var domElement = null;
            var context;
            var options = null;
            var hitTargets = [];
            var itemTargets = [];
            var m = false;
            var mScroll = false;
            var speed = 0;
            var now = new Date();
            var scrollBarYPos = 0;
            var scrollYPos = 0;
            var yMax = 0;
            var headerHeight = 0;
            var scrollYBar = [];
            var framePending = false;
            var mxy = { x: 0, y: 0 };
            var mxyLast = { x: 0, y: 0 };
            var oxy = { x: 0, y: 0 };
            var touchstarttime = null;
            var scaling = false;
            var scaledist = 0;
            var dscale = 0;

            var tStart, tEnd, tRange, scale, r;

            this.loadThumbs = function () {
                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    that.doLoadThumbs(i);
                }
            }

            function getimage(src, obj) {
                var img = new Image();
                img.src = src;
                img.obj = obj;
                $(img).on("load", function (e) {
                    e.target.obj.ImageLoaded = true;
                    e.target.obj.ImageObject = e.target;
                    that.refresh();
                });
                $(img).on("error", function (e) {
                    e.target.obj.ImageLoaded = false;
                });
            }

            this.doLoadThumbs = function (serverIndex) {
                var oServer = iSpy.config.connectedServers[serverIndex];
                if (!oServer.include)
                    return;
                if (!oServer.gotObjectList) {
                    window.setTimeout(iSpy.timeline1.doLoadThumbs, 500, serverIndex);
                    return;
                }
                var rowlen = oServer.objectList.length;
                for (var j = 0; j < rowlen; j++) {
                    var obj = oServer.objectList[j];
                    if (!iSpy.helper.checkAccess(obj))
                        continue;
                    if (obj.typeID === 2) {
                        getimage(iSpy.helper.unique(oServer.objectList[j].thumbURL), obj);
                    } else {
                        if (obj.active)
                            obj.ImageObject = iSpy.helper.images.MicOn;
                        else
                            obj.ImageObject = iSpy.helper.images.MicOff;
                    }
                }
            }



            function setBounds() {
                if (options.preventFuture) {
                    if (options.endDate > now)
                        options.endDate = now;
                }
                if (options.endDate <= options.startDate) {
                    options.startDate = new Date();
                    options.startDate.setTime(options.endDate.getTime());
                    options.startDate = options.startDate.addHours(-24);
                }
                tStart = options.startDate.getTime();
                tEnd = options.endDate.getTime();


                r = (tEnd - tStart) / (domElement.width - options.colWidth); //milliseconds per pixel
                tRange = (tEnd - tStart) / 1000;

                scale = "seconds";
                if (tRange > 60)
                    scale = "minutes";
                if (tRange > 60 * 60)
                    scale = "hours";
                if (tRange > 60 * 60 * 24 * 1.5)
                    scale = "days";
                if (tRange > 60 * 60 * 24 * 30)
                    scale = "months";
                if (tRange > 60 * 60 * 24 * 365 * 1.5)
                    scale = "years";
            };

            function drawLine(x, d, last) {
                var l = 5;
                var s = "";

                context.font = options.fontsize + "px " + options.font;
                if (scale === "seconds") {
                    s = d.getSeconds();
                    if (d.getMinutes() !== last.getMinutes()) {
                        s = d.getHours() + ":" + iSpy.helper.zero(d.getMinutes());
                        l = options.fontsize + 4;
                    }
                }
                if (scale === "minutes") {
                    s = d.getMinutes();
                    if (d.getHours() !== last.getHours()) {
                        s = d.getHours();
                        l = options.fontsize + 4;
                    }
                }
                if (scale === "hours") {
                    s = d.getHours();
                    if (d.getDay() !== last.getDay()) {
                        s = dayNames[d.getDay()];
                        l = options.fontsize + 4;
                    }
                }
                if (scale === "days") {
                    s = d.getDate();
                    if (d.getMonth() !== last.getMonth()) {
                        s = monthNames[d.getMonth()];
                        l = options.fontsize + 4;
                    }
                }
                if (scale === "months") {
                    s = monthNames[d.getMonth()];
                    if (d.getFullYear() !== last.getFullYear()) {
                        s = d.getFullYear();
                        l = options.fontsize + 4;
                    }
                }
                if (scale === "years") {
                    s = d.getFullYear();
                }
                if (l === options.fontsize + 4)
                    context.font = "bold " + (options.fontsize + 4) + "px " + options.font;

                context.moveTo(x, options.fontsize + 5);
                context.lineTo(x, options.fontsize + 5 + l);
                context.fillText(s, x, options.fontsize + 2 + l);
                return true;
            };

            function render() {
                framePending = false;
                if (options.fitToContainer) {
                    context.canvas.width = domElement.width;
                    context.canvas.height = domElement.height;
                }
                context.clearRect(-1, -1, context.canvas.width + 2, context.canvas.height + 2);
                context.strokeStyle = options.lineStyle;
                context.fillStyle = options.textStyle;
                context.lineWidth = 1;
                context.textBaseline = "top";
                context.font = options.fontsize + "px " + options.font;
                headerHeight = (options.fontsize + 2) * 2 + 20;
                var yoffset = headerHeight - scrollYPos;

                hitTargets = [];
                itemTargets = [];
                var i;
                var textWidth;
                for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    var draw = yoffset > headerHeight - options.thumbHeight - options.verticalSpacing && yoffset < domElement.height;
                    if (options.includeSections) {
                        //section headers
                        if (draw) {
                            context.fillStyle = options.sectionColor;
                            context.fillRect(-1, yoffset - 1, domElement.width, options.fontsize + 10);
                            context.fillStyle = options.sectionTextColor;
                            context.font = (options.fontsize + 2) + "px " + options.font;
                            textWidth = context.measureText(oServer.name);
                            context.fillText(oServer.name, domElement.width / 2 - textWidth.width / 2, yoffset + 2);
                        }
                        yoffset += options.fontsize + 7 + options.verticalSpacing;
                    }

                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var obj = oServer.objectList[j];
                        if (obj.camID > -1 || !iSpy.helper.checkAccess(obj))
                            continue;

                        var eventlen = obj.events.length;
                        if (eventlen === 0 && options.hideNoEvents)
                            continue;
                        draw = yoffset > headerHeight - options.thumbHeight - options.verticalSpacing && yoffset < domElement.height;
                        if (draw) {

                            var img;
                            if (!obj.active) {
                                switch (obj.typeID) {
                                    case 1:
                                        img = iSpy.helper.images.MicOff;
                                        break;
                                    case 2:
                                        img = iSpy.helper.images.CamOff;
                                        break;
                                }
                            } else {
                                switch (obj.typeID) {
                                    case 1:
                                        img = iSpy.helper.images.MicOn;
                                        break;
                                    case 2:
                                        img = obj.ImageObject;
                                        break;
                                }
                            }
                            if (img != null) {
                                context.drawImage(img, 2, yoffset, options.thumbWidth, options.thumbHeight);
                                itemTargets.push(new iSpy.helper.HitTarget(2, yoffset, options.colWidth, yoffset + options.thumbHeight, obj));
                            }
                            var ranges = [];

                            for (var k = eventlen - 1; k > -1; k--) {
                                var ev = oServer.objectList[j].events[k];

                                var pStart = options.colWidth + (ev.date.getTime() - tStart) / r;
                                var timeEnd = new Date().setTime(ev.date.getTime() + ev.duration_seconds * 1000);
                                var pEnd = options.colWidth + (timeEnd - tStart) / r;
                                if (pStart < domElement.width && pEnd + options.minEventWidth > options.colWidth) {

                                    if (pEnd > domElement.width)
                                        pEnd = domElement.width;

                                    var rng = new iSpy.helper.Range(pStart, pEnd);

                                    pEnd = Math.max(pStart + Math.max(options.minEventWidth, pEnd - pStart), options.colWidth);
                                    pStart = Math.max(pStart, options.colWidth);

                                    if (ev.timelapse || !iSpy.helper.RangeContains(ranges, rng)) {
                                        var vOff = 0;

                                        if (!ev.timelapse)
                                            ranges.push(new iSpy.helper.Range(pStart, pEnd));
                                        else
                                            vOff = options.thumbHeight / 2;

                                        context.fillStyle = ev.color;
                                        context.fillRect(pStart, yoffset + vOff, (pEnd - pStart), options.thumbHeight - vOff);
                                        ev.x = pStart;
                                        ev.y = yoffset;
                                        hitTargets.push(new iSpy.helper.HitTarget(pStart, yoffset + vOff, pEnd, yoffset + options.thumbHeight, ev));
                                    }
                                }
                            }
                            context.font = options.fontsize + "px " + options.font;
                            var txt = oServer.objectList[j].events.length + ": " + obj.name;
                            textWidth = context.measureText(txt);
                            context.fillStyle = "rgba(255,255,255,0.7)";
                            context.fillRect(options.colWidth, yoffset, textWidth.width + 15, options.fontsize + 6);
                            context.fillStyle = options.textStyle;
                            context.fillText(txt, options.colWidth + 10, yoffset + 2);


                            if (options.rulerLines && j < oServer.objectList.length - 1) {
                                var yl = yoffset + options.thumbHeight + (options.verticalSpacing / 2);
                                context.moveTo(options.colWidth, yl);
                                context.lineTo(domElement.width - 2, yl);
                            }

                        }

                        yoffset += options.thumbHeight + options.verticalSpacing;
                    }
                }

                yMax = yoffset + scrollYPos;
                context.stroke();
                context.clearRect(-1, -1, context.canvas.width + 2, headerHeight + 2);

                //scrollbar
                if (yMax > domElement.height) {
                    context.fillStyle = iSpy.ScrollBarStyle;
                    var sh = Math.max(iSpy.MinScrollBarHeight, ((domElement.height - headerHeight) / yMax) * domElement.height);
                    context.fillRect(domElement.width - iSpy.ScrollBarWidth, headerHeight + scrollBarYPos, iSpy.ScrollBarWidth - 1, sh);
                    scrollYBar = [domElement.width - iSpy.ScrollBarWidth, headerHeight + scrollBarYPos, domElement.width - 1, headerHeight + scrollBarYPos + sh];
                }
                //timeline
                context.strokeStyle = options.lineStyle;
                context.fillStyle = options.textStyle;
                context.lineWidth = 1;
                context.beginPath();
                context.moveTo(options.colWidth, options.fontsize + 5);
                context.lineTo(domElement.width, options.fontsize + 5);

                context.textBaseline = "top";
                context.font = options.fontsize + "px " + options.font;

                context.fillText(options.startDate.formatDate(iSpy.timeFormatSmall), options.colWidth, 0);
                var txtTo = options.endDate.formatDate(iSpy.timeFormatSmall);
                textWidth = context.measureText(txtTo);
                context.fillText(txtTo, domElement.width - textWidth.width - 3, 0);

                var last = new Date();
                var first = true;
                for (i = options.colWidth; i < domElement.width; i += options.accuracy) {
                    var dt = new Date();
                    dt.setTime(tStart + r * (i - options.colWidth));
                    if (first) {
                        last = dt;
                        first = false;
                    }
                    var dl = false;
                    switch (scale) {
                        case "seconds":
                            if (dt.getSeconds() !== last.getSeconds())
                                dl = drawLine(i, dt, last);
                            break;
                        case "minutes":
                            if (dt.getMinutes() !== last.getMinutes())
                                dl = drawLine(i, dt, last);
                            break;
                        case "hours":
                            if (dt.getHours() !== last.getHours())
                                dl = drawLine(i, dt, last);
                            break;
                        case "days":
                            if (dt.getDay() !== last.getDay())
                                dl = drawLine(i, dt, last);
                            break;
                        case "months":
                            if (dt.getMonth() !== last.getMonth())
                                dl = drawLine(i, dt, last);
                            break;
                        case "years":
                            if (dt.getYear() !== last.getYear())
                                dl = drawLine(i, dt, last);
                            break;
                    }
                    if (dl) {
                        last = dt;
                    }
                }


                context.stroke();
                if (!m && speed * speed > 0.2) {
                    speed = speed * options.frictionCoefficient;
                    var bleft = 0 - speed;
                    var bright = domElement.width - options.colWidth - speed;
                    options.startDate = new Date();
                    options.startDate.setTime(tStart + r * bleft);
                    options.endDate = new Date();
                    options.endDate.setTime(tStart + r * bright);
                    setBounds();
                    window.requestAnimationFrame(render);
                }

            };

            this.Resize = function () {
                var w = that.container.width();
                if (w < 240) w = 240;
                domElement.width = w;

                var h = $(window).height();
                h = h - that.container.offset().top;
                h -= 90; //footer
                if (h < 240)
                    h = 240;
                domElement.height = h;
                setBounds();
                if (domElement.width < 340) {
                    options.thumbWidth = options.thumbWidthSmall;
                    options.thumbHeight = options.thumbHeightSmall;
                } else {
                    options.thumbWidth = options.thumbWidthNormal;
                    options.thumbHeight = options.thumbHeightNormal;
                }
                options.colWidth = options.thumbWidth + 5;
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.Redraw = function (bResetScroll) {
                if (bResetScroll) {
                    scrollBarYPos = scrollYPos = 0;
                }
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function zoomin(x) {
                x = x || ((domElement.width - options.colWidth) / 2);
                //zoom in 
                if (scale === options.maxScale)
                    return;

                var w = domElement.width - options.colWidth;
                var pcl = (x / w);
                var pcr = 1 - pcl;

                options.startDate = new Date();
                options.startDate.setTime(tStart + ((pcl / 2) * w) * r);

                options.endDate = new Date();
                options.endDate.setTime(tStart + (w - (pcr / 2) * w) * r);

                setBounds();
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function zoomout(x) {
                x = x || ((domElement.width - options.colWidth) / 2);
                if (scale === options.minScale)
                    return;

                var w = domElement.width - options.colWidth;
                var pcl = (x / w);
                var pcr = 1 - pcl;

                options.startDate = new Date();
                options.startDate.setTime(tStart - (pcl * w) * r);

                options.endDate = new Date();
                options.endDate.setTime(tStart + (w + pcr * w) * r);


                setBounds();
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function stopEvent(e) {
                if (e.preventDefault) e.preventDefault();
                if (e.stopPropagation) e.stopPropagation();
                if (e.returnValue) e.returnValue = false;
                if (e.cancelBubble) e.cancelBubble = true;
                return false;
            }

            function zoom(e) {
                if (scaling) {
                    return;
                }
                e = e.originalEvent;
                var wd = e.wheelDelta || e.detail;
                if (e.detail) {
                    wd = wd * -1;
                }
                stopEvent(e);

                var x = e.pageX - $(domElement).offset().left;

                if (wd > 0)
                    zoomin(x - options.colWidth);
                else
                    zoomout(x - options.colWidth);
            };

            function mousemove(e) {
                if (scaling) {
                    return;
                }
                mxy = iSpy.helper.mouseXY(domElement, e);
                var o, i;
                if (e.target === domElement) {
                    var animate = false;
                    iSpy.helper.setCursor(e, "pointer");
                    if (mxy.x > options.colWidth)
                        iSpy.helper.setCursor(e, "w-resize");


                    if (mScroll && mxy.y > headerHeight) {
                        iSpy.helper.setCursor(e, "pointer");
                        o = mxy.y - mxyLast.y;
                        if (o !== 0) {
                            animate = true;
                            scrollBarYPos += o;
                            if (scrollBarYPos < 0)
                                scrollBarYPos = 0;
                            if (scrollBarYPos > domElement.height - headerHeight - (scrollYBar[3] - scrollYBar[1]))
                                scrollBarYPos = domElement.height - headerHeight - (scrollYBar[3] - scrollYBar[1]);

                            scrollYPos = (scrollBarYPos / (domElement.height - headerHeight)) * yMax;

                            if (scrollYPos - o > yMax)
                                scrollYPos = yMax;
                            if (scrollYPos - o < 0)
                                scrollYPos = 0;
                            iSpy.helper.setCursor(e, 'default');
                        }
                    } else {
                        if (m) {
                            o = mxy.x - mxyLast.x;
                            speed = o;
                            if (o !== 0) {
                                var bleft = 0 - o;
                                var bright = domElement.width - options.colWidth - o;
                                options.startDate = new Date();
                                options.startDate.setTime(tStart + r * bleft);
                                options.endDate = new Date();
                                options.endDate.setTime(tStart + r * bright);
                                setBounds();
                                animate = true;
                            }
                        }
                    }
                    mxyLast = { x: mxy.x, y: mxy.y };

                    if (animate && !framePending) {
                        framePending = true;
                        window.requestAnimationFrame(render);
                    }

                    if (scrollYBar.length > 0) {
                        if (mxy.x > scrollYBar[0] && mxy.y > scrollYBar[1] && mxy.x < scrollYBar[2] && mxy.y < scrollYBar[3]) {
                            iSpy.helper.setCursor(e, "pointer");
                            return;
                        }
                    }

                    var needThumb = false;
                    if (!m) {
                        var html;
                        if (mxy.x > options.colWidth) {
                            for (i = 0; i < hitTargets.length; i++) {
                                o = hitTargets[i];

                                if (mxy.x > o.X && mxy.y > o.Y && mxy.x < o.X2 && mxy.y < o.Y2) {
                                    iSpy.helper.setCursor(e, "pointer");
                                    switch (o.obj.parent.typeID) {
                                        case 1:
                                            html = "<p>" + o.obj.date.formatDate(iSpy.timeFormat) + "</p>";
                                            iSpy.helper.showThumb(html, that.container, o.X, o.Y2, 320, 25);
                                            break;
                                        case 2:
                                            html = "<img src=\"" + o.obj.thumbURL + "\" style=\"width:320px;height:240px\"/><p>" + o.obj.date.formatDate(iSpy.timeFormat) + "</p>";
                                            iSpy.helper.showThumb(html, that.container, o.X, o.Y2, 320, 265);
                                            break;
                                    }
                                    needThumb = true;
                                }
                            }
                        } else {
                            for (i = 0; i < itemTargets.length; i++) {
                                o = itemTargets[i];
                                if (mxy.x > o.X && mxy.y > o.Y && mxy.x < o.X2 && mxy.y < o.Y2) {
                                    if (o.obj.typeID === 2) {
                                        var src = o.obj.thumbURL.replace("thumb=1", "size=320x240");
                                        html = "<img src=\"" + src + "\" style=\"width:320px;height:240px\"/><p>" + o.obj.parent.name + ": " + o.obj.name + "</p>";
                                        iSpy.helper.showThumb(html, that.container, o.X, o.Y2, 320, 265);
                                        needThumb = true;
                                    }
                                    break;
                                }
                            }
                        }
                    }
                    if (!needThumb) {
                        iSpy.helper.hideThumb();
                    }
                }
            };

            function click(e) {
                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;
                iSpy.helper.hideThumb();
                var o, i;
                if (iSpy.helper.calcDist(oxy, mxy) < 20) {
                    if (x > options.colWidth && options.onEventClicked != null) {
                        for (i = 0; i < hitTargets.length; i++) {
                            o = hitTargets[i];
                            if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                                options.onEventClicked(o);
                                return;
                            }
                        }
                    }
                    if (options.onHeaderClicked != null) {
                        for (i = 0; i < itemTargets.length; i++) {
                            o = itemTargets[i];
                            if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                                options.onHeaderClicked(o, e);
                                break;
                            }
                        }
                    }
                }
            };

            function mousedown(e) {
                e.preventDefault();
                if (e.button > 0)
                    return;

                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;
                oxy = { x: x, y: y };
                mxyLast = { x: mxy.x, y: mxy.y };

                if (scrollYBar.length > 0) {
                    if (x > scrollYBar[0] && y > scrollYBar[1] && x < scrollYBar[2] && y < scrollYBar[3]) {
                        mScroll = true;
                        return;
                    }
                }
                m = true;

            };

            function touchstart(e) {
                var ev = e.originalEvent;
                if (ev && ev.touches && ev.touches.length === 2) {
                    scaling = true;
                    var t1 = { x: ev.touches[0].pageX, y: ev.touches[0].pageY };
                    var t2 = { x: ev.touches[1].pageX, y: ev.touches[1].pageY };
                    scaledist = iSpy.helper.calcDist(t1, t2);
                    dscale = 0;
                    return;
                }
                touchstarttime = new Date();
                mousedown(e);

            }

            function touchmove(e) {
                var ev = e.originalEvent;
                if (ev && ev.touches && ev.touches.length === 2) {
                    var t1 = { x: ev.touches[0].pageX, y: ev.touches[0].pageY };
                    var t2 = { x: ev.touches[1].pageX, y: ev.touches[1].pageY };
                    var scaledistnew = iSpy.helper.calcDist(t1, t2);

                    if (!scaling) {
                        scaling = true;
                        scaledist = scaledistnew;
                    }

                    if (scaledist > 0) {
                        dscale = (scaledistnew / scaledist - 1);
                        if (dscale > 0) {
                            if (scale === options.maxScale)
                                return;
                        }
                        else {
                            if (scale === options.minScale)
                                return;
                        }
                        scaledist = scaledistnew;

                        var ox = $(domElement).offset().left;
                        var x = (ev.touches[0].pageX + ev.touches[1].pageX) / 2 - options.colWidth - ox;
                        var w = domElement.width - options.colWidth;

                        var pcl = (x / w);
                        var pcr = 1 - pcl;
                        options.startDate = new Date();
                        options.startDate.setTime(tStart + ((pcl * dscale) * w) * r);

                        options.endDate = new Date();
                        options.endDate.setTime(tStart + (w - (pcr * dscale) * w) * r);


                        setBounds();
                        that.refresh();

                    }
                    return;

                }
                mousemove(e);
            }

            function mouseup() {
                m = false;
                mScroll = false;
                window.requestAnimationFrame(render);
            };

            function touchend(e) {
                if (scaling) {
                    scaling = false;
                    mouseup(e);
                    return;

                }
                var t = new Date() - touchstarttime;
                if (t <= iSpy.touchClickDelay) {
                    if (iSpy.helper.calcDist(oxy, mxy) < iSpy.touchClickRadius) {
                        click(e);
                        return;
                    }
                }
                mouseup(e);
            }

            this.refresh = function () {
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.init = function (ele) {
                that.container = ele.parent();
                domElement = ele[0];
                options = iSpy.timelineOptions;
                context = domElement.getContext("2d");
                context.translate(0.5, 0.5);

                options.thumbWidthNormal = options.thumbWidth;
                options.thumbHeightNormal = options.thumbHeight;
                options.thumbWidthSmall = options.thumbWidth / 2;
                options.thumbHeightSmall = options.thumbHeight / 2;

                $(window).on("resize orientationchange", that.Resize);

                $(document.body).on("mousemove", mousemove);
                $(document.body).on("mouseup touchcancel", mouseup);

                $(domElement).on("mousedown", mousedown);
                $(domElement).on("touchstart", touchstart);
                $(domElement).on("touchend", touchend);
                $(domElement).on("touchmove", touchmove);
                $(domElement).on("mousewheel", zoom);

                $(domElement).on("click", click);

                iSpy.intervals.timelineImages = window.setInterval(iSpy.timeline1.loadThumbs, 10000);
                that.ZoomIn = zoomin;
                that.ZoomOut = zoomout;
                that.loadThumbs();
                that.Resize();
            };

            this.deinit = function () {
                $(window).off("resize orientationchange", that.Resize);
                $(document.body).off("mousemove touchmove", mousemove);
                $(document.body).off("mouseup touchcancel", mouseup);
                window.clearInterval(iSpy.intervals.timelineImages);
            };
        }
    },
    files: {
        bindPage: function () {
            iSpy.clearBoundEvents();
            iSpy.files1 = new iSpy.files.Manager();
            iSpy.files1.init($("#cnvfiles"));
        },
        Manager: function () {
            var that = this;
            var framePending = false;
            var domElement = null;
            var inited;
            var scrollYBar = [];
            var hitTargets = [];
            var context = null;
            var m = false;
            var mScroll = false;
            var scrollBarYPos = 0;
            var scrollYPos = 0;
            var yMax = 0;
            var mxy = { x: 0, y: 0 };
            var margin = 4;
            var oxy = null;
            var itemover;
            var startDate = null;
            var endDate = null;
            this.scales = [
                { w: 24, h: 18, padding: 4, isBig: false },
                { w: 47, h: 36, padding: 4, isBig: false },
                { w: 72, h: 54, padding: 4, isBig: false },
                { w: 96, h: 72, padding: 4, isBig: false },
                { w: 144, h: 108, padding: 4, isBig: false },
                { w: 180, h: 135, padding: 6, isBig: true },
                { w: 216, h: 162, padding: 6, isBig: true },
                { w: 270, h: 203, padding: 6, isBig: true },
                { w: 320, h: 240, padding: 6, isBig: true },
                { w: 400, h: 300, padding: 6, isBig: true },
                { w: 480, h: 360, padding: 6, isBig: true }
            ];
            this.scaleIndex = parseInt(iSpy.helper.readCookie("filesScale", 3));



            var touchstarttime = null;

            function keydown(evt) {
                if (iSpy.lastDownTarget === domElement) {
                    switch (evt.which) {
                        case 8:
                        case 46:
                            that.ActionSelected("massdelete");
                            break;
                    }
                }
            }

            this.ZoomOut = function () {
                that.scaleIndex--;
                if (that.scaleIndex < 0)
                    that.scaleIndex = 0;
                iSpy.helper.createCookie("filesScale", that.scaleIndex, 30);
                that.refresh();
            }

            this.ZoomIn = function () {
                that.scaleIndex++;
                if (that.scaleIndex > that.scales.length - 1)
                    that.scaleIndex = that.scales.length - 1;
                iSpy.helper.createCookie("filesScale", that.scaleIndex, 30);
                that.refresh();
            }
            this.GenerateDownloadLinks = function () {
                var ld = [];
                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var o = oServer.objectList[j];
                        if (!iSpy.helper.checkAccess(o))
                            continue;
                        if (o.events.length > 0) {
                            var eventlen = o.events.length;

                            for (var k = 0; k < eventlen; k++) {
                                var ev = o.events[k];
                                if (startDate != null && endDate != null) {
                                    var t = ev.date.getTime();
                                    if (t < startDate || t > endDate)
                                        continue;
                                }
                                if (ev.selected) {
                                    ev.selected = false;
                                    var ext = ev.filename.substring(ev.filename.indexOf("."));
                                    var url = oServer.url + "downloadclip" + ext + "?auth=" + oServer.auth + "&oid=" + o.id + "&ot=" + o.typeID + "&fn=" + ev.filename;
                                    ld.push({ url: url, text: ev.filename });
                                }
                            }
                        }
                    }
                }
                if (ld.length > 0) {
                    iSpy.downloadLinks = ld;
                    iSpy.currentScope.open('lg', 'partials/ispy_downloadlinks.html', null, null, null);
                } else {
                    iSpy.rootScope.pop("error", "s.SelectFiles", "s.NoFilesSelected");
                    iSpy.rootScope.$apply();
                }

            }

            this.ActionSelected = function (action) {
                var max = 1;
                var isDelete = false;
                if (action === "massdelete" || action === "archive") {
                    max = iSpy.MaxFileOperations;
                    isDelete = true;
                }
                var perm = true;
                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    if (oServer.Permissions != null && oServer.Permissions.readOnly) {
                        perm = false;
                    }
                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var o = oServer.objectList[j];
                        if (!iSpy.helper.checkAccess(o))
                            continue;
                        if (o.events.length > 0) {
                            var eventlen = o.events.length;
                            var fl = "";
                            var c = 0;
                            for (var k = 0; k < eventlen; k++) {
                                var ev = o.events[k];
                                if (startDate != null && endDate != null) {
                                    var t = ev.date.getTime();
                                    if (t < startDate || t > endDate)
                                        continue;
                                }
                                if (ev.selected) {
                                    if (action === "uploadyoutube" && ev.parent.typeID !== 2) {
                                        iSpy.LogScope.addLog("YouTube", "Only valid for video files", true);
                                        break;
                                    }
                                    if (!perm) {
                                        iSpy.LogScope.addLog(oServer.name, "Access denied", true);
                                        ev.selected = false;
                                        break;
                                    }
                                    fl += "{\"name\":\"" + ev.filename + "\"},";
                                    if (isDelete) {
                                        o.events.splice(k, 1);
                                        eventlen--;
                                        k--;
                                    } else {
                                        ev.selected = false;
                                    }
                                    c++;
                                }
                                if (c === max) {
                                    break;
                                }
                            }
                            if (c > 0) {
                                //throttle
                                if (fl !== "") {
                                    fl = fl.substring(0, fl.length - 1);
                                    window.setTimeout(function (o2, fl2) {
                                        iSpy.api.postCommand(o2, action, "{\"files\":[" + fl2 + "]}", function (obj, data) {
                                            iSpy.helper.processActionResult(iSpy.files1, data, action);
                                        });
                                        that.refresh();
                                    }, 200, o, fl);
                                    return;
                                }
                            }

                        }
                    }
                }
            }

            function render() {
                if (!iSpy.helper.images.Loaded()) {
                    framePending = false;
                    return;
                }
                context.clearRect(-1, -1, context.canvas.width + 2, context.canvas.height + 2);
                context.strokeStyle = "#ccc";
                var x;
                var y = 0 - scrollYPos;
                var ytot;

                var markers = [];

                hitTargets = [];
                context.font = "11px verdana";


                var scale = that.scales[that.scaleIndex];
                var padding = scale.padding;

                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    var draw;
                    draw = y + 20 > 0 && y < context.canvas.height;
                    var textWidth;
                    if (draw) {
                        context.fillStyle = that.sectionColor;
                        context.fillRect(-1, y - 1, context.canvas.width, 21);
                        context.fillStyle = "#fff";
                        context.font = "13px verdana";
                        textWidth = context.measureText(oServer.name);
                        context.fillText(oServer.name, context.canvas.width / 2 - textWidth.width / 2, y + 14);
                        hitTargets.push(new iSpy.helper.HitTarget(-1, y - 1, context.canvas.width, y + 20, oServer));
                    }
                    markers.push(y + scrollYPos);
                    y += 25;

                    context.strokeStyle = "#ccc";
                    context.beginPath();

                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var o = oServer.objectList[j];
                        if (!iSpy.helper.checkAccess(o))
                            continue;
                        if (o.events.length > 0) {
                            x = 0;
                            draw = y + 20 > 0 && y < context.canvas.height;
                            var drawHeader = draw;
                            var eventlen = o.events.length;
                            for (var k = 0; k < eventlen; k++) {
                                var ev = o.events[k];
                                if (startDate != null && endDate != null) {
                                    var t = ev.date.getTime();
                                    if (t < startDate || t > endDate)
                                        continue;
                                }
                                if (drawHeader) {
                                    context.fillStyle = "#ccc";
                                    if (o.selected)
                                        context.fillStyle = that.sectionColor;

                                    context.fillRect(-1, y - 1, context.canvas.width, 21);
                                    context.fillStyle = "#222";
                                    if (o.selected)
                                        context.fillStyle = "#fff";
                                    context.font = "13px verdana";
                                    textWidth = context.measureText(o.name);
                                    context.fillText(o.name, context.canvas.width / 2 - textWidth.width / 2, y + 12);
                                    hitTargets.push(new iSpy.helper.HitTarget(-1, y - 1, context.canvas.width, y + 20, o));
                                    markers.push(y + scrollYPos);
                                    y += 21 + margin;
                                    drawHeader = false;
                                }
                                var x2 = x + scale.w + (padding * 2);
                                var y2 = y + scale.h + (padding * 2);

                                draw = y2 > 0 && y < context.canvas.height;
                                if (draw) {
                                    if (ev.selected) {
                                        context.fillStyle = that.sectionColor;
                                        context.fillRect(x, y, x2 - x, y2 - y);
                                    }
                                    context.moveTo(x, y);
                                    context.lineTo(x2, y);
                                    context.lineTo(x2, y2);
                                    context.lineTo(x, y2);
                                    context.lineTo(x, y);

                                    switch (ev.parent.typeID) {
                                        case 1:
                                            context.drawImage(iSpy.helper.images.Mic, x + padding, y + padding, scale.w, scale.h);
                                            break;
                                        case 2:
                                            if (ev.thumb == null || !ev.thumb.loaded) {
                                                context.drawImage(iSpy.helper.images.Loading, x + padding, y + padding, scale.w, scale.h);
                                                if (!m && ev.thumb == null) {
                                                    ev.thumb = new Image();
                                                    ev.thumb.loaded = false;
                                                    ev.thumb.src = ev.thumbURLSmall;
                                                    $(ev.thumb).on("load", function (e) {
                                                        e.target.loaded = true;
                                                        if (!framePending) {
                                                            framePending = true;
                                                            window.requestAnimationFrame(render);
                                                        }
                                                    });
                                                }

                                            } else {
                                                if (scale.isBig && (ev.bigThumb == null || !ev.bigThumb.loaded)) {
                                                    ev.bigThumb = new Image();
                                                    ev.bigThumb.loaded = false;
                                                    ev.bigThumb.src = ev.thumbURL;
                                                    $(ev.bigThumb).on('load', function (e) {
                                                        e.target.loaded = true;
                                                        if (!framePending) {
                                                            framePending = true;
                                                            window.requestAnimationFrame(render);
                                                        }
                                                    });
                                                    $(ev.bigThumb).on('error', function (e) {
                                                        e.target.loaded = false;

                                                    });
                                                } else {
                                                    if (scale.isBig)
                                                        context.drawImage(ev.bigThumb, x + padding, y + padding, scale.w, scale.h);
                                                    else
                                                        context.drawImage(ev.thumb, x + padding, y + padding, scale.w, scale.h);
                                                }
                                            }
                                            break;

                                    }
                                    hitTargets.push(new iSpy.helper.HitTarget(x, y, x2, y2, ev, 'image'));
                                }

                                x = x2 + margin;
                                if (x + scale.w + (padding * 2) + margin > context.canvas.width) {
                                    x = 0;
                                    y = y2 + margin;

                                }
                            }
                            if (x > 0) {
                                y = y + scale.h + (padding * 2) + margin;
                            }


                        }
                    }
                    context.stroke();

                }
                if (m && !mScroll) {
                    context.beginPath();
                    var lw = context.lineWidth;
                    context.lineWidth = "2";
                    context.strokeStyle = "blue";

                    context.moveTo(oxy.x, oxy.y);
                    context.lineTo(mxy.x, oxy.y);
                    context.lineTo(mxy.x, mxy.y);
                    context.lineTo(oxy.x, mxy.y);
                    context.lineTo(oxy.x, oxy.y);
                    context.stroke();
                    context.lineWidth = lw;

                }
                ytot = scrollYPos + y + scale.h + (padding * 2) + margin;
                yMax = ytot;

                if (ytot - scrollYPos < domElement.height) {
                    scrollYPos = ytot - domElement.height;
                    if (scrollYPos < 0)
                        scrollYPos = 0;
                    scrollBarYPos = (scrollYPos / yMax) * domElement.height;
                }


                if (yMax > domElement.height) {

                    context.strokeStyle = "#222";
                    context.beginPath();
                    while (markers.length > 0) {
                        var ym = markers.pop();
                        var pc = (ym / yMax);
                        var ys = context.canvas.height * pc;
                        context.moveTo(context.canvas.width - 20, ys);
                        context.lineTo(context.canvas.width, ys);
                    }
                    context.stroke();

                    context.fillStyle = iSpy.ScrollBarStyle;
                    var sh = Math.max(iSpy.MinScrollBarHeight, (domElement.height / yMax) * domElement.height);
                    context.fillRect(domElement.width - iSpy.ScrollBarWidth, scrollBarYPos, iSpy.ScrollBarWidth - 1, sh);
                    scrollYBar = [domElement.width - iSpy.ScrollBarWidth, scrollBarYPos, domElement.width - 1, scrollBarYPos + sh];
                }

                framePending = false;

            }

            function mousewheel(e) {
                e = e.originalEvent;
                var o = 20;
                var wd = e.wheelDelta || e.detail;
                if (e.detail) {
                    wd = wd * -1;
                }
                iSpy.helper.stopEvent(e);
                if (wd > 0)
                    o = -20;

                scrollBarYPos += o;
                if (scrollBarYPos < 0)
                    scrollBarYPos = 0;
                if (scrollBarYPos > domElement.height - (scrollYBar[3] - scrollYBar[1]))
                    scrollBarYPos = domElement.height - (scrollYBar[3] - scrollYBar[1]);

                scrollYPos = (scrollBarYPos / domElement.height) * yMax;

                if (scrollYPos - o > yMax)
                    scrollYPos = yMax;
                if (scrollYPos - o < 0)
                    scrollYPos = 0;

                if (!framePending) {
                    window.requestAnimationFrame(render);
                }
            }

            this.Resize = function () {
                var w = that.container.width();
                if (w < 300) w = 300;
                domElement.width = w;

                var h = $(window).height();
                h = h - that.container.offset().top;
                h -= 90; //footer
                if (h < 300)
                    h = 300;
                domElement.height = h;
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.NavigateTo = function (obj) {
                render(obj);
            };

            function mousemove(e) {

                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;

                itemover = -1;

                if (e.target === domElement) {
                    iSpy.helper.setCursor(e, "default");
                    var i, html, o;
                    for (i = 0; i < hitTargets.length; i++) {
                        o = hitTargets[i];
                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            iSpy.helper.setCursor(e, "pointer");
                        }
                    }
                    if (mScroll) {
                        iSpy.helper.setCursor(e, "pointer");
                        var dy = y - oxy.y;
                        if (dy !== 0) {
                            scrollBarYPos += dy;
                            if (scrollBarYPos < 0)
                                scrollBarYPos = 0;
                            if (scrollBarYPos > domElement.height - (scrollYBar[3] - scrollYBar[1]))
                                scrollBarYPos = domElement.height - (scrollYBar[3] - scrollYBar[1]);

                            scrollYPos = (scrollBarYPos / domElement.height) * yMax;

                            if (scrollYPos - dy > yMax)
                                scrollYPos = yMax;
                            if (scrollYPos - dy < 0)
                                scrollYPos = 0;
                            oxy.y = y;
                        }
                    }

                    if (scrollYBar.length > 0) {
                        if (x > scrollYBar[0] && y > scrollYBar[1] && x < scrollYBar[2] && y < scrollYBar[3]) {
                            iSpy.helper.setCursor(e, "pointer");
                        }
                    }

                    if (m && !framePending) {
                        framePending = true;
                        window.requestAnimationFrame(render);
                    }

                    var needThumb = false;
                    if (!m && !mScroll) {
                        for (i = 0; i < hitTargets.length; i++) {
                            o = hitTargets[i];
                            if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                                if (o.type === "image") {
                                    var scale = that.scales[that.scaleIndex];
                                    if (scale.isBig || o.obj.parent.typeID === 1) {
                                        html = "<p>" + o.obj.date.formatDate(iSpy.timeFormat) + "</p>";
                                        iSpy.helper.showThumb(html, that.container, o.X, o.Y2, scale.w + scale.padding * 2, 25);
                                    } else {
                                        html = "<img src=\"" + o.obj.thumbURL + "\" style=\"width:320px;height:240px\"/><p>" + o.obj.date.formatDate(iSpy.timeFormat) + "</p>";
                                        iSpy.helper.showThumb(html, that.container, o.X, o.Y2, 320, 265);
                                    }
                                    needThumb = true;
                                }
                            }
                        }
                    }
                    if (!needThumb) {
                        iSpy.helper.hideThumb();
                    }
                }
            };

            function mousedown(e) {
                if (e.target !== domElement)
                    return;
                e.preventDefault();
                if (e.button > 0)
                    return;

                oxy = iSpy.helper.mouseXY(domElement, e);
                m = true;

                if (scrollYBar.length > 0) {
                    if (oxy.x > scrollYBar[0] && oxy.y > scrollYBar[1] && oxy.x < scrollYBar[2] && oxy.y < scrollYBar[3]) {
                        mScroll = true;
                        return;
                    }
                }
            };

            function markSelected(obj) {
                var eventlen = obj.events.length;
                for (var k = 0; k < eventlen; k++) {
                    var ev = obj.events[k];
                    if (startDate != null && endDate != null) {
                        var t = ev.date.getTime();
                        if (t < startDate || t > endDate)
                            continue;
                    }
                    ev.selected = obj.selected;
                }
            }

            function click(e) {
                if (e.target !== domElement || mScroll)
                    return;
                mxy = iSpy.helper.mouseXY(domElement, e);
                m = false;
                var d = Math.sqrt(Math.pow((mxy.x - oxy.x), 2) + Math.pow((mxy.y - oxy.y), 2));
                if (d > 10) {
                    window.requestAnimationFrame(render);
                    return;
                }
                var x = mxy.x, y = mxy.y;
                iSpy.helper.hideThumb();
                var i, j, o, o2;
                for (i = 0; i < hitTargets.length; i++) {
                    o = hitTargets[i];

                    if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                        if (o.type === "image") {
                            iSpy.tools.loadMedia(o.obj);
                            return;
                        }
                        if (o.obj.auth != null) {
                            //server
                            o.obj.selected = !o.obj.selected;
                            for (j = 0; j < o.obj.objectList.length; j++) {
                                o2 = o.obj.objectList[j];
                                o2.selected = o.obj.selected;
                                markSelected(o2);
                            }
                            window.requestAnimationFrame(render);
                            return;
                        }
                        if (o.obj.type === "Device") {
                            //camera
                            o.obj.selected = !o.obj.selected;
                            markSelected(o.obj);
                            window.requestAnimationFrame(render);
                            return;
                        }
                    }
                }
                //clicked nothing - deselect selections
                for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    oServer.selected = false;
                    for (j = 0; j < oServer.objectList.length; j++) {
                        o2 = oServer.objectList[j];
                        o2.selected = false;
                        markSelected(o2);
                    }
                }
                window.requestAnimationFrame(render);
            };

            function intersectRect(r1, r2) {
                return !(r2.left > r1.right ||
                    r2.right < r1.left ||
                    r2.top > r1.bottom ||
                    r2.bottom < r1.top);
            }

            function mouseup(e) {
                m = false;
                if (e.target !== domElement || mScroll) {
                    mScroll = false;
                    window.requestAnimationFrame(render);
                    return;
                }
                mxy = iSpy.helper.mouseXY(domElement, e);
                var d = Math.sqrt(Math.pow((mxy.x - oxy.x), 2) + Math.pow((mxy.y - oxy.y), 2));
                if (d > 10 && !mScroll) {
                    //drawn out a selection
                    var r1 = {
                        left: Math.min(mxy.x, oxy.x),
                        top: Math.min(mxy.y, oxy.y),
                        right: Math.max(mxy.x, oxy.x),
                        bottom: Math.max(mxy.y, oxy.y)
                    };

                    for (var i = 0; i < hitTargets.length; i++) {
                        var o = hitTargets[i];
                        if (o.type === "image") {
                            var r2 = {
                                left: o.X,
                                top: o.Y,
                                right: o.X2,
                                bottom: o.Y2
                            };
                            if (intersectRect(r1, r2)) {
                                o.obj.selected = !o.obj.selected;
                            }
                        }
                    }
                }
                window.requestAnimationFrame(render);
            };

            this.refresh = function () {
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.SetRange = function () {
                startDate = iSpy.searchOptions.fromDate;
                endDate = iSpy.searchOptions.toDate;

                scrollBarYPos = 0;

                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function touchstart(e) {
                touchstarttime = new Date();
                mousedown(e);

            }

            function touchend(e) {
                var t = new Date() - touchstarttime;
                if (t <= iSpy.touchClickDelay) {
                    click(e);
                    return;
                }
                mouseup(e);
            }

            this.deinit = function () {
                $(window).off("resize orientationchange", that.Resize);
                $(document.body).off("mousemove touchmove", mousemove);
                $(document.body).off("mouseup touchcancel", mouseup);
                $(document.body).off("keydown", keydown);
            }

            this.init = function (ele) {
                that.sectionColor = "#666";
                that.container = ele.parent();
                domElement = ele[0];

                context = domElement.getContext("2d");
                context.translate(0.5, 0.5);

                $(window).on("resize orientationchange", that.Resize);
                $(document.body).on("mousemove touchmove", mousemove);
                $(document.body).on("mouseup touchcancel", mouseup);
                $(document.body).on("keydown", keydown);

                $(domElement).on("mousedown", mousedown);
                $(domElement).on("touchstart", touchstart);
                $(domElement).on("touchend", touchend);
                $(domElement).on("mousewheel", mousewheel);
                $(domElement).on("click", click);

                inited = true;
                that.Resize();
                that.SetRange();
            };
        }
    },
    snapshots: {
        bindPage: function () {
            iSpy.clearBoundEvents();
            iSpy.snapshots1 = new iSpy.snapshots.Manager();
            iSpy.snapshots1.init($("#cnvSnapshots"));
            iSpy.snapshots1.SetRange();

        },
        pageSize: 1000,
        dateQuery: "",
        LoadData: function (reset) {
            for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                iSpy.snapshots.DoLoadData(i, reset);
            }
            iSpy.snapshots1.refresh();
        },
        DoLoadData: function (serverIndex, reset) {
            var oServer = iSpy.config.connectedServers[serverIndex];
            if (!oServer.include)
                return;
            if (!oServer.gotObjectList) {
                window.setTimeout(iSpy.snapshots.DoLoadData, 500, serverIndex, reset);
                return;
            }
            for (var j = 0; j < oServer.objectList.length; j++) {
                var obj = oServer.objectList[j];
                if (!iSpy.helper.checkAccess(obj))
                    continue;
                if (obj.typeID === 2) {
                    if (reset)
                        obj.grabs = [];

                    iSpy.api.command(obj, "getcameragrabs&page=0&pagesize=" + iSpy.snapshots.pageSize + iSpy.snapshots.dateQuery, function (obj2, data) {
                        iSpy.snapshots.PopulateData(obj2, data);
                    });
                }
            }
        },
        PopulateData: function (obj, data) {

            if (data.results.length > 0) {
                var d2 = [];
                for (var i = 0; i < data.results.length; i++) {
                    var fn = obj.parent.url + "loadgrab?oid=" + obj.id + "&fn=" + data.results[i].name + "&auth=" + obj.parent.auth;
                    var date = new Date();
                    date.setTime(parseInt(data.results[i].time));
                    d2.push({ url: fn, filename: data.results[i].name, date: date });
                }
                obj.grabs = obj.grabs.concat(d2);
            }

            if (data.total > (iSpy.snapshots.pageSize * (data.page + 1))) {
                iSpy.api.command(obj, "getcameragrabs&page=" + (page + 1) + "0&pagesize=" + iSpy.snapshots.pageSize + iSpy.snapshots.dateQuery, function (obj2, data2) {
                    iSpy.snapshots.PopulateData(obj2, data2);
                });
            }

            if (data.total !== 0)
                iSpy.snapshots1.refresh();
        },
        Manager: function () {
            var that = this;
            var framePending = false;
            var domElement = null;
            var inited;
            var scrollYBar = [];
            var hitTargets = [];
            var context = null;
            var m = false;
            var mScroll = false;
            var my = 0;
            var scrollBarYPos = 0;
            var scrollYPos = 0;
            var yMax = 0;
            var mxy = { x: 0, y: 0 };
            var margin = 4;
            var oxy = { x: 0, y: 0 };
            var itemover;
            var startDate = null;
            var endDate = null;
            var touchstarttime = null;
            this.scales = [
                { w: 24, h: 18, padding: 4, isBig: false },
                { w: 47, h: 36, padding: 4, isBig: false },
                { w: 72, h: 54, padding: 4, isBig: false },
                { w: 96, h: 72, padding: 4, isBig: false },
                { w: 144, h: 108, padding: 4, isBig: false },
                { w: 180, h: 135, padding: 6, isBig: true },
                { w: 216, h: 162, padding: 6, isBig: true },
                { w: 270, h: 203, padding: 6, isBig: true },
                { w: 320, h: 240, padding: 6, isBig: true },
                { w: 400, h: 300, padding: 6, isBig: true },
                { w: 480, h: 360, padding: 6, isBig: true }
            ];

            this.scaleIndex = parseInt(iSpy.helper.readCookie("snapshotsScale", 3));

            this.reload = function () {
                iSpy.snapshots.LoadData(true);
            }

            function keydown(evt) {
                if (iSpy.lastDownTarget === domElement) {
                    switch (evt.which) {
                        case 8:
                        case 46:
                            that.ActionSelected("massdeletegrabs");
                            break;
                    }
                }
            }

            this.ZoomOut = function () {
                that.scaleIndex--;
                if (that.scaleIndex < 0)
                    that.scaleIndex = 0;
                that.refresh();
                iSpy.helper.createCookie("snapshotsScale", that.scaleIndex, 30);
            }

            this.ZoomIn = function () {
                that.scaleIndex++;
                if (that.scaleIndex > that.scales.length - 1)
                    that.scaleIndex = that.scales.length - 1;
                iSpy.helper.createCookie("snapshotsScale", that.scaleIndex, 30);
                that.refresh();
            }

            this.ActionSelected = function (action) {
                var max = 1;
                var isDelete = false;
                if (action === "massdeletegrabs" || action === "archive") {
                    max = iSpy.MaxFileOperations;
                    isDelete = true;
                }
                var perm = true;
                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    if (oServer.Permissions != null && oServer.Permissions.readOnly) {
                        perm = false;
                    }
                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var o = oServer.objectList[j];
                        if (!iSpy.helper.checkAccess(o))
                            continue;
                        if (o.grabs == null)
                            continue;
                        var eventlen = o.grabs.length;
                        if (eventlen > 0) {
                            var fl = "";
                            var c = 0;
                            for (var k = 0; k < eventlen; k++) {
                                var ev = o.grabs[k];
                                if (ev.selected) {
                                    if (!perm) {
                                        iSpy.LogScope.addLog(oServer.name, "Access denied");
                                        ev.selected = false;
                                        break;
                                    }

                                    fl += "{\"name\":\"" + ev.filename + "\"},";
                                    if (isDelete) {
                                        o.grabs.splice(k, 1);
                                        eventlen--;
                                        k--;
                                    } else {
                                        ev.selected = false;
                                    }
                                    c++;
                                }
                                if (c === max) {
                                    break;
                                }
                            }
                            if (c > 0) {
                                if (fl !== "")
                                    fl = fl.substring(0, fl.length - 1);
                                window.setTimeout(function (o2, fl2) {
                                    iSpy.api.postCommand(o2, action, "{\"files\":[" + fl2 + "]}", function (obj, data) {
                                        iSpy.helper.processActionResult(iSpy.snapshots1, data, action);
                                    });
                                    that.refresh();
                                }, 200, o, fl);
                                return;
                            }

                        }
                    }
                }
            }

            function render() {
                if (!iSpy.helper.images.Loaded()) {
                    framePending = false;
                    return;
                }
                context.clearRect(-1, -1, context.canvas.width + 2, context.canvas.height + 2);
                context.strokeStyle = "#ccc";
                var x;
                var y = 0 - scrollYPos;
                var ytot;

                var markers = [];

                hitTargets = [];
                context.font = "11px verdana";

                var scale = that.scales[that.scaleIndex];
                var padding = scale.padding;

                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    var draw;
                    draw = y + 20 > 0 && y < context.canvas.height;
                    var textWidth;
                    if (draw) {
                        context.fillStyle = that.sectionColor;
                        context.fillRect(-1, y - 1, context.canvas.width, 21);
                        context.fillStyle = "#fff";
                        context.font = "13px verdana";
                        textWidth = context.measureText(oServer.name);
                        context.fillText(oServer.name, context.canvas.width / 2 - textWidth.width / 2, y + 14);
                        hitTargets.push(new iSpy.helper.HitTarget(-1, y - 1, context.canvas.width, y + 20, oServer));
                    }
                    markers.push(y + scrollYPos);
                    y += 25;

                    context.strokeStyle = "#ccc";
                    context.beginPath();

                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var o = oServer.objectList[j];
                        if (!iSpy.helper.checkAccess(o))
                            continue;
                        if (o.grabs != null && o.grabs.length > 0) {
                            x = 0;
                            draw = y + 20 > 0 && y < context.canvas.height;
                            var drawHeader = draw;
                            var eventlen = o.grabs.length;
                            for (var k = 0; k < eventlen; k++) {
                                var ev = o.grabs[k];
                                if (startDate != null && endDate != null && ev.date != null) {
                                    var t = ev.date.getTime();
                                    if (t < startDate || t > endDate)
                                        continue;
                                }
                                if (drawHeader) {
                                    context.fillStyle = "#ccc";
                                    if (o.selected)
                                        context.fillStyle = that.sectionColor;

                                    context.fillRect(-1, y - 1, context.canvas.width, 21);
                                    context.fillStyle = "#222";
                                    if (o.selected)
                                        context.fillStyle = "#fff";
                                    context.font = "13px verdana";
                                    textWidth = context.measureText(o.name);
                                    context.fillText(o.name, context.canvas.width / 2 - textWidth.width / 2, y + 12);
                                    hitTargets.push(new iSpy.helper.HitTarget(-1, y - 1, context.canvas.width, y + 20, o));
                                    markers.push(y + scrollYPos);
                                    y += 21 + margin;
                                    drawHeader = false;
                                }
                                var x2 = x + scale.w + (padding * 2);
                                var y2 = y + scale.h + (padding * 2);

                                draw = y2 > 0 && y < context.canvas.height;
                                if (draw) {
                                    if (ev.selected) {
                                        context.fillStyle = that.sectionColor;
                                        context.fillRect(x, y, x2 - x, y2 - y);
                                    }
                                    context.moveTo(x, y);
                                    context.lineTo(x2, y);
                                    context.lineTo(x2, y2);
                                    context.lineTo(x, y2);
                                    context.lineTo(x, y);

                                    if (ev.thumb == null || !ev.thumb.loaded) {
                                        context.drawImage(iSpy.helper.images.Loading, x + padding, y + padding, scale.w, scale.h);
                                        if (!m && ev.thumb == null) {
                                            ev.thumb = new Image();
                                            ev.thumb.loaded = false;
                                            ev.thumb.src = ev.url + "&size=320X240";
                                            $(ev.thumb).on('load', function (e) {
                                                e.target.loaded = true;
                                                if (!framePending) {
                                                    framePending = true;
                                                    window.requestAnimationFrame(render);
                                                }
                                            });
                                            $(ev.thumb).on('error', function (e) {
                                                e.target.loaded = false;
                                                e.target.thumb = null;
                                            });
                                        }

                                    } else {
                                        context.drawImage(ev.thumb, x + padding, y + padding, scale.w, scale.h);
                                    }

                                    hitTargets.push(new iSpy.helper.HitTarget(x, y, x2, y2, ev, 'image'));
                                }

                                x = x2 + margin;
                                if (x + scale.w + (padding * 2) + margin > context.canvas.width) {
                                    x = 0;
                                    y = y2 + margin;

                                }
                            }
                            if (x > 0) {
                                y = y + scale.h + (padding * 2) + margin;
                            }


                        }
                    }
                    context.stroke();

                }
                if (m && !mScroll) {
                    context.beginPath();
                    var lw = context.lineWidth;
                    context.lineWidth = "2";
                    context.strokeStyle = "blue";

                    context.moveTo(oxy.x, oxy.y);
                    context.lineTo(mxy.x, oxy.y);
                    context.lineTo(mxy.x, mxy.y);
                    context.lineTo(oxy.x, mxy.y);
                    context.lineTo(oxy.x, oxy.y);
                    context.stroke();
                    context.lineWidth = lw;

                }
                ytot = scrollYPos + y + scale.h + (padding * 2) + margin;
                yMax = ytot;

                if (ytot - scrollYPos < domElement.height) {
                    scrollYPos = ytot - domElement.height;
                    if (scrollYPos < 0)
                        scrollYPos = 0;
                    scrollBarYPos = (scrollYPos / yMax) * domElement.height;
                }


                if (yMax > domElement.height) {
                    context.strokeStyle = "#222";
                    context.beginPath();
                    while (markers.length > 0) {
                        var ym = markers.pop();
                        var pc = (ym / yMax);
                        var ys = context.canvas.height * pc;
                        context.moveTo(context.canvas.width - 20, ys);
                        context.lineTo(context.canvas.width, ys);
                    }
                    context.stroke();

                    context.fillStyle = iSpy.ScrollBarStyle;
                    var sh = Math.max(iSpy.MinScrollBarHeight, (domElement.height / yMax) * domElement.height);
                    context.fillRect(domElement.width - iSpy.ScrollBarWidth, scrollBarYPos, iSpy.ScrollBarWidth - 1, sh);
                    scrollYBar = [domElement.width - iSpy.ScrollBarWidth, scrollBarYPos, domElement.width - 1, scrollBarYPos + sh];
                }

                framePending = false;

            }

            function mousewheel(e) {
                e = e.originalEvent;
                var o = 20;
                var wd = e.wheelDelta || e.detail;
                if (e.detail) {
                    wd = wd * -1;
                }
                iSpy.helper.stopEvent(e);
                if (wd > 0)
                    o = -20;

                scrollBarYPos += o;
                if (scrollBarYPos < 0)
                    scrollBarYPos = 0;
                if (scrollBarYPos > domElement.height - (scrollYBar[3] - scrollYBar[1]))
                    scrollBarYPos = domElement.height - (scrollYBar[3] - scrollYBar[1]);

                scrollYPos = (scrollBarYPos / domElement.height) * yMax;

                if (scrollYPos - o > yMax)
                    scrollYPos = yMax;
                if (scrollYPos - o < 0)
                    scrollYPos = 0;

                if (!framePending) {
                    window.requestAnimationFrame(render);
                }
            }

            function mousemove(e) {

                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;

                itemover = -1;
                var o, h, i;

                if (e.target === domElement) {
                    iSpy.helper.setCursor(e, 'default');

                    for (i = 0; i < hitTargets.length; i++) {
                        o = hitTargets[i];
                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            iSpy.helper.setCursor(e, "pointer");
                        }
                    }
                    if (mScroll) {
                        iSpy.helper.setCursor(e, "pointer");
                        o = y - my;
                        if (o !== 0) {
                            scrollBarYPos += o;
                            if (scrollBarYPos < 0)
                                scrollBarYPos = 0;
                            if (scrollBarYPos > domElement.height - (scrollYBar[3] - scrollYBar[1]))
                                scrollBarYPos = domElement.height - (scrollYBar[3] - scrollYBar[1]);

                            scrollYPos = (scrollBarYPos / domElement.height) * yMax;

                            if (scrollYPos - o > yMax)
                                scrollYPos = yMax;
                            if (scrollYPos - o < 0)
                                scrollYPos = 0;
                            my = y;
                        }
                    }

                    if (scrollYBar.length > 0) {
                        if (x > scrollYBar[0] && y > scrollYBar[1] && x < scrollYBar[2] && y < scrollYBar[3]) {
                            iSpy.helper.setCursor(e, "pointer");
                        }
                    }

                    if (m && !framePending) {
                        framePending = true;
                        window.requestAnimationFrame(render);
                    }


                    var needThumb = false;
                    if (!m && !mScroll) {
                        for (i = 0; i < hitTargets.length; i++) {
                            o = hitTargets[i];
                            if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                                if (o.type === "image") {
                                    var scale = that.scales[that.scaleIndex];
                                    if (!scale.isBig) {
                                        h = 240;
                                        var html = "<img src=\"" + o.obj.url + "\" style=\"width:320px;height:240px\"/>";
                                        if (o.obj.date != null) {
                                            html += "<p>" + o.obj.date.formatDate(iSpy.timeFormat) + "</p>";
                                            h += 25;
                                        }
                                        iSpy.helper.showThumb(html, that.container, o.X, o.Y2, 320, h);
                                        needThumb = true;
                                    }

                                }
                            }
                        }
                    }
                    if (!needThumb) {
                        iSpy.helper.hideThumb();
                    }
                }

            };

            function mousedown(e) {
                if (e.target !== domElement)
                    return;
                e.preventDefault();
                if (e.button > 0)
                    return;

                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;

                m = true;
                oxy = { "x": x, "y": y };

                if (scrollYBar.length > 0) {
                    if (x > scrollYBar[0] && y > scrollYBar[1] && x < scrollYBar[2] && y < scrollYBar[3]) {
                        mScroll = true;
                        return;
                    }
                }
            };

            function markSelected(obj) {
                if (obj.grabs == null)
                    return;
                var eventlen = obj.grabs.length;
                for (var k = 0; k < eventlen; k++) {
                    var ev = obj.grabs[k];
                    if (ev.date != null && startDate != null && endDate != null) {
                        var t = ev.date.getTime();
                        if (t < startDate || t > endDate)
                            continue;
                    }
                    ev.selected = obj.selected;
                }
            }

            function click(e) {
                if (e.target !== domElement || mScroll)
                    return;
                mxy = iSpy.helper.mouseXY(domElement, e);
                m = false;
                var d = Math.sqrt(Math.pow((mxy.x - oxy.x), 2) + Math.pow((mxy.y - oxy.y), 2));
                if (d > 10) {
                    window.requestAnimationFrame(render);
                    return;
                }

                var x = mxy.x, y = mxy.y;
                iSpy.helper.hideThumb();
                var i, j, o, o2;
                loop1:
                    for (i = 0; i < hitTargets.length; i++) {
                        o = hitTargets[i];

                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            if (o.type === "image") {
                                iSpy.tools.loadSnapshot(o.obj);
                                return;
                            }
                            if (o.obj.auth != null) {
                                //server
                                o.obj.selected = !o.obj.selected;
                                for (j = 0; j < o.obj.objectList.length; j++) {
                                    o2 = o.obj.objectList[j];
                                    o2.selected = o.obj.selected;
                                    markSelected(o2);
                                }
                                window.requestAnimationFrame(render);
                                return;
                            }
                            if (o.obj.type === "Device") {
                                //camera
                                o.obj.selected = !o.obj.selected;
                                markSelected(o.obj);
                                window.requestAnimationFrame(render);
                                return;
                            }
                        }
                    }
                //clicked nothing - deselect selections
                for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;
                    oServer.selected = false;
                    for (j = 0; j < oServer.objectList.length; j++) {
                        o2 = oServer.objectList[j];
                        o2.selected = false;
                        markSelected(o2);
                    }
                }
                window.requestAnimationFrame(render);
            };

            function intersectRect(r1, r2) {
                return !(r2.left > r1.right ||
                    r2.right < r1.left ||
                    r2.top > r1.bottom ||
                    r2.bottom < r1.top);
            }

            function mouseup(e) {
                m = false;
                if (e.target !== domElement || mScroll) {
                    mScroll = false;
                    window.requestAnimationFrame(render);
                    return;
                }
                mxy = iSpy.helper.mouseXY(domElement, e);
                var d = Math.sqrt(Math.pow((mxy.x - oxy.x), 2) + Math.pow((mxy.y - oxy.y), 2));
                if (d > 10 && !mScroll) {
                    //drawn out a selection
                    var r1 = {
                        left: Math.min(mxy.x, oxy.x),
                        top: Math.min(mxy.y, oxy.y),
                        right: Math.max(mxy.x, oxy.x),
                        bottom: Math.max(mxy.y, oxy.y)
                    };

                    for (var i = 0; i < hitTargets.length; i++) {
                        var o = hitTargets[i];
                        if (o.type === "image") {
                            var r2 = {
                                left: o.X,
                                top: o.Y,
                                right: o.X2,
                                bottom: o.Y2
                            };
                            if (intersectRect(r1, r2)) {
                                o.obj.selected = !o.obj.selected;
                            }
                        }
                    }
                }
                window.requestAnimationFrame(render);
            };



            this.refresh = function () {
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.SetRange = function () {
                startDate = iSpy.searchOptions.fromDate;
                endDate = iSpy.searchOptions.toDate;

                iSpy.snapshots.dateQuery = "";
                if (startDate != null)
                    iSpy.snapshots.dateQuery += "&startdate=" + iSpy.helper.ticks(startDate);
                if (endDate != null) {
                    iSpy.snapshots.dateQuery += "&endDate=" + iSpy.helper.ticks(endDate);
                }

                scrollBarYPos = 0;
                that.reload();

                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function touchstart(e) {
                touchstarttime = new Date();
                mousedown(e);

            }

            function touchend(e) {
                var t = new Date() - touchstarttime;
                if (t <= iSpy.touchClickDelay) {
                    click(e);
                    return;
                }
                mouseup(e);
            }

            this.deinit = function () {
                $(window).off("resize orientationchange", that.Resize);
                $(document.body).off("mousemove touchmove", mousemove);
                $(document.body).off("mouseup touchcancel", mouseup);
                $(document.body).off("keydown", keydown);
            }

            this.Resize = function () {
                var w = that.container.width();
                if (w < 300) w = 300;
                domElement.width = w;

                var h = $(window).height();
                h = h - that.container.offset().top;
                h -= 90; //footer
                if (h < 300)
                    h = 300;
                domElement.height = h;
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.NavigateTo = function (obj) {
                render(obj);
            };

            this.init = function (ele) {
                that.sectionColor = "#666";
                that.container = ele.parent();
                domElement = ele[0];

                context = domElement.getContext("2d");
                context.translate(0.5, 0.5);

                $(window).on("resize orientationchange", that.Resize);
                $(document.body).on("mousemove touchmove", mousemove);
                $(document.body).on("mouseup touchcancel", mouseup);
                $(document.body).on("keydown", keydown);

                $(domElement).on("mousedown", mousedown);
                $(domElement).on("touchstart", touchstart);
                $(domElement).on("touchend", touchend);
                $(domElement).on("mousewheel", mousewheel);
                $(domElement).on("click", click);

                inited = true;
                that.Resize();
            };
        }

    },
    videowall: {
        objectList: [],
        bindPage: function () {
            iSpy.clearBoundEvents();
            iSpy.videowall1 = new iSpy.videowall.Manager();
            iSpy.videowall1.init($("#videowall"));
            iSpy.intervals.videowallThumbs = window.setInterval(iSpy.videowall1.loadThumbs, 10000);
        },
        Manager: function () {
            var that = this;
            var domElement;
            var framePending = false;
            var context;
            var hitTargets = [];
            this.dragObj = null;
            var m = false;
            var oxy = { x: 0, y: 0 };
            var hcams = 72;
            var xOffset = 0;
            var itemTargets = [];
            var mxy = { x: 0, y: 0 };
            var xOffsetOrig = 0;
            var maxX = 0;

            this.loadThumbs = function () {
                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    that.doLoadThumbs(i);
                }
            }

            function getImage(src, obj) {
                var img = new Image();
                img.src = src;
                img.obj = obj;
                $(img).on("load", function (e) {
                    e.target.obj.ImageLoaded = true;
                    e.target.obj.ImageObject = e.target;
                    that.refresh();
                });
                $(img).on("error", function (e) {
                    e.target.obj.ImageLoaded = false;
                });
            }
            this.doLoadThumbs = function (serverIndex) {
                var oServer = iSpy.config.connectedServers[serverIndex];
                if (!oServer.include)
                    return;
                if (!oServer.gotObjectList) {
                    window.setTimeout(iSpy.videowall1.doLoadThumbs, 500, serverIndex);
                    return;
                }
                var rowlen = oServer.objectList.length;
                for (var j = 0; j < rowlen; j++) {
                    var obj = oServer.objectList[j];
                    if (!iSpy.helper.checkAccess(obj))
                        continue;
                    if (obj.typeID === 2) {
                        getImage(iSpy.helper.unique(oServer.objectList[j].thumbURL), obj);
                    }
                }
            }

            this.fullScreen = function () {
                iSpy.helper.fullScreen(domElement);
            };

            this.addObject = function (auth, typeId, id, cfg) {
                var obj = iSpy.helper.findObject(auth, typeId, id);
                if (obj == null)
                    return;
                obj.sourceWidth = cfg.width;
                obj.sourceHeight = cfg.height;
                iSpy.videowall.objectList.push(obj);
                that.refresh();
                saveConfig();
            }

            this.removeObject = function (obj) {
                for (var i = 0; i < iSpy.videowall.objectList.length; i++) {
                    if (iSpy.videowall.objectList[i] === obj) {
                        iSpy.videowall.objectList.splice(i, 1);
                        break;
                    }
                }
                that.dragObj = null;
                that.refresh();
                saveConfig();
            }

            function mousedown(e) {
                if (e.target === domElement) {
                    m = true;
                    e.preventDefault();
                    oxy = iSpy.helper.mouseXY(domElement, e);
                    var x = oxy.x, y = oxy.y;
                    var o, i;
                    xOffsetOrig = xOffset;
                    for (i = 0; i < hitTargets.length; i++) {
                        o = hitTargets[i];
                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            iSpy.helper.setCursor(e, "pointer");
                            that.dragObj = o.obj;
                            m = true;
                            return;
                        }
                    }

                    for (i = 0; i < itemTargets.length; i++) {
                        o = itemTargets[i];
                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            that.dragObj = o.obj;
                            return;
                        }
                    }

                }
            }

            function mouseup(e) {
                m = false;
                if (e.target === domElement && that.dragObj != null) {
                    mxy = iSpy.helper.mouseXY(domElement, e);
                    var x = mxy.x, y = mxy.y;
                    e.preventDefault();
                    if (that.dragObj != null) {
                        if (iSpy.videowall.objectList.indexOf(that.dragObj) === -1) {
                            if (y > hcams) {
                                iSpy.api.command(that.dragObj, "getobjectstatus", function (obj2, data2) {
                                    that.addObject(obj2.parent.auth, 2, obj2.id, data2);
                                    that.dragObj = null;
                                });
                                return;
                            }
                        } else {
                            if (y < hcams) {
                                that.removeObject(that.dragObj);
                                that.dragObj = null;
                                return;
                            }
                        }
                    }
                    for (var i = 0; i < hitTargets.length; i++) {
                        var o = hitTargets[i];
                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            iSpy.helper.setCursor(e, "pointer");
                            var obj = o.obj;
                            if (that.dragObj !== o.obj) {
                                //swap objects
                                for (var j = 0; j < iSpy.videowall.objectList.length; j++) {
                                    if (iSpy.videowall.objectList[j] === obj) {
                                        iSpy.videowall.objectList[j] = that.dragObj;
                                        continue;
                                    }
                                    if (iSpy.videowall.objectList[j] === that.dragObj) {
                                        iSpy.videowall.objectList[j] = obj;
                                    }
                                }
                            }
                        }
                    }

                    that.dragObj = null;
                    saveConfig();
                }
            }

            function mousemove(e) {
                if (e.target === domElement) {
                    mxy = iSpy.helper.mouseXY(domElement, e);
                    iSpy.helper.setCursor(e, "pointer");
                    var needthumb = false;
                    if (m) {
                        if (oxy.y < hcams && mxy.y < hcams) {
                            var dx = xOffsetOrig + mxy.x - oxy.x;
                            xOffset = Math.min(0, Math.max(dx, Math.min(0, domElement.width - maxX)));

                        }
                        iSpy.helper.setCursor(e, "crosshair");
                        that.refresh();

                    } else {
                        for (var i = 0; i < itemTargets.length; i++) {
                            var o = itemTargets[i];
                            if (mxy.x > o.X && mxy.y > o.Y && mxy.x < o.X2 && mxy.y < o.Y2) {
                                iSpy.helper.setCursor(e, "pointer");
                                var src = o.obj.thumbURL.replace("thumb=1", "size=320x240");
                                var html = "<img src=\"" + src + "\" style=\"width:320px;height:240px\"/><p>" + o.obj.parent.name + ": " + o.obj.name + "</p>";
                                iSpy.helper.showThumb(html, that.container, o.X, o.Y2, 320, 265);
                                needthumb = true;
                                break;
                            }
                        }
                    }
                    if (!needthumb)
                        iSpy.helper.hideThumb();

                }
            }

            function drawDrag() {
                if (that.dragObj != null) {
                    if (that.dragObj.ImageObject != null) {
                        var dx = mxy.x - that.dragObj.ImageObject.width / 2;
                        var dy = mxy.y - that.dragObj.ImageObject.height / 2;
                        context.drawImage(that.dragObj.ImageObject, dx, dy);
                    }
                }
            }

            function getLiveImage(src, obj) {
                var img = new Image();
                img.src = src;
                img.obj = obj;

                $(img).on("load", function (e) {
                    e.target.obj.LiveImage = this;
                    e.target.obj.loadingLiveImage = false;
                });
                $(img).on("error", function (e) {
                    e.target.obj.loadingLiveImage = false;
                });
            }

            function render() {
                framePending = false;
                var w = domElement.width;
                var h = domElement.height;

                context.canvas.width = w;

                //draw list of cameras
                context.fillStyle = "#E9E9E9";
                context.fillRect(0, 0, w, hcams);
                itemTargets = [];

                var x = xOffset, y = 0, obj, txt, ar, i;
                var xTot = 0;
                for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include || !oServer.gotObjectList)
                        continue;

                    for (var j = 0; j < oServer.objectList.length; j++) {
                        obj = oServer.objectList[j];
                        if (!iSpy.helper.checkAccess(obj) || obj.typeID !== 2 || iSpy.videowall.objectList.indexOf(obj) !== -1)
                            continue;
                        var draw = x + 90 > 0 && x < w;
                        if (draw) {
                            if (obj.ImageObject != null) {
                                context.drawImage(obj.ImageObject, x, 0, 90, 72);
                                itemTargets.push(new iSpy.helper.HitTarget(x, 0, x + 90, 72, obj));

                            }
                        }
                        x += 94;
                        xTot += 94;
                    }
                }
                maxX = xTot;
                xOffset = Math.min(0, Math.max(xOffset, Math.min(0, domElement.width - maxX)));
                context.stroke();


                var objLen = iSpy.videowall.objectList.length;
                context.fillStyle = "#eee";
                context.fillRect(0, hcams, w, h);
                context.font = "12px verdana";
                if (objLen === 0) {
                    txt = iSpy.helper.translate("t.DropHere");
                    var tw = context.measureText(txt).width;
                    context.fillStyle = "#333";

                    context.fillText(txt, w / 2 - tw / 2, h / 2 - 10 + hcams);
                    context.stroke();
                    if (mxy.y > hcams)
                        drawDrag();
                    return;
                }


                context.strokeStyle = "#ccc";
                context.lineWidth = 1;
                context.textBaseline = "top";
                ar = context.canvas.width / (context.canvas.height - hcams);
                var preferHorizontal = ar < 1.333;
                var rows = Math.min(Math.floor(Math.sqrt(objLen), 1));
                var cols = Math.min(Math.ceil(Math.sqrt(objLen), 1));
                if (rows * cols < objLen)
                    cols++;
                if (preferHorizontal) {
                    var rtemp = rows;
                    rows = cols;
                    cols = rtemp;
                }
                var cellwidth = w / cols;
                var cellheight = (h - hcams) / rows;

                for (i = 1; i < cols; i++) {
                    context.moveTo((i * cellwidth), hcams);
                    context.lineTo((i * cellwidth), h);
                }
                for (i = 1; i < rows; i++) {
                    context.moveTo(0, hcams + (i * cellheight));
                    context.lineTo(w, hcams + (i * cellheight));
                }
                context.stroke();

                hitTargets = [];

                //draw grid
                var cellspacing = 2;

                var contw = cellwidth - (2 * cellspacing);
                var conth = cellheight - (2 * cellspacing);
                var c = 0, r = 0;
                for (i = 0; i < objLen; i++) {
                    obj = iSpy.videowall.objectList[i];
                    if (!iSpy.helper.checkAccess(obj))
                        continue;
                    x = c * cellwidth, y = hcams + r * cellheight;
                    x += cellspacing;
                    y += cellspacing;

                    c++;
                    if (c === cols) {
                        c = 0;
                        r++;
                    }

                    //scale
                    var iw = obj.sourceWidth;
                    var ih = obj.sourceHeight;

                    ar = iw / ih;

                    var f = contw / iw;

                    if (f < 1) {
                        iw = iw * f;
                        ih = ih * f;
                    }

                    f = conth / ih;
                    if (f < 1) {
                        iw = iw * f;
                        ih = ih * f;
                    }
                    hitTargets.push(new iSpy.helper.HitTarget(x, y, x + contw, y + conth, obj));

                    if (!obj.loadingLiveImage) {
                        obj.loadingLiveImage = true;
                        var src = iSpy.helper.unique(obj.thumbURL.replace("thumb=1", "size=" + iw + "x" + ih));
                        getLiveImage(src, obj);

                    }

                    if (obj.LiveImage != null) {
                        //center
                        var ox = x + (contw - iw) / 2;
                        var oy = y + (conth - ih) / 2;
                        context.drawImage(obj.LiveImage, ox, oy, iw, ih);

                    }

                    txt = obj.parent.name + ": " + obj.name;
                    context.fillStyle = "rgba(255,255,255,0.9)";
                    context.fillRect(x - cellspacing, y + conth - 20, contw + (2 * cellspacing), 20);
                    context.fillStyle = "#222";
                    context.fillText(txt, x, y + conth - 18);
                }
                if (mxy.y > hcams || oxy.y > hcams)
                    drawDrag();
            }



            this.Resize = function () {
                var w = that.container.width();
                if (w < 300) w = 300;
                domElement.width = w;

                var h = $(window).height();
                h = h - that.container.offset().top;
                h -= 90; //footer
                if (h < 300)
                    h = 300;
                domElement.height = h;
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function saveConfig() {
                var objLen = iSpy.videowall.objectList.length;
                var s = "";
                for (var i = 0; i < objLen; i++) {
                    var obj = iSpy.videowall.objectList[i];
                    if (!iSpy.helper.checkAccess(obj))
                        continue;
                    var iw = obj.sourceWidth;
                    var ih = obj.sourceHeight;
                    s += obj.parent.name + "," + obj.typeID + "," + obj.id + "," + iw + "," + ih + "|";

                }
                iSpy.helper.createCookie("videoWall", s, 30);
            }


            this.refresh = function () {
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            }

            this.init = function (ele) {
                that.container = ele.parent();
                domElement = ele[0];
                context = domElement.getContext("2d");
                context.translate(0.5, 0.5);
                that.Resize();



                //load from cookie?
                if (iSpy.videowall.objectList.length === 0) {
                    var cfg = iSpy.helper.readCookie("videoWall", "");
                    if (cfg !== "") {
                        var l = cfg.split("|");
                        for (var i = 0; i < l.length; i++) {
                            if (l[i] === "")
                                continue;
                            try {
                                var c = l[i].split(",");
                                var osrv = iSpy.helper.getServer(c[0]);
                                if (osrv != null) {
                                    var typeId = parseInt(c[1]);
                                    var id = parseInt(c[2]);
                                    var w = parseInt(c[3]);
                                    var h = parseInt(c[4]);

                                    var obj = iSpy.helper.findObject(osrv.auth, typeId, id);
                                    if (obj != null) {
                                        obj.sourceWidth = w;
                                        obj.sourceHeight = h;
                                        iSpy.videowall.objectList.push(obj);
                                    }
                                }
                            }
                            catch (e) {

                            }
                        }
                    }
                }

                iSpy.intervals.videowall = window.setInterval(iSpy.videowall1.refresh, 150);


                $(window).on("resize orientationchange", that.Resize);
                $(document.body).on("mousemove touchmove", mousemove);
                $(document.body).on("mouseup touchcancel touchend", mouseup);
                $(domElement).on("mousedown touchstart", mousedown);
                that.loadThumbs();
            };

            this.deinit = function () {
                $(window).off("resize orientationchange", that.Resize);
                window.clearInterval(iSpy.intervals.videowall);
                window.clearInterval(iSpy.intervals.videowallThumbs);
                $(document.body).off("mousemove touchmove", mousemove);
                $(document.body).off("mouseup touchcancel touchend", mouseup);
            };
        }
    },
    livestills: {
        bindPage: function () {
            iSpy.clearBoundEvents();
            iSpy.livestills1 = new iSpy.livestills.Manager();
            iSpy.livestills1.init($("#livestills"));
        },
        Manager: function () {
            var that = this;
            var domElement;
            var framePending = false;
            var context;
            var hitTargets = [];
            var objectList = [];
            this.dragObj = null;
            var m;
            var oxy = null;
            var hcams = 0;
            var xOffset = 0;
            var itemTargets;
            var xOffsetOrig;
            var contw = 0, conth = 0;


            this.addServer = function (oServer) {
                if (!oServer.gotObjectList) {
                    if (!oServer.errorMessage)
                        window.setTimeout(iSpy.livestills1.Manager.addServer, 200, oServer);
                    return;
                }
                for (var j = 0; j < oServer.objectList.length; j++) {
                    var obj = oServer.objectList[j];
                    if (!iSpy.helper.checkAccess(obj) || obj.typeID !== 2)
                        continue;
                    iSpy.api.command(obj, "getobjectstatus", function (obj2, data) {
                        if (obj2.active) {
                            obj2.sourceWidth = data.width;
                            obj2.sourceHeight = data.height;
                            objectList.push(obj2);
                        }
                    });
                }
            }

            this.fullScreen = function () {
                iSpy.helper.fullScreen(domElement);
            };

            this.deinit = function () {
                $(window).off("resize orientationchange", that.Resize);
                window.clearInterval(iSpy.intervals.livestills);
            };

            function click(e) {
                if (e.target === domElement) {
                    m = true;
                    e.preventDefault();
                    oxy = iSpy.helper.mouseXY(domElement, e);
                    var x = oxy.x, y = oxy.y;
                    xOffsetOrig = xOffset;
                    for (var i = 0; i < hitTargets.length; i++) {
                        var o = hitTargets[i];
                        if (x > o.X && y > o.Y && x < o.X2 && y < o.Y2) {
                            iSpy.helper.setCursor(e, "pointer");
                            //iSpy.live.media.Open(o.obj, e);
                            m = true;
                            return;
                        }
                    }
                }
            }

            this.init = function (ele) {
                that.container = ele.parent();
                domElement = ele[0];
                context = domElement.getContext("2d");
                context.translate(0.5, 0.5);
                that.Resize();
                var i;
                for (i = 0; i < iSpy.config.connectedServers.length; i++) {
                    var oServer = iSpy.config.connectedServers[i];
                    if (!oServer.include)
                        continue;
                    that.addServer(oServer);

                }
                iSpy.intervals.livestills = window.setInterval(iSpy.livestills1.loadImages, 1500);

                $(window).on("resize orientationchange", that.Resize);
                $(domElement).on("click", click);
            };


            function render() {
                framePending = false;
                var w = domElement.width;
                var h = domElement.height;

                context.canvas.width = w;

                itemTargets = [];
                var x = xOffset;
                var txt, i;

                var objLen = objectList.length;
                context.fillStyle = "#eee";
                context.fillRect(0, hcams, w, h);
                context.font = "12px verdana";
                if (objLen === 0) {
                    txt = iSpy.helper.translate("t.None");
                    var tw = context.measureText(txt).width;
                    context.fillStyle = "#333";

                    context.fillText(txt, w / 2 - tw / 2, h / 2 - 10 + hcams);
                    context.stroke();
                    return;
                }


                context.strokeStyle = "#ccc";
                context.lineWidth = 1;
                context.textBaseline = "top";
                var ar = context.canvas.width / (context.canvas.height - hcams);
                var preferHorizontal = ar < 1.333;
                var rows = Math.min(Math.floor(Math.sqrt(objLen), 1));
                var cols = Math.min(Math.ceil(Math.sqrt(objLen), 1));
                if (rows * cols < objLen)
                    cols++;
                if (preferHorizontal) {
                    var rtemp = rows;
                    rows = cols;
                    cols = rtemp;
                }
                var cellwidth = w / cols;
                var cellheight = (h - hcams) / rows;

                for (i = 1; i < cols; i++) {
                    context.moveTo((i * cellwidth), hcams);
                    context.lineTo((i * cellwidth), h);
                }
                for (i = 1; i < rows; i++) {
                    context.moveTo(0, hcams + (i * cellheight));
                    context.lineTo(w, hcams + (i * cellheight));
                }
                context.stroke();

                hitTargets = [];

                //draw grid
                var cellspacing = 2;

                contw = cellwidth - (2 * cellspacing);
                conth = cellheight - (2 * cellspacing);
                var c = 0, r = 0, y = 0;
                for (i = 0; i < objLen; i++) {
                    var obj = objectList[i];
                    if (!iSpy.helper.checkAccess(obj))
                        continue;
                    x = c * cellwidth, y = hcams + r * cellheight;
                    x += cellspacing;
                    y += cellspacing;

                    c++;
                    if (c === cols) {
                        c = 0;
                        r++;
                    }

                    //scale
                    var iw = obj.sourceWidth;
                    var ih = obj.sourceHeight;

                    ar = iw / ih;

                    var f = contw / iw;

                    if (f < 1) {
                        iw = iw * f;
                        ih = ih * f;
                    }

                    f = conth / ih;
                    if (f < 1) {
                        iw = iw * f;
                        ih = ih * f;
                    }
                    hitTargets.push(new iSpy.helper.HitTarget(x, y, x + contw, y + conth, obj));

                    if (obj.LiveImage != null) {
                        //center
                        var ox = x + (contw - iw) / 2;
                        var oy = y + (conth - ih) / 2;
                        context.drawImage(obj.LiveImage, ox, oy, iw, ih);

                    }

                    txt = obj.parent.name + ": " + obj.name;
                    context.fillStyle = "rgba(255,255,255,0.9)";
                    context.fillRect(x - cellspacing, y + conth - 20, contw + (2 * cellspacing), 20);
                    context.fillStyle = "#222";
                    context.fillText(txt, x, y + conth - 18);
                }
            }

            function getLiveImage(src, obj) {
                var img = new Image();
                img.src = src;
                img.obj = obj;

                $(img).on("load", function (e) {
                    e.target.obj.LiveImage = this;
                    e.target.obj.loadingLiveImage = false;
                    that.refresh();
                });
                $(img).on("error", function (e) {
                    e.target.obj.loadingLiveImage = false;
                });
            }

            this.loadImages = function () {
                if (contw === 0) {
                    render();
                    return;
                }
                var i;
                for (i = 0; i < objectList.length; i++) {
                    var obj = objectList[i];
                    if (!obj.loadingLiveImage) {
                        obj.loadingLiveImage = true;

                        var iw = obj.sourceWidth;
                        var ih = obj.sourceHeight;

                        var f = contw / iw;

                        if (f < 1) {
                            iw = iw * f;
                            ih = ih * f;
                        }

                        f = conth / ih;
                        if (f < 1) {
                            iw = iw * f;
                            ih = ih * f;
                        }

                        var src = iSpy.helper.unique(obj.thumbURL.replace("thumb=1", "size=" + iw + "x" + ih));
                        getLiveImage(src, obj);
                    }
                }
            }

            this.Resize = function () {
                var w = that.container.width();
                if (w < 300) w = 300;
                domElement.width = w;

                var h = $(window).height();
                h = h - that.container.offset().top;
                h -= 90; //footer
                if (h < 300)
                    h = 300;
                domElement.height = h;
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.refresh = function () {
                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            }
        }
    },
    includeFilter: function (server) {
        return server.include && server.hasExtendedAPI;
    },
    serverLogs: {
        loaded: false,
        bindPage: function () {
            if (!iSpy.serverLogs.loaded)
                iSpy.serverLogs.reload();
        },
        reload: function () {
            for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                var oServer = iSpy.config.connectedServers[i];
                if (!oServer.include || !oServer.gotObjectList)
                    continue;
                if (oServer.Permissions != null && oServer.Permissions.readOnly)
                    continue;

                iSpy.api.command(oServer, "getlogfilelist", function (osrv, data) {
                    iSpy.serverLogs.add(osrv, data);
                });

            }
            iSpy.commands.loaded = true;
        },
        add: function (oServer, data) {
            oServer.logs = data.logs;

            iSpy.rootScope.$apply();
        }
    },
    commands: {
        loaded: false,
        bindPage: function () {
            if (!iSpy.commands.commandsLoaded)
                iSpy.commands.reload();

        },
        reload: function () {
            for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                var oServer = iSpy.config.connectedServers[i];
                if (!oServer.include)
                    continue;
                if (oServer.Permissions != null && oServer.Permissions.readOnly)
                    continue;

                iSpy.api.command(oServer, "getcmdlist", function (osrv, data) {
                    iSpy.commands.add(osrv, data);
                });

            }
            iSpy.commands.loaded = true;
        },
        add: function (oServer, data) {
            oServer.commands = data.commands;

            iSpy.rootScope.$apply();
        },
        sendremotecommand: function (oServer, cmd) {

            iSpy.api.command(oServer, "executecmd&id=" + cmd.id, function (osrv, data) {
                if (data.status !== "ok") {
                    iSpy.LogScope.addLog(osrv.name, cmd.name + ": " + data.status, true);
                    iSpy.rootScope.pop("error", "s.CommandFailed", data.status);
                } else {
                    iSpy.LogScope.addLog(osrv.name, cmd.name + ": " + data.status, false);
                    iSpy.rootScope.pop("success", "s.CommandExecuted", cmd.name);
                }
                iSpy.api.command(osrv, "loadObjects", iSpy.api.refreshObjectList);
                iSpy.rootScope.$apply();
            });
        }
    },
    embed: {
        viewer: {
            generateCode: function () {
                var groups = $("#txtGroups").val().trim();
                if (groups === "")
                    $("#viewerWarning").show();
                else
                    $("#viewerWarning").hide();

                var url = "id=" + iSpy.config.accountDetails.ident + "&uselan=" + $("#chkLAN").is(":checked") + "&groups=" + groups + "&readonly=" + $("#chkReadOnly").is(":checked") + "&ptz=" + $("#chkPTZ").is(":checked") + "&referrer=" + $("#txtReferrer").val();

                $.ajax({
                    type: "POST",
                    url: "/webservices/UserAdmin.asmx/Encrypt",
                    data: '{toEncrypt: "' + url + '"}',
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (response) {
                        iSpy.embed.viewer.renderScript(response);
                    },
                    failure: iSpy.helper.webMethodFailed
                });
            },
            renderScript: function (o) {
                $("#codeResult").show();
                $("#viewerCode").html("&lt;iframe src=\"http://www.ispyconnect.com/watch_pop.aspx?id=" + o.d + "\" width=\"940px\" height=\"500px\" frameborder=\"0\"&gt;&lt;/iframe&gt;");
            }
        },
        camera: {
            loadCameras: function (serverIndex) {
                var oServer = iSpy.config.connectedServers[serverIndex];
                if (!oServer.include || oServer.isAccess)
                    return;
                if (!oServer.gotObjectList) {
                    window.setTimeout(iSpy.embed.camera.loadCameras, 500, serverIndex);
                    return;
                }
                var opt1 = $("#ddlCamera");
                var opt2 = $("#ddlCamera2");

                for (var j = 0; j < oServer.objectList.length; j++) {
                    var q = oServer.objectList[j];
                    opt1.append($("<option></option>").val(oServer.wanPort + "," + q.id).html(q.name));
                    opt2.append($("<option></option>").val(oServer.wanPort + "," + q.id).html(q.name));
                }
            },
            bindPage: function () {
                if (iSpy.config.subscribed) {
                    for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                        iSpy.embed.camera.loadCameras(i);
                    }

                    if ($("#ddlCamera2")[0].options.length === 0) {
                        var opt1 = $("#ddlCamera");
                        var opt2 = $("#ddlCamera2");

                        opt1.append($("<option></option>").val("").html(iSpy.helper.translate("t.None")));
                        opt2.append($("<option></option>").val("").html(iSpy.helper.translate("t.None")));
                        $("#btnGenerate2").attr("disabled", "disabled");
                        $("#btnGenerate").attr("disabled", "disabled");
                    }


                    $("#scriptresult").hide();
                    $("#scriptresult2").hide();
                }
            },
            generateScript: function () {
                var url = "id=" + iSpy.config.accountDetails.ident + "&cam=" + $("#ddlCamera").val() + "&interval=" + $("#txtFrameInterval").val() + "&streamfor=" + $("#txtStreamFor").val() + "&uselan=" + $("#chkLAN").is(':checked') + "&referrer=" + $("#txtReferrer").val();

                var s = $("#ddlSize").val();
                if (s !== "") {
                    if (s === "custom")
                        url += "&size=" + $("#txtCustom").val();
                    else
                        url += "&" + s;
                }

                $.ajax({
                    type: "POST",
                    url: "/webservices/UserAdmin.asmx/Encrypt",
                    data: '{toEncrypt: "' + url + '"}',
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (response) {
                        iSpy.embed.camera.renderScript(response);
                    },
                    failure: iSpy.helper.webMethodFailed
                });
            },
            generateScript2: function () {
                var url = "id=" + iSpy.config.accountDetails.ident + "&cam=" + $("#ddlCamera2").val() + "&streamfor=" + $("#txtStreamFor2").val() + "&uselan=" + $("#chkLAN2").is(":checked") + "&includerecent=" + $("#chkMovies").is(":checked") + "&audio=" + $("#chkAudio").is(":checked") + "&referrer=" + $("#txtReferrer2").val();

                var s = $("#ddlSize2").val();
                if (s !== "") {
                    if (s === "custom")
                        url += "&size=" + $("#txtCustom2").val();
                    else
                        url += "&" + s;
                }

                $.ajax({
                    type: "POST",
                    url: "/webservices/UserAdmin.asmx/Encrypt",
                    data: '{toEncrypt: "' + url + '"}',
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (response) {
                        iSpy.embed.camera.renderScript2(response);
                    },
                    failure: iSpy.helper.webMethodFailed
                });
            },
            renderScript: function (o) {
                var r = "<p>Copy and paste the javascript below into the &lt;head&gt; section of a page on your website:</p>";
                r += "<pre>&lt;script type=\"text/javascript\" src=\"http://www.ispyconnect.com/external_viewer2.aspx?id=" + o.d + "\"&gt;&lt;/script&gt;</pre>";
                r += "<p>The add the following code anywhere in your &lt;body&gt; section to display the live feed on your page:</p><pre>&lt;script&gt;iSpyFeed();&lt;/script&gt;</pre>";
                r += "<p>Optionally add the following code anywhere in your &lt;body&gt; section to display the PTZ controls:</p><pre>&lt;script&gt;iSpyPTZ();&lt;/script&gt;</pre>";

                $("#scriptresult").html(r);
                $("#scriptresult").show();
            },
            renderScript2: function (o) {
                var r = "<p>Copy and paste the iframe code into a page on your website:</p>";
                r += "<pre>&lt;iframe src=\"http://www.ispyconnect.com/external_viewer3.aspx?id=" + o.d + "\" width=\"100%\" height=\"600px\" frameborder=\"0\"&gt;&lt;/iframe&gt;</pre>";
                r += "<p>Next: Save the crossdomain xml file into the root directory of your website.</p>";
                r += "<a role=\"button\" class=\"btn btn-primary\" href=\"/content/crossdomain.xml\" target=\"_blank\">download crossdomain.xml</a> <a role=\"button\" class=\"btn btn-info\" href=\"/external_viewer3.aspx?id=" + o.d + "\" target=\"_blank\">Preview</a>";


                $("#scriptresult2").html(r);
                $("#scriptresult2").show();
            }
        }
    },
    tools: {
        goOldAPI: function () {
            if (iSpy.currentServer.iSpyAccessID > -1) {
                location.href = "/watch_new.aspx?iSpyAccessID=" + iSpy.currentServer.iSpyAccessID;
            } else
                location.href = "/watch_new.aspx";
        },
        loadMedia: function (ev) {
            iSpy.helper.showOverlay();
            iSpy.overlay.isMediaPlayer = true;
            if (iSpy.currentPlayer) {
                iSpy.currentPlayer.jPlayer("clearMedia");
            }
            $("#jp_wrapper").show();
            $("#audioPlayer").hide();
            $("#videoPlayer").hide();
            switch (ev.parent.typeID) {
                case 1:
                    $("#audioPlayer").show();
                    var a = ev.server.url + "loadclip.mp3?oid=" + ev.parent.id + "&ot=" + ev.parent.typeID + "&fn=" + ev.filename + "&auth=" + ev.server.auth;
                    iSpy.audioPlayer.jPlayer("setMedia", {
                        title: ev.parent.name + ", " + ev.date,
                        artist: "iSpy",
                        mp3: a
                    });
                    iSpy.currentPlayer = iSpy.audioPlayer;
                    iSpy.audioPlayer.jPlayer("play");
                    break;
                case 2:
                    $("#videoPlayer").show();
                    var v = ev.server.url + "loadclip.mp4?oid=" + ev.parent.id + "&ot=" + ev.parent.typeID + "&fn=" + ev.filename + "&auth=" + ev.server.auth;
                    iSpy.videoPlayer.jPlayer("setMedia", {
                        title: ev.parent.name + ", " + ev.date,
                        artist: "iSpy",
                        m4v: v
                    });
                    iSpy.currentPlayer = iSpy.videoPlayer;
                    iSpy.videoPlayer.jPlayer("play");
                    break;
            }
            iSpy.api.command(ev.parent, "getgraph&fn=" + ev.filename, function (obj, data) {
                iSpy.tools.grapher.rendergraph(obj, data);
            });
        },
        loadSnapshot: function (ev) {
            iSpy.helper.showOverlay(ev.url);
        },
        grapher: new function () {
            var that = this;
            this.timer = null;
            this.context = null;
            this.ele = null;
            this.inited = false;
            this.target = null;
            this.obj = null;

            function parseData(data, duration, threshold) {
                var step = duration / data.length;
                var outdata = [];
                var j = 0;
                for (var i = 0; i < duration; i += step) {
                    outdata.push([i, parseFloat(data[j])]);
                    j++;
                }
                return [{ label: "Activity Graph", data: outdata, color: "#C8141E", threshold: { below: threshold, color: "rgb(57, 57, 57)" }, lines: { steps: true } }];
            }

            this.rendergraph = function (obj, data) {
                if (data.duration === 0) {
                    iSpy.graph.hide();
                    return;
                }
                that.target = $("#jp_container_audio_1");
                if (obj.typeID === 2) {
                    that.target = $("#jp_container_video_1");
                }
                that.obj = obj;

                var w = that.target.width();
                iSpy.graph.width(w);
                var h = 40;
                iSpy.graph.height(h);

                iSpy.graph.show();
                that.graph_data = parseData(data.raw, data.duration, data.threshold);
                that.duration = data.duration;
                that.context = iSpy.graph[0].getContext("2d");
                that.context.canvas.width = w;
                that.context.canvas.height = h;

                that.DrawGraph(0);
                if (!iSpy.currentPlayer.bound) {
                    iSpy.currentPlayer.bound = true;
                    iSpy.currentPlayer.bind($.jPlayer.event.timeupdate, function (e) {
                        iSpy.tools.grapher.DrawGraph(e.jPlayer.status.currentTime);
                    });
                    iSpy.currentPlayer.bind($.jPlayer.event.ended, function () {
                        iSpy.tools.grapher.DrawGraph(0);
                    });
                }

                if (!that.inited) {
                    that.context.translate(0.5, 0.5);
                    that.inited = true;
                }

            };



            this.DrawGraph = function (time) {
                if (that.duration === 0) {
                    iSpy.graph.hide();
                    return;
                }
                if (isNaN(time))
                    time = 0;
                var w = that.target.width();
                iSpy.graph.width(w);

                var context = that.context;
                if (that.graph_data == null || that.graph_data.length > 0) {
                    var threshold = that.graph_data[0].threshold.below;
                    var data = that.graph_data[0].data;
                    var h = iSpy.graph.height();
                    context.clearRect(-1, -1, context.canvas.width + 2, context.canvas.height + 2);
                    context.strokeStyle = "#333";

                    var r = w / that.duration;
                    var x = 0;

                    for (var i = 0; i < data.length - 1; i++) {
                        var ts1 = data[i][0];
                        var ts2 = data[i + 1][0];
                        var w2 = (ts2 - ts1) * r;
                        var pc;
                        pc = data[i][1];
                        if (that.obj.typeID === 2) {
                            pc = (data[i][1] / 100);
                        }
                        var h2 = h * pc;

                        var rgbr = parseInt(255 * pc);
                        context.fillStyle = "rgb(" + rgbr + ",0,0)";
                        context.fillRect(x, h - h2, w2, h2);
                        x += w2;
                    }

                    context.strokeStyle = "#029BE1";
                    context.lineWidth = 2;
                    context.beginPath();
                    var l = h - threshold * h / 100;
                    context.moveTo(0, l);
                    context.lineTo(w, l);
                    context.stroke();

                    context.strokeStyle = "#029BE1";
                    context.lineWidth = 2;
                    context.beginPath();
                    l = time * r;
                    context.moveTo(l, 0);
                    context.lineTo(l, h);
                    context.stroke();
                }
            };
            function init() {

            }
            init();
        },
        PtzController: function (obj) {
            var that = this;
            this.needsstop = false;
            var framePending = false;
            var domElement = null;
            var context = null;
            var m = false;
            var mxy = { x: 0, y: 0 };
            var jssizeBase = 15;
            var arc = Math.PI / 8;
            this.command = "";
            var ptz = { jsx: 0, jsy: 0, centerx: 50, centery: 50, jssize: 0, moving: false, returning: false, dCenter: 0, angle: 0, maxd: 30, radius: 35 };
            var zoom = { jsx: 0, jsy: 0, centerx: 0, centery: 0, jssize: 0, moving: false, returning: false, dCenter: 0, angle: 0, maxd: 0, radius: 0, width: 18 };



            function render() {
                context.fillStyle = iSpy.themeColor;
                context.fillRect(0, 0, context.canvas.width, context.canvas.height);

                var grad = context.createRadialGradient(ptz.centerx, ptz.centery, 0, ptz.centerx, ptz.centery, ptz.radius);
                grad.addColorStop(1, 'rgb(51,51,51)');
                grad.addColorStop(0, 'rgb(0,0,0)');
                context.fillStyle = grad;
                context.beginPath();
                context.arc(ptz.centerx, ptz.centery, ptz.radius, 0, Math.PI * 2, true);
                context.closePath();
                context.fill();
                grad = context.createRadialGradient(ptz.centerx, ptz.centery, 0, ptz.centerx, ptz.centery, ptz.maxd);
                grad.addColorStop(1, 'rgb(80,80,80)');
                grad.addColorStop(0, 'rgb(31,31,31)');
                context.strokeStyle = grad;
                context.beginPath();
                context.lineWidth = 15;
                context.lineCap = "round";
                context.moveTo(ptz.centerx, ptz.centery);
                context.lineTo(ptz.jsx, ptz.jsy);
                context.stroke();

                ptz.jssize = (1 - (ptz.dCenter / ptz.maxd) * 0.05) * jssizeBase;
                var pr = (ptz.jssize / 1.5);
                if (ptz.dCenter < pr)
                    pr = ptz.dCenter;

                var gx = ptz.jsx - Math.cos(ptz.angle) * pr;
                var gy = ptz.jsy - Math.sin(ptz.angle) * pr;
                if (isNaN(gx))
                    gx = ptz.centerx;
                if (isNaN(gy))
                    gy = ptz.centery;

                try { //this seems to die sometimes... no idea why
                    grad = context.createRadialGradient(gx, gy, 0, ptz.jsx, ptz.jsy, ptz.jssize);
                    grad.addColorStop(0, 'rgb(158,158,158)');
                    grad.addColorStop(0.6, 'rgb(53,53,53)');

                    context.fillStyle = grad;
                } catch (e) {
                    context.fillStyle = "#333";
                }

                context.fillStyle = grad;
                context.beginPath();
                context.arc(ptz.jsx, ptz.jsy, ptz.jssize, 0, Math.PI * 2, true);
                context.closePath();
                context.fill();


                framePending = false;
                var animate = false;

                if (ptz.returning) {
                    ptz.dCenter = ptz.dCenter * 0.8;
                    ptz.jsx = ptz.centerx - Math.cos(ptz.angle) * ptz.dCenter;
                    ptz.jsy = ptz.centery - Math.sin(ptz.angle) * ptz.dCenter;
                    animate = true;
                    if (ptz.dCenter < 1) {
                        ptz.dCenter = 0;
                        ptz.returning = false;
                    }
                }

                //draw zoom control
                grad = context.createRadialGradient(zoom.centerx, zoom.centery, 0, zoom.centerx, zoom.centery, zoom.radius);
                grad.addColorStop(1, 'rgb(51,51,51)');
                grad.addColorStop(0, 'rgb(0,0,0)');
                context.fillStyle = grad;
                context.fillRect(zoom.centerx - zoom.width / 2, zoom.centery - zoom.radius, zoom.width, zoom.radius * 2);
                grad = context.createRadialGradient(zoom.centerx, zoom.centery, 0, zoom.centerx, zoom.centery, zoom.maxd);
                grad.addColorStop(1, 'rgb(80,80,80)');
                grad.addColorStop(0, 'rgb(31,31,31)');
                context.strokeStyle = grad;
                context.beginPath();
                context.lineWidth = 15;
                context.lineCap = "round";
                context.moveTo(zoom.centerx, zoom.centery);
                context.lineTo(zoom.jsx, zoom.jsy);
                context.stroke();

                zoom.jssize = (1 - (zoom.dCenter / zoom.maxd) * 0.05) * jssizeBase;
                pr = (zoom.jssize / 1.5);
                if (zoom.dCenter < pr)
                    pr = zoom.dCenter;

                gy = zoom.jsy - Math.sin(zoom.angle) * pr;
                if (isNaN(gy))
                    gy = zoom.centerx;

                try { //this seems to die sometimes... no idea why
                    grad = context.createRadialGradient(zoom.jsx, gy, 0, zoom.jsx, zoom.jsy, zoom.jssize);
                    grad.addColorStop(0, 'rgb(158,158,158)');
                    grad.addColorStop(0.6, 'rgb(53,53,53)');

                    context.fillStyle = grad;
                } catch (e) {
                    context.fillStyle = "#333";
                }
                context.beginPath();
                context.arc(zoom.jsx, zoom.jsy, zoom.jssize, 0, Math.PI * 2, true);
                context.closePath();
                context.fill();

                if (zoom.returning) {
                    zoom.dCenter = zoom.dCenter * 0.8;
                    //zoom.jsx = zoom.centerx - Math.cos(zoom.angle) * zoom.dCenter;
                    zoom.jsy = zoom.centery - Math.sin(zoom.angle) * zoom.dCenter;
                    animate = true;
                    if (zoom.dCenter < 1) {
                        zoom.dCenter = 0;
                        zoom.returning = false;
                    }
                }
                if (animate) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            }

            function mousemove(e) {
                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;
                var animate = false;
                try {
                    var d;
                    d = Math.sqrt(Math.pow(ptz.jsx - x, 2) + Math.pow(ptz.jsy - y, 2));
                    if (d < ptz.jssize)
                        iSpy.helper.setCursor(e, "pointer");
                    d = Math.sqrt(Math.pow(zoom.jsx - x, 2) + Math.pow(zoom.jsy - y, 2));
                    if (d < zoom.jssize)
                        iSpy.helper.setCursor(e, "pointer");
                    if (!m)
                        return;
                    var angle;
                    if (ptz.moving) {
                        ptz.angle = Math.atan2(ptz.centery - y, ptz.centerx - x);
                        if (isNaN(ptz.angle)) {
                            ptz.angle = 0;
                        }
                        ptz.dCenter = Math.sqrt(Math.pow(x - ptz.centerx, 2) + Math.pow(y - ptz.centery, 2));
                        if (ptz.dCenter > ptz.maxd) {
                            ptz.dCenter = ptz.maxd;
                        }
                        ptz.jsx = ptz.centerx - Math.cos(ptz.angle) * ptz.dCenter;
                        ptz.jsy = ptz.centery - Math.sin(ptz.angle) * ptz.dCenter;
                        animate = true;

                        if (m && ptz.dCenter > ptz.maxd / 2) {
                            angle = ptz.angle;
                            if (angle < arc && angle > -arc) {
                                that.command = ('ispydir_1');
                            }
                            if (angle >= arc && angle < 3 * arc) {
                                that.command = ('ispydir_2');
                            }
                            if (angle >= 3 * arc && angle < 5 * arc) {
                                that.command = ('ispydir_3');
                            }
                            if (angle >= 5 * arc && angle < 7 * arc) {
                                that.command = ('ispydir_4');
                            }
                            if (angle >= 7 * arc || angle < -7 * arc) {
                                that.command = ('ispydir_5');
                            }
                            if (angle <= -5 * arc && angle > -7 * arc) {
                                that.command = ('ispydir_6');
                            }
                            if (angle <= -3 * arc && angle > -5 * arc) {
                                that.command = ('ispydir_7');
                            }
                            if (angle <= -arc && angle > -3 * arc) {
                                that.command = ('ispydir_8');
                            }
                        }

                    }

                    if (zoom.moving) {
                        zoom.angle = Math.atan2(zoom.centery - y, zoom.centerx - x);
                        zoom.dCenter = Math.sqrt(Math.pow(x - zoom.centerx, 2) + Math.pow(y - zoom.centery, 2));
                        if (zoom.dCenter > zoom.maxd) {
                            zoom.dCenter = zoom.maxd;
                        }
                        //zoom.jsx = zoom.centerx - Math.cos(zoom.angle) * zoom.dCenter;
                        zoom.jsy = zoom.centery - Math.sin(zoom.angle) * zoom.dCenter;
                        animate = true;

                        if (m && zoom.dCenter > zoom.maxd / 2) {
                            angle = zoom.angle;
                            if (angle >= 3 * arc && angle < 5 * arc) {
                                that.command = ('ispydir_9');
                            }
                            if (angle <= -3 * arc && angle > -5 * arc) {
                                that.command = ('ispydir_10');
                            }
                        }
                    }
                } catch (e) {
                }

                if (animate && !framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
                if (m) {
                    e.cancelBubble = true;
                    e.stopPropagation();
                }
            };

            function mousedown(e) {
                e.preventDefault();
                if (e.button > 0)
                    return;
                mxy = iSpy.helper.mouseXY(domElement, e);
                var x = mxy.x, y = mxy.y;

                m = true;

                var d = Math.sqrt(Math.pow(ptz.jsx - x, 2) + Math.pow(ptz.jsy - y, 2));
                if (d < ptz.jssize) {
                    ptz.moving = true;
                }
                d = Math.sqrt(Math.pow(zoom.jsx - x, 2) + Math.pow(zoom.jsy - y, 2));
                if (d < zoom.jssize) {
                    zoom.moving = true;
                }

                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            function mouseup() {
                m = false;
                that.command = "";
                if (ptz.moving && obj != null) {
                    ptz.moving = false;
                    ptz.returning = true;
                }

                if (zoom.moving && obj != null) {
                    zoom.moving = false;
                    zoom.returning = true;
                }

                if (!framePending) {
                    framePending = true;
                    window.requestAnimationFrame(render);
                }
            };

            this.refresh = function () {
                render();
            }

            this.checkCommand = function () {
                if (that.command !== "") {
                    that.ptzcommand(that.command);
                    that.needsstop = that.command !== "ispydir_11";
                } else {
                    if (that.needsstop) {
                        that.ptzcommand("ispydir_11");
                        that.needsstop = false;
                    }
                }
            };

            function sendPtz(field, fieldvalue) {
                iSpy.api.command(obj, "ptzcommand&field=" + field + "&value=" + iSpy.helper.encode(fieldvalue), null, null);
            };

            this.ptzcommand = function (cmd) {
                if (cmd !== "") {
                    sendPtz('ptz', cmd);
                }
            };

            this.init = function (ele) {
                ele.addClass("ptzControl");
                var canvas = $('<canvas width="156" height="114"/>');
                canvas.appendTo(ele);
                domElement = canvas[0];
                ptz.jsx = ptz.centerx;
                ptz.jsy = ptz.centery;
                ptz.jssize = jssizeBase;

                zoom.maxd = ptz.maxd;
                zoom.radius = ptz.radius;
                zoom.centerx = ptz.centerx + ptz.maxd + 40;
                zoom.centery = ptz.centery;
                zoom.jssize = jssizeBase;
                zoom.jsx = zoom.centerx;
                zoom.jsy = zoom.centery;
                that.command = "";

                context = domElement.getContext("2d");
                context.translate(0.5, 0.5);

                $(document.body).on("mousemove touchmove", mousemove);
                $(document.body).on("mouseup touchcancel touchend", mouseup);

                $(domElement).on("mousedown touchstart", mousedown);

                render();
            };
            this.deinit = function () {
                $(document.body).off("mousemove touchmove", mousemove);
                $(document.body).off("mouseup touchcancel touchend", mouseup);
            }
        },
        notifications: {
            NativeNotification: null,
            alertNotification: null,
            setNativeNotifications: function () {
                var n = window.Notification;
                if (!n) {
                    iSpy.helper.msg("s.NotSupported", "s.NotSupportedMessage", "warning");
                    return;
                }
                if (n.permission !== "granted") {
                    n.requestPermission(function (permission) {
                        // If the user accepts, let's create a notification
                        if (permission === "granted") {
                            $("#btnNotifications").text("Active");
                        }
                    });
                }
            },
            notify: function (type, title, text) {
                var n = window.Notification;
                if (n) {
                    if (n.permission !== "granted")
                        n = false;
                    else {
                        if (iSpy.tools.notifications.NativeNotification != null)
                            iSpy.tools.notifications.NativeNotification.close();
                    }
                    if (iSpy.helper.readCookie("DisableDesktopNotifications") === "true")
                        n = false;

                    var ua = navigator.userAgent.toLowerCase();
                    var isAndroid = ua.indexOf("android") > -1;
                    if (isAndroid) {
                        //android claims to support them but really doesn't.
                        n = false;
                    }
                }
                switch (type) {
                    case "NewRecording":
                        if (iSpy.helper.readCookie('NotifyRecordings') === "true") {
                            if (n) {
                                iSpy.tools.notifications.NativeNotification = new window.Notification("iSpy: " + title, {
                                    icon: '/monitor/app/img/notifyicon_80.png',
                                    body: text
                                });
                            } else {
                                iSpy.helper.msg("s.NewRecording", text, "info");
                            }
                            return;
                        }
                        break;
                    case "Alert":
                        if (iSpy.helper.readCookie('NotifyAlerts') === "true") {
                            if (n) {
                                iSpy.tools.notifications.NativeNotification = new window.Notification("iSpy: " + title, {
                                    icon: '/monitor/app/img/alerticon_80.png',
                                    body: text
                                });
                            } else {
                                iSpy.helper.msg("s.Alert", text, "warning");
                            }
                            if (iSpy.helper.readCookie('NotifyAlertAlarm') === "true") {
                                iSpy.helper.alarm();
                            }
                        }
                        break;
                }
            }
        }
    },
    serverComms: {
        loadJSON: function (obj, cmd, successFunction, errorFunction) {
            var osrv = obj;
            if (obj.type === "Device")
                osrv = obj.parent;

            var url = osrv.url + "loadobject.json?auth=" + osrv.auth + "&cmd=" + cmd + "&lc=" + iSpy.helper.languageCode() + "&r=" + Math.random();

            switch (successFunction) {
                case "render":
                    successFunction = iSpy.api.render;
                    break;
                case "openRender":
                    successFunction = iSpy.api.openRender;
                    break;
            }
            $.ajax({
                type: "GET",
                url: url,
                data: "",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                context: obj
            }).done(function (data) {
                var srv = this;
                if (srv.parent) {
                    srv = srv.parent;
                }
                if (data.error) {
                    iSpy.helper.msg("s.Error", data.error, "error");
                    if (data.errorType === "authentication") {
                        if (!srv.authFailed || srv.authFailed < new Date((new Date()).getTime() - 60000)) {
                            srv.authFailed = new Date();
                            //$.ajax({
                            //	type: "GET",
                            //	url: "/monitor/app/js/config.aspx?subset=reauth&id="+osrv.ServerID,
                            //	dataType: "json",
                            //	context: osrv,
                            //	success: function (response) {
                            //		this.auth = response[0].auth;
                            //	},
                            //	failure: iSpy.helper.webMethodFailed
                            //});
                        }
                    }
                    if (errorFunction != null) {
                        errorFunction(this, data.error);
                    } else {
                        iSpy.LogScope.addLog(srv.name, cmd + ": " + data.error, true);
                    }
                } else {
                    if (successFunction)
                        successFunction(this, data);
                    if (srv.authFailed) {
                        iSpy.helper.msg("s.Reconnected", srv.name + " Connected", "success");
                        srv.authFailed = null;
                    }

                }
            }).error(function (jqErr, textStatus) {
                if (errorFunction != null) {
                    if (textStatus === "error")
                        textStatus = "Cannot contact server";
                    errorFunction(this, textStatus);
                }
                iSpy.LogScope.addLog(this.name, cmd + ": " + textStatus, true);
            });
        },
        postData: function (obj, cmd, data, resultFunction) {
            var osrv = obj;
            if (obj.type === "Device")
                osrv = obj.parent;
            var t = angular.element(document.body).injector().get('$translate');
            var lc = t.use();
            var url = osrv.url + "loadobject.json?auth=" + osrv.auth + "&cmd=" + cmd + "&lc=" + lc + "&r=" + Math.random();

            $.ajax({
                type: "POST",
                url: url,
                data: data,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                context: obj
            }).done(function (d) {
                resultFunction(this, d);
            }).fail(function (jqErr, textStatus) {
                iSpy.LogScope.addLog(this.name, cmd + ": " + textStatus, true);
            });
        }
    },
    helper: {
        languageCode: function () {
            var t = angular.element(document.body).injector().get('$translate');
            return t.use();
        },
        translate: function (txt) {
            var t = angular.element(document.body).injector().get('$translate');
            return t.instant(txt);
        },
        showIntro: function () {
            var intro = introJs();
            intro.setOptions({ showStepNumbers: false });
            intro.start();
        },
        refreshVisible: function () {
            if (iSpy.snapshots1 != null)
                iSpy.snapshots1.refresh();

            if (iSpy.timeline1 != null)
                iSpy.timeline1.refresh();

            if (iSpy.files1 != null)
                iSpy.files1.refresh();
        },
        alarm: function () {
            if (iSpy.alarmSound == null) {
                iSpy.alarmSound = $("<audio hidden=\"hidden\" autoplay=\"autoplay\" preload=\"none\"></audio>");
                var source = $("<source type=\"audio/mpeg; codecs=mp3\" src=\"/audio/woop.mp3\"/>");
                var source2 = $("<source type=\"audio/wave\" src=\"/audio/woop.wav\"/>");
                source.appendTo(iSpy.alarmSound);
                source2.appendTo(iSpy.alarmSound);
                iSpy.alarmSound[0].load();
                iSpy.alarmSound[0].play();
            } else
                iSpy.alarmSound[0].play();

        },
        encode: function (t) {
            return encodeURIComponent(t);
        },
        center: function (o) {
            if (o.css) {
                o.css("position", "fixed");
                o.css("top", Math.max(0, (($(window).height() - o.outerHeight()) / 2)) + "px");
                o.css("left", ((($(window).width() - o.outerWidth()) / 2)) + "px");
                o.show();
            }
        },
        fullScreen: function (domElement) {

            if (domElement.requestFullscreen) {
                domElement.requestFullscreen();
            } else if (domElement.mozRequestFullScreen) {
                domElement.mozRequestFullScreen();
            } else if (domElement.webkitRequestFullScreen) {
                domElement.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT);
            }
        },
        findID: function (obj, key, val) {
            var objects = [];
            for (var i in obj) {
                if (!obj.hasOwnProperty(i)) continue;
                if (typeof obj[i] == 'object') {
                    objects = objects.concat(iSpy.helper.findID(obj[i], key, val));
                } else if (i === key && obj[key] === val) {
                    objects.push(obj);
                }
            }
            return objects;
        },
        initServerObjectList: function (osrv) {
            if (!osrv.gotObjectList) {
                return;
            }
            for (var j = 0; j < osrv.objectList.length; j++) {
                var obj = osrv.objectList[j];
                iSpy.helper.initObject(obj, osrv);
                if (!obj.hasPermission) {
                    osrv.objectList.splice(j, 1);
                    j--;
                }
            }
            if (osrv.objectCount === 0 && iSpy.config.connectedServers.length === 1) {
                iSpy.currentScope.open('sm', 'partials/ispy_welcome.html', osrv, null);
            }
        },
        initObject: function (obj, osrv) {
            var q = obj, p = osrv;
            q.parent = p;
            q.events = [];
            if (q.typeID === 2) {
                q.thumbURL = p.url + "livefeed?oid=" + q.id + "&thumb=1&auth=" + p.auth;
            }
            q.hasPermission = true;
            q.selected = false;
            q.type = "Device";
            if (p.Permissions != null) {
                var mask = p.Permissions.accessMask;
                var groups = q.groups.toLowerCase();
                if (groups !== "") {
                    q.hasPermission = false;
                    var ams = mask.toLowerCase().split(',');
                    var gs = groups.split(',');
                    if (gs.indexOf("exclude") === -1) {
                        if (mask === "") {
                            q.hasPermission = true;
                        } else {
                            loop1:
                                for (var i2 = 0; i2 < ams.length; i2++) {
                                    var m = ams[i2];
                                    for (var j2 = 0; j2 < gs.length; j2++) {
                                        var g = gs[j2];
                                        if (m !== "" && m === g) {
                                            q.hasPermission = true;
                                            break loop1;
                                        }
                                    }
                                }
                        }
                    }

                }

            }
            if (q.hasPermission)
                p.objectCount++;
        },
        renderAPI: function (serverIndex) {
            var oServer = iSpy.config.connectedServers[serverIndex];
            if (oServer.API == null) {
                window.setTimeout(iSpy.helper.renderAPI, 100, serverIndex);
                return;
            }
            iSpy.rootScope.$apply();
        },
        layoutChanged: function () {
            window.setTimeout(function () {
                if (iSpy.timeline1 != null)
                    iSpy.timeline1.Resize();
                if (iSpy.files1 != null)
                    iSpy.files1.Resize();
                if (iSpy.videowall1 != null)
                    iSpy.videowall1.Resize();
                if (iSpy.snapshots1 != null)
                    iSpy.snapshots1.Resize();
            }, 500);
        },
        Range: function (x1, x2) {
            this.X1 = x1;
            this.X2 = x2;
        },
        zero: function (i) {
            if (i < 10)
                return "0" + i;
            return i;
        },
        RangeContains: function (a, obj) {
            var b = a.length;
            for (var i = 0; i < b; i++) {
                if (obj.X1 >= a[i].X1 && obj.X2 <= a[i].X2) {
                    return true;
                }
            }
            return false;
        },
        HitTarget: function (x, y, x2, y2, obj, type) {
            this.X = x;
            this.Y = y;
            this.X2 = x2;
            this.Y2 = y2;
            this.obj = obj;
            this.type = type || null;
        },
        images: {
            Loading: null,
            Mic: null,
            loadImages: function () {
                function loadImage(src) {
                    var img = new Image();
                    img.src = src;
                    img.loaded = false;
                    $(img).on('load', function () {
                        this.loaded = true;
                    });
                    return img;
                }
                iSpy.helper.images.Loading = loadImage("/monitor/app/img/loading.png");
                iSpy.helper.images.Mic = loadImage("/monitor/app/img/mic.png");
                iSpy.helper.images.ErrorIcon = loadImage("/monitor/app/img/err.png");
                iSpy.helper.images.MicOn = loadImage("/monitor/app/img/mic_on.png");
                iSpy.helper.images.MicOff = loadImage("/monitor/app/img/mic_off.png");
                iSpy.helper.images.CamOff = loadImage("/monitor/app/img/cam_off.png");

            },
            Loaded: function () {
                return iSpy.helper.images.Loading.loaded && iSpy.helper.images.Mic.loaded;
            }
        },
        calcDist: function (p1, p2) {
            return Math.sqrt((Math.pow(p1.x - p2.x, 2) + Math.pow(p1.y - p2.y, 2)));
        },
        mouseXY: function (domElement, e) {

            var ox = $(domElement).offset().left;
            var oy = $(domElement).offset().top;

            var out = { x: 0, y: 0 };
            out.x = e.pageX;
            out.y = e.pageY;

            if (e.originalEvent) {
                if (e.originalEvent.touches) {
                    if (e.originalEvent.touches.length > 0) {
                        out.x = e.originalEvent.touches[0].pageX;
                        out.y = e.originalEvent.touches[0].pageY;
                    } else {
                        if (e.originalEvent.changedTouches) {
                            if (e.originalEvent.changedTouches.length > 0) {
                                out.x = e.originalEvent.changedTouches[0].pageX;
                                out.y = e.originalEvent.changedTouches[0].pageY;
                            }
                        }
                    }
                }
            }
            out.x -= ox;
            out.y -= oy;

            return out;
        },
        setCursor: function (e, c) {
            e = window.event || e;
            var targ = e.target || e.srcElement;

            if (targ == null) {
                return;
            }
            if (targ.style) {
                targ.style.cursor = c;
            } else
                targ.cursor = c;
        },
        serverAddress: function (server) {
            var serverAddress;
            server.isLocal = true;
            server.isBlocked = false;
            if (server.subscribed) {
                if ((server.clientIP === "::1" || server.clientIP === server.serverIP) && server.useLANIP && server.localIP !== "") {
                    //Internal IP Access
                    serverAddress = (server.ssl ? "https" : "http") + "://" + server.localIP + ":" + server.lanPort + "/";
                } else {
                    if (server.overrideURL !== "") {
                        serverAddress = server.overrideURL;
                    } else {
                        //External IP Access
                        serverAddress = (server.ssl ? "https" : "http") + "://" + server.serverIP + ":" + server.wanPort + "/";
                    }
                    server.isLocal = false;
                }
            } else {
                //Internal IP Access
                serverAddress = (server.ssl ? "https" : "http") + "://" + server.localIP + ":" + server.lanPort + "/";
                if ((server.clientIP !== "::1" && server.clientIP !== server.serverIP)) {
                    server.isBlocked = true;
                }
            }

            return serverAddress;
        },
        unique: function (url) {
            var i = url.indexOf("&r=");
            if (i !== -1) {
                var p1 = url.substring(0, i + 3);
                var p2 = url.substring(i + 3);
                var j = p2.indexOf("&");
                if (j > -1)
                    p2 = p2.substring(j);
                else
                    p2 = "";
                return p1 + Math.random() + p2;
            }
            if (url.indexOf("?") !== -1)
                return url + "&r=" + Math.random();
            return url; //static image
        },
        msg: function (title, text, style) {
            iSpy.rootScope.pop(style, title, text);
            iSpy.rootScope.$apply();
        },
        lock: function () {
            window.location.replace('default.aspx?task=lock');
        },
        showOverlay: function (url) {
            iSpy.overlay.show();
            if (url) {
                $("#snapshotImg")[0].src = url;
                $("#snapshotImg").show();
            }
            else
                $("#snapshotImg").hide();
            iSpy.overlay.isMediaPlayer = false;

        },
        hideOverlay: function () {
            if (iSpy.overlay.isMediaPlayer) {
                iSpy.currentPlayer.jPlayer("clearMedia");
                $("#jp_wrapper").hide();
            }
            iSpy.overlay.hide();
        },
        webMethodFailed: function (r) {
            iSpy.LogScope.addLog("Webservices", r.statusText, true, r);
        },
        createCookie: function (name, value, days) {
            var expires = "";
            if (days) {
                var date = new Date();
                date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
                expires = "; expires=" + date.toGMTString();
            }
            document.cookie = name + "=" + value + expires + "; path=/";
        },
        readCookie: function (name, defaultValue) {
            var n = name + "=";
            var ca = document.cookie.split(";");
            for (var i = 0; i < ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) === ' ') c = c.substring(1, c.length);
                if (c.indexOf(n) === 0) return c.substring(n.length, c.length);
            }
            return defaultValue;
        },
        eraseCookie: function (name) {
            iSpy.helper.createCookie(name, "", -1);
        },
        boolCookie: function (name, checkboxid) {
            var cb = $("#" + checkboxid)[0];
            if (cb.checked)
                iSpy.helper.createCookie(name, "true", 30);
            else
                iSpy.helper.eraseCookie(name);
        },
        findObject: function (auth, typeId, id) {
            typeId = parseInt(typeId);
            id = parseInt(id);
            for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                var oServer = iSpy.config.connectedServers[i];
                if (oServer.auth === auth) {
                    if (typeId == null)
                        return oServer;
                    for (var j = 0; j < oServer.objectList.length; j++) {
                        var obj = oServer.objectList[j];
                        if (obj.typeID === typeId && obj.id === id) {
                            return obj;
                        }
                    }
                    return null;
                }
            }
            return null;
        },
        getServer: function (name) {
            for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                var oServer = iSpy.config.connectedServers[i];
                if (oServer.name === name) {
                    if (oServer.include)
                        return oServer;
                }
            }
            return null;
        },
        checkPerm: function (auth, typeId, id) {
            var obj = iSpy.helper.findObject(auth, typeId, id);
            if (obj != null) {
                return iSpy.helper.checkAccess(obj);
            }
            return false;
        },
        checkAccess: function (obj) {
            if (obj.parent.isAccess) {
                return obj.hasPermission;
            }
            return true;
        },
        eventManager: {
            totFiles: 0,
            maxFiles: 500000,
            eventsPerRequest: 1000,
            serversLoaded: 0,
            findTimelineObject: function (oServer, ot, id) {
                for (var i = 0; i < oServer.objectList.length; i++) {
                    var o2 = oServer.objectList[i];
                    if (o2.typeID === ot && o2.id === id)
                        return o2;
                }
                return null;
            },
            loadEvents: function () {
                for (var i = 0; i < iSpy.config.connectedServers.length; i++) {
                    iSpy.helper.eventManager.doLoadEvents(i);
                }
            },
            doLoadEvents: function (serverIndex) {
                var oServer = iSpy.config.connectedServers[serverIndex];
                if (oServer.isBlocked) {
                    iSpy.helper.eventManager.serversLoaded++;
                    if (iSpy.helper.eventManager.serversLoaded === iSpy.config.connectedServers.length) {
                        iSpy.loaded = true;
                    }
                    return;
                }
                if (!oServer.gotObjectList) {
                    window.setTimeout(iSpy.helper.eventManager.doLoadEvents, 500, serverIndex);
                    return;
                }

                iSpy.api.command(oServer, "getevents&num=" + iSpy.helper.eventManager.eventsPerRequest + "&startdate=&enddate=", function (osrv, data) {
                    iSpy.helper.eventManager.addEvents(osrv, data, true);
                });
            },
            addEvents: function (oServer, data, push) {
                var lastLoaded = null;
                oServer.lastUpdate = data.timeStamp;
                for (var e = 0; e < data.events.length; e++) {
                    var o = data.events[e];
                    var obj = iSpy.helper.eventManager.findTimelineObject(oServer, o.ot, o.oid);
                    if (obj != null) {
                        var d = new Date();
                        var duration = parseInt(o.duration);
                        //convert to local time

                        d.setTime(((o.created - 621355968000000000) / 10000) + duration * 1000); //o.created is utc time in .net ticks

                        var activity = parseInt(o.maxalarm);

                        if (!isNaN(duration)) {
                            if (lastLoaded == null || o.created < lastLoaded)
                                lastLoaded = o.created;

                            var fn = o.filename;
                            var rmax = activity;
                            if (rmax < 20)
                                rmax = 20;
                            var rgbr = parseInt(255 * (rmax / 100));
                            var turl = null, turls = null;
                            if (o.ot === 2) {
                                turl = oServer.url + "loadimage?oid=" + o.oid + "&fn=" + fn.replace(".mp4", "_large.jpg").replace(".avi", "_large.jpg") + "&size=320x240&auth=" + oServer.auth;
                                turls = oServer.url + "loadimage?oid=" + o.oid + "&fn=" + fn.replace(".mp4", ".jpg").replace(".avi", ".jpg") + "&auth=" + oServer.auth;
                            }
                            var hs = fn.indexOf("TimeLapse") !== -1;
                            if (push)
                                obj.events.push({ server: oServer, parent: obj, timelapse: hs, filename: fn, duration_seconds: duration, date: d, maxactivity: activity, color: "rgb(" + rgbr + ",51,51)", thumbURL: turl, thumbURLSmall: turls });
                            else
                                obj.events.splice(0, 0, { server: oServer, parent: obj, timelapse: hs, filename: fn, duration_seconds: duration, date: d, maxactivity: activity, color: "rgb(" + rgbr + ",51,51)", thumbURL: turl, thumbURLSmall: turls });
                        }
                    }
                }

                iSpy.helper.refreshVisible();

                if (!iSpy.loaded && push) {
                    iSpy.helper.eventManager.totFiles += data.events.length;

                    if (data.events.length === iSpy.helper.eventManager.eventsPerRequest && iSpy.helper.eventManager.totFiles < iSpy.helper.eventManager.maxFiles) {
                        window.setTimeout(iSpy.helper.eventManager.loadEventList, 200, oServer, lastLoaded);
                    } else {
                        iSpy.helper.eventManager.serversLoaded++;
                        if (iSpy.helper.eventManager.serversLoaded === iSpy.config.connectedServers.length) {
                            iSpy.loaded = true;
                        }
                    }
                }
            },
            loadEventList: function (oServer, lastLoadedTicks) {
                iSpy.api.command(oServer, "getevents&num=" + iSpy.helper.eventManager.eventsPerRequest + "&enddate=" + lastLoadedTicks, function (osrv, data) {
                    iSpy.helper.eventManager.addEvents(osrv, data, true);
                });
            }
        },
        verifyLANIP: function (server) {
            if (!server.useLANIP) {
                iSpy.helper.msg("s.Warning", "s.NoLAN", "warning");
            }
        },
        reload: function () {
            location.reload(true);
        },
        ticks: function (date) {
            this.day = date.getDate();
            this.month = date.getMonth() + 1;
            this.year = date.getFullYear();
            this.hour = date.getHours();
            this.minute = date.getMinutes();
            this.second = date.getSeconds();
            this.ms = date.getMilliseconds();

            this.monthToDays = function (year, month) {
                var add = 0;
                var result = 0;
                if ((year % 4 === 0) && ((year % 100 !== 0) || ((year % 100 === 0) && (year % 400 === 0)))) add++;

                switch (month) {
                    case 0:
                        return 0;
                    case 1:
                        result = 31;
                        break;
                    case 2:
                        result = 59;
                        break;
                    case 3:
                        result = 90;
                        break;
                    case 4:
                        result = 120;
                        break;
                    case 5:
                        result = 151;
                        break;
                    case 6:
                        result = 181;
                        break;
                    case 7:
                        result = 212;
                        break;
                    case 8:
                        result = 243;
                        break;
                    case 9:
                        result = 273;
                        break;
                    case 10:
                        result = 304;
                        break;
                    case 11:
                        result = 334;
                        break;
                    case 12:
                        result = 365;
                        break;
                }
                if (month > 1) result += add;
                return result;
            };
            this.dateToTicks = function (year, month, day) {
                var a = parseInt((year - 1) * 365);
                var b = parseInt((year - 1) / 4);
                var c = parseInt((year - 1) / 100);
                var d = parseInt((a + b) - c);
                var e = parseInt((year - 1) / 400);
                var f = parseInt(d + e);
                var monthDays = this.monthToDays(year, month - 1);
                var g = parseInt((f + monthDays) + day);
                var h = parseInt(g - 1);
                return h * 864000000000;
            };
            this.timeToTicks = function (hour, minute, second) {
                return (((hour * 3600) + minute * 60) + second) * 10000000;
            };
            return this.dateToTicks(this.year, this.month, this.day) + this.timeToTicks(this.hour, this.minute, this.second) + (this.ms * 10000);
        },
        setTheme: function () {
            var color = $("#navBar").css("backgroundColor");
            if (color == null) {
                window.setTimeout(iSpy.helper.setTheme, 100);
                return;
            }
            iSpy.themeColor = iSpy.helper.hexc(color);

            if (iSpy.timeline1 != null) {
                iSpy.timelineOptions.sectionColor = iSpy.themeColor;
            }
            if (iSpy.files1 != null) {
                iSpy.files1.sectionColor = iSpy.themeColor;
            }
            if (iSpy.snapshots1 != null) {
                iSpy.snapshots1.sectionColor = iSpy.themeColor;
            }
            iSpy.helper.refreshVisible();

            for (var i = 0; i < iSpy.liveViewers.length; i++) {
                if (iSpy.liveViewers[i].options.PtzController != null) {
                    iSpy.liveViewers[i].options.PtzController.refresh();
                }
            }
        },
        hexc: function (colorval) {
            var parts = colorval.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
            delete (parts[0]);
            for (var i = 1; i <= 3; ++i) {
                parts[i] = parseInt(parts[i]).toString(16);
                if (parts[i].length === 1) parts[i] = "0" + parts[i];
            }
            return "#" + parts.join("");

        },
        hideThumb: function () {
            if (iSpy.thumb)
                iSpy.thumb.hide();
        },
        showThumb: function (html, div, x, y, w, h) {
            //draw preview thumbnail
            if (iSpy.overlay.is(":visible"))
                return;

            if (w < 160)
                w = 160;
            if (iSpy.thumb.htmlContent === html) {
                iSpy.thumb.show();
                return;
            }
            iSpy.thumb.htmlContent = html;
            var loff = (div.offset().top + y) - 15;
            iSpy.thumb.css({
                "position": "absolute",
                "top": loff + "px",
                "left": (div.offset().left + x) + "px",
                "width": Math.max(w, 140),
                "height": h,
                "z-index": 400,
                "opacity": 0.5,
                "background-color": iSpy.themeColor,
                "color": "#fff",
                "pointer-events": "none",
                "text-align": "center"
            });

            iSpy.thumb.html(html);
            iSpy.thumb.show();
            iSpy.thumb.stop();
            iSpy.thumb.clearQueue();
            iSpy.thumb.delay(20).animate({ opacity: 1.0, top: loff + 15 }, {
                duration: 200,
                specialEasing: {
                    top: "linear"
                }
            });
        },
        stopEvent: function (e) {
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
            if (e.returnValue) e.returnValue = false;
            if (e.cancelBubble) e.cancelBubble = true;
            return false;
        },
        pollPTZ: function () {
            for (var i = 0; i < iSpy.liveViewers.length; i++) {
                if (iSpy.liveViewers[i].options.PtzController != null) {
                    iSpy.liveViewers[i].options.PtzController.checkCommand();
                }
            }
        },
        processActionResult: function (obj, data) {

            var h = data.action;
            switch (h) {
                case "uploadyoutube":
                    h = "Upload to YouTube";
                    break;
                case "massdelete":
                    h = "Delete Files";
                    break;
                case "massdeletegrabs":
                    h = "Delete Snapshots";
                    break;
                case "uploadcloud":
                    h = "Upload to Cloud";
                    break;
                case "archive":
                    h = "Archive";
                    break;
            }
            if (data.status && data.status !== "ok") {
                iSpy.helper.msg("s.Error", data.status, "error");
            }
            iSpy.LogScope.addLog(h, data.status, data.status !== "ok");
            obj.ActionSelected(data.action);
        }
    },
    api: {
        connectSocket: function (osrv) {
            if (window.WebSocket) {
                var wsurl = osrv.url.replace("https:", "wss:").replace("http:", "ws:") + "websocket?auth=" + osrv.auth;
                osrv.socket = new WebSocket(wsurl);
                osrv.socket.server = osrv;

                osrv.socket.onopen = function () {
                    this.send("communication test");
                };

                osrv.socket.onmessage = function (evt) {
                    var t = evt.data.split('|');
                    switch (t[0]) {
                        case "communication success":
                            this.server.socketSupported = true;
                            if (this.server.socketErrorCount && this.server.socketErrorCount > 0) {
                                iSpy.LogScope.addLog("Websocket Connected", "Reconnected", false);
                            }
                            this.server.socketErrorCount = 0;

                            break;
                        case "new events":
                            var sd = this.server.lastUpdate;
                            if (sd) {
                                iSpy.api.command(this.server, "getevents&startdate=" + sd + "&enddate=", function (srv, data) {
                                    srv.lastUpdate = data.timeStamp;
                                    if (data.events.length > 0)
                                        iSpy.helper.eventManager.addEvents(srv, data, false);
                                });
                                iSpy.tools.notifications.notify("NewRecording", "New Recordings", this.server.name + ": " + t[1]);
                            }
                            break;
                        case "objects updated":
                            iSpy.api.command(this.server, "loadObjects", iSpy.api.refreshObjectList);
                            break;
                        case "alert":
                            iSpy.tools.notifications.notify("Alert", "Alert", this.server.name + ": " + t[1]);
                            break;
                        case "error":
                            iSpy.LogScope.addLog("Error", this.server.name + ": " + t[1], true);
                            break;
                        case "message":
                            iSpy.LogScope.addLog("Message", this.server.name + ": " + t[1], false);
                            break;
                    }
                };

                osrv.socket.onclose = function () {
                    if (this.server.socketSupported) {
                        this.server.socketErrorCount++;
                        var delay = Math.min(10, this.server.socketErrorCount);
                        iSpy.LogScope.addLog("Websocket Disconnected", "Reconnecting in " + delay + " s", true);
                        //stretchy reconnect

                        window.setTimeout(iSpy.api.connectSocket, delay * 1000, this.server);
                    }
                };
            }
            else {
                // The browser doesn't support WebSocket
                osrv.socketSupported = false;
                iSpy.LogScope.addLog("Websockets Unsupported", "Update your browser for live updates.", true);
            }
        },
        completeWizard: function (osrv, result) {
            var cmd = "createfromwizard&ot=2&channel=" + iSpy.wizard.channel;
            cmd += "&mmid=" + result.mmid;
            cmd += "&url=" + encodeURIComponent(result.URL);
            cmd += "&username=" + encodeURIComponent(iSpy.wizard.username);
            cmd += "&password=" + encodeURIComponent(iSpy.wizard.password);
            cmd += "&make=" + encodeURIComponent(iSpy.wizard.make);
            cmd += "&model=" + encodeURIComponent(iSpy.wizard.model);
            iSpy.api.command(osrv, cmd, iSpy.api.switchResult);
        },
        liveUpdate: function (o) {
            if (o.live) {
                var obj = iSpy.currentRenderObject.obj;
                var osrv = obj;
                if (obj.type === "Device")
                    osrv = obj.parent;

                var url = osrv.url + "saveobject.json?auth=" + obj.parent.auth + "&lc=" + iSpy.helper.languageCode();
                if (obj.type === "Device")
                    url += "&ot=" + obj.typeID + "&oid=" + obj.id;

                var otemp = { "name": "liveupdate", "sections": [{ "items": [o] }] };

                var jso = JSON.stringify(otemp);
                $.ajax({
                    type: "POST",
                    url: url,
                    data: jso,
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: null,
                    failure: iSpy.helper.webMethodFailed
                });
            }
        },
        apiCommand: function (obj) {
            switch (obj.command) {
                case "runWizard":
                    iSpy.currentScope.open("lg", "partials/ispy_wizard.html", null, null, null);
                    break;
                default:
                    iSpy.api.command(iSpy.currentServer, obj.command, obj.resultFunction);
                    break;
            }
        },
        filterPermission: function (obj) {
            return obj.hasPermission;
        },
        filterPermissionCameras: function (obj) {
            return obj.hasPermission && obj.typeID === 2;
        },
        cloud: {
            authorise: function (name) {
                var osrv = iSpy.currentRenderObject.obj;
                var rurl = encodeURI("https://www.ispyconnect.com/responsecode.aspx");

                switch (name) {
                    case "drive":
                        iSpy.currentScope.open("sm", "partials/ispy_responsecode.html", 'drive', function (name) {
                            iSpy.api.command(osrv, "authorise&provider=" + name + "&code=" + encodeURI(iSpy.api.cloud.responseCode), iSpy.api.cloud.callback);
                        });
                        window.open("https://accounts.google.com/o/oauth2/v2/auth?scope=https://www.googleapis.com/auth/drive&redirect_uri=urn:ietf:wg:oauth:2.0:oob&response_type=code&client_id=648753488389.apps.googleusercontent.com&access_type=offline");
                        break;
                    case "youtube":
                        iSpy.currentScope.open("sm", "partials/ispy_responsecode.html", 'youtube', function (name) {
                            iSpy.api.command(osrv, "authorise&provider=" + name + "&code=" + encodeURI(iSpy.api.cloud.responseCode), iSpy.api.cloud.callback);
                        });
                        window.open("https://accounts.google.com/o/oauth2/v2/auth?scope=https://www.googleapis.com/auth/youtube.upload&redirect_uri=urn:ietf:wg:oauth:2.0:oob&response_type=code&client_id=648753488389.apps.googleusercontent.com&access_type=offline");
                        break;
                    case "flickr":
                        iSpy.api.command(osrv, "getauthoriseurl&provider=" + name, iSpy.api.cloud.callback);
                        iSpy.currentScope.open("sm", "partials/ispy_responsecode.html", 'flickr', function (name) {
                            iSpy.api.command(osrv, "authorise&provider=" + name + "&code=" + encodeURI(iSpy.api.cloud.responseCode), iSpy.api.cloud.callback);
                        });
                        break;
                    case "dropbox":
                        iSpy.currentScope.open("sm", "partials/ispy_responsecode.html", 'dropbox', function (name) {
                            iSpy.api.command(osrv, "authorise&provider=" + name + "&code=" + encodeURI(iSpy.api.cloud.responseCode), iSpy.api.cloud.callback);
                        });
                        window.open("https://www.dropbox.com/oauth2/authorize?client_id=6k40bpqlz573mqt&response_type=code&redirect_uri=" + rurl);
                        break;
                    case "onedrive":
                        iSpy.currentScope.open("sm", "partials/ispy_responsecode.html", 'onedrive', function (name) {
                            iSpy.api.command(osrv, "authorise&provider=" + name + "&code=" + encodeURI(iSpy.api.cloud.responseCode), iSpy.api.cloud.callback);
                        });
                        window.open("https://login.live.com/oauth20_authorize.srf?client_id=000000004C193719&scope=wl.offline_access wl.skydrive_update&response_type=code&redirect_uri=" + rurl);
                        break;
                    case "box":
                        iSpy.currentScope.open("sm", "partials/ispy_responsecode.html", 'box', function (name) {
                            iSpy.api.command(osrv, "authorise&provider=" + name + "&code=" + encodeURI(iSpy.api.cloud.responseCode), iSpy.api.cloud.callback);
                        });
                        window.open("https://account.box.com/api/oauth2/authorize?client_id=0uvr6c6kvl60p7725i62v9ua4k6bclpj&box_login=" + encodeURI(iSpy.config.email) + "&response_type=code&state=" + Math.random() + "&redirect_uri=" + rurl);
                        break;
                }
            },
            callback: function (osrv, data) {
                if (data.url !== "") {
                    $("<a>").attr("href", data.url).attr("target", "_blank")[0].click();
                }
                if (data.error !== "") {
                    iSpy.rootScope.pop("error", data.provider, data.error);
                    iSpy.rootScope.$apply();
                }
                if (data.message !== "") {
                    iSpy.rootScope.pop("success", data.provider, data.message);
                    iSpy.rootScope.$apply();
                }
            }
        },
        serverClick: function (osrv) {
            iSpy.currentServer = osrv;
            iSpy.currentScope.open('lg', 'partials/ispy_server.html', null, null, null);
        },
        attachAPI: function (osrv, data) {
            osrv.API = data;
            iSpy.rootScope.$apply();
            iSpy.api.command(osrv, "loadObjects", iSpy.api.attachObjectList);
            iSpy.api.connectSocket(osrv);
        },
        loadAPIFailed: function (osrv, err) {
            osrv.errorMessage = err;
            iSpy.connectionErrors.push(osrv);
            iSpy.rootScope.$apply();
        },
        reloadAPI: function (osrv) {
            iSpy.api.command(osrv, "loadAPI", iSpy.api.attachAPI, iSpy.api.loadAPIFailed);
        },
        attachObjectList: function (osrv, data) {
            osrv.objectList = data.objectList;
            osrv.gotObjectList = true;
            iSpy.helper.initServerObjectList(osrv);
            iSpy.rootScope.$apply();
        },
        refreshObjectList: function (obj, data) {
            var osrv = obj;
            if (obj.type === "Device")
                osrv = obj.parent;

            osrv.objectListTimeStamp = data.objectListTimeStamp;
            var io, i, j, o;
            for (i = 0; i < data.objectList.length; i++) {
                io = data.objectList[i];
                var ioorig = null;
                for (j = 0; j < osrv.objectList.length; j++) {
                    o = osrv.objectList[j];
                    if (o.typeID === io.typeID && o.id === io.id) {
                        ioorig = o;
                        break;
                    }
                }
                if (ioorig == null) {
                    //item added
                    iSpy.helper.initObject(io, osrv);
                    osrv.objectList.push(io);
                } else {
                    //item updated
                    for (var prop in io) {
                        if (io.hasOwnProperty(prop)) {
                            ioorig[prop] = io[prop];
                        }
                    }
                }
            }
            for (i = 0; i < osrv.objectList.length; i++) {
                io = osrv.objectList[i];
                var f = false;
                for (j = 0; j < data.objectList.length; j++) {
                    o = data.objectList[j];
                    if (o.typeID === io.typeID && o.id === io.id) {
                        f = true;
                        break;
                    }
                }
                if (!f) {
                    //deleted
                    osrv.objectList.splice(i, 1);
                    i--;
                }
            }
            iSpy.rootScope.$apply();
            iSpy.helper.refreshVisible();

            if (iSpy.deviceAdded) {
                var objnew = iSpy.helper.findObject(iSpy.currentServer.auth, iSpy.deviceAdded.typeID, iSpy.deviceAdded.ID);
                iSpy.api.command(objnew, iSpy.deviceAdded.actionResult, iSpy.api.render);
                iSpy.deviceAdded = null;
            }
        },
        render: function (obj, data) {
            iSpy.api.modal.cleanup();
            iSpy.ObjectLoaded = true;
            if (obj.typeID === 2) {
                var optz = iSpy.helper.findID(data, "id", "ptzModelList");
                if (optz.length > 0) {
                    optz[0].options = obj.parent.API.ptzmodels;
                }
            }
            //convert times (minutes of day to date object)
            var t = iSpy.helper.findID(data, "type", "Time");
            var d1 = (new Date()).getTimezoneOffset() * 60000;
            for (var i = 0; i < t.length; i++) {
                var d = t[i].value;
                t[i].value = new Date(d * 60000 + d1);
            }

            iSpy.currentRenderObject = { "data": data, "obj": obj };

            iSpy.renderObjects.push(iSpy.currentRenderObject);
            window.setTimeout(iSpy.api.bind, 0);
        },
        bind: function () {
            iSpy.rootScope.$apply();
            var obj = iSpy.currentRenderObject.obj;
            $(".zoneManager").each(function () {
                var options = { "isMotion": true, "multiZone": true, "name": "MotionZones", "url": obj.thumbURL.replace("thumb=1", "size=" + this.width + "x" + this.height) };
                this.renderEngine = new iSpy.render.ZoneRenderer(this, options);
            });
            $(".screenAreaManager").each(function () {
                var url = obj.parent.url + "desktopfeed?oid=" + obj.id + "&size=" + this.width + "x" + this.height + "&auth=" + obj.parent.auth;
                var options = { "multiZone": false, "name": "ScreenArea", "url": url };
                this.renderEngine = new iSpy.render.ZoneRenderer(this, options);
            });
            $(".PiPManager").each(function () {
                var options = { "isPiP": true, "multiZone": true, "name": "PiP", "url": obj.thumbURL.replace("thumb=1", "size=" + this.width + "x" + this.height) };
                this.renderEngine = new iSpy.render.ZoneRenderer(this, options);
            });
            $(".volumeLevel").each(function () {
                this.renderEngine = new iSpy.render.LevelRenderer(this);
            });
        },
        openRender: function (obj, data) {
            iSpy.currentScope.open("lg", "partials/ispy_render.html", null, null, iSpy.api.modal.dismissed);
            iSpy.api.render(obj, data);
        },
        command: function (obj, cmd, successFunction, errorFunction) {
            if (obj.type === "Device") {
                cmd += "&ot=" + obj.typeID + "&oid=" + obj.id;
            }
            iSpy.serverComms.loadJSON(obj, cmd, successFunction, errorFunction);
        },
        commandDeferred: function (obj, cmd) {
            return $.Deferred(function (dfrd) {
                iSpy.api.command(obj, cmd, dfrd.resolve, dfrd.reject);
            }).promise();
        },
        postCommand: function (obj, cmd, json, successFunction) {
            if (obj != null) {
                if (obj.type === "Device") {
                    cmd += "&ot=" + obj.typeID + "&oid=" + obj.id;
                }
                iSpy.serverComms.postData(obj, cmd, json, successFunction);
            }
        },
        modal: {
            dismissed: function () {
                if (iSpy.newObject) {
                    iSpy.newObject = false;
                    iSpy.api.tools.deleteObject(iSpy.currentRenderObject.obj, true);
                }
                iSpy.renderObjects = [];
                iSpy.api.modal.cleanup();
            },
            ok: function () {
                iSpy.api.processResult(iSpy.currentRenderObject);
                iSpy.api.modal.cleanup();
                return iSpy.api.popRenderStack();
            },
            cancel: function () {
                if (iSpy.newObject) {
                    iSpy.newObject = false;
                    iSpy.api.tools.deleteObject(iSpy.currentRenderObject.obj, true);
                }
                iSpy.api.modal.cleanup();
                return iSpy.api.popRenderStack();
            },
            cleanup: function () {
                $(".renderEngine").each(function () {
                    if (this.renderEngine != null) {
                        this.renderEngine.deinit();
                        this.renderEngine = null;
                    }
                });
            },
            setActiveTab: function (sec) {
                var o = iSpy.currentRenderObject.data.sections;
                for (var i = 0; i < o.length; i++) {
                    var s = o[i];
                    s.tabActive = false;
                    if (s.header === sec.header)
                        s.tabActive = true;
                }
            },
            buttonClick: function (obj) {
                var cmd;
                switch (obj.action) {
                    case "authorise":
                        iSpy.api.cloud.authorise(obj.parameter);
                        break;
                    case "editsource":
                        cmd = obj.action;
                        iSpy.api.command(iSpy.currentRenderObject.obj, cmd, iSpy.api.render);
                        break;
                    case "onvifdiscover":
                        var surl = $("#txtOnvifURL").val();
                        var un = $("#txtOnvifUsername").val();
                        var pwd = $("#txtOnvifPassword").val();
                        cmd = obj.action + "&un=" + encodeURIComponent(un) + "&pwd=" + encodeURIComponent(pwd) + "&surl=" + encodeURIComponent(surl);
                        $("#btnOnvifDiscover").attr('disabled', 'disabled');
                        iSpy.api.command(iSpy.currentRenderObject.obj, cmd, function (obj2, data) {
                            $("#btnOnvifDiscover").removeAttr('disabled');
                            var o = iSpy.helper.findID(iSpy.currentRenderObject.data, "id", "ddlOnvifURLs")[0];
                            o.options = data.list;
                            if (o.options.length === 0)
                                o.options = [{ "value": "", "text": "None" }];
                            o.value = o.options[0].value;
                            iSpy.currentScope.apply();
                            iSpy.rootScope.$apply();
                        }, function () {
                            $("#btnOnvifDiscover").removeAttr('disabled');
                        });
                        break;
                    default:
                        iSpy.api.command(iSpy.currentRenderObject.obj, obj.action, iSpy.api.render);
                        break;

                }
            }
        },
        popRenderStack: function () {
            iSpy.renderObjects.pop();
            if (iSpy.renderObjects.length > 0) {
                iSpy.currentRenderObject = iSpy.renderObjects[iSpy.renderObjects.length - 1];
                window.setTimeout(iSpy.api.bind, 0);
                return false;
            } else {
                return true;
            }

        },
        updateServerConfig: function (data, index) {
            iSpy.currentRenderObject.data.sections[index].items = data.sections[index].items;
            iSpy.rootScope.$apply();
        },
        switchResult: function (obj, data) {
            switch (data.actionResult) {
                case "waiteditobject":
                    iSpy.helper.msg("s.Updating", "s.PleaseWait", "success");
                    window.setTimeout(
						function (o) {
						    iSpy.api.command(o, "loadObjects", function (o2, d2) {
						        iSpy.api.refreshObjectList(o2, d2);
						        iSpy.helper.msg("s.Updated", "s.Done", "success");
						        if (iSpy.newObject) {
						            iSpy.newObject = false;
						            iSpy.api.tools.editObject(obj);
						        } else {
						            iSpy.renderObjects.pop();
						            iSpy.api.command(o, "editobject", iSpy.api.render);
						        }
						    });
						}, 5000, obj, data);
                    return;
                case "waiteditobjectnew": //from wizard
                    iSpy.helper.msg("s.Updating", "s.PleaseWait", "success");
                    window.setTimeout(
						function (o, d) {
						    o.dataPacket = d;
						    iSpy.api.command(o, "loadObjects", function (o2, d2) {
						        iSpy.api.refreshObjectList(o2, d2);
						        iSpy.helper.msg("s.Updated", "s.Done", "success");
						        var obj2 = iSpy.helper.findObject(o.auth, o.dataPacket.typeID, o.dataPacket.ID);
						        iSpy.api.tools.editObject(obj2);
						    });

						}, 5000, obj, data);
                    break;
                case "ok":
                    break;
                case "reloadFTPServers":
                    iSpy.serverComms.loadJSON(obj, "getSettings", function (obj2, data2) { iSpy.api.updateServerConfig(data2, 2); });
                    break;
                case "reloadStorage":
                    iSpy.serverComms.loadJSON(obj, "getSettings", function (obj2, data2) { iSpy.api.updateServerConfig(data2, 5); });
                    break;
                case "reloadSchedule":
                    iSpy.api.command(obj, "showschedule", function (obj2, data2) {
                        iSpy.currentRenderObject.data = data2;
                        iSpy.rootScope.$apply();
                    });
                    break;
                case "reloadActions":
                    iSpy.api.command(obj, "showactions", function (obj2, data2) {
                        iSpy.currentRenderObject.data = data2;
                        iSpy.rootScope.$apply();
                    });
                    break;
                case "reloadPTZSchedule":
                    iSpy.api.command(obj, "showptzschedule", function (obj2, data2) {
                        iSpy.currentRenderObject.data = data2;
                        iSpy.rootScope.$apply();
                    });
                    break;
                case "editobject": //created from wizard
                    iSpy.currentScope.open("lg", "partials/ispy_render.html", null, null, iSpy.api.modal.dismissed);
                    iSpy.deviceAdded = data;
                    break;
                case "editsource": //created from add source
                    iSpy.deviceAdded = data;
                    break;
            }
            if (data.error) {
                iSpy.helper.msg("s.Error", data.error, "error");
            }
            if (data.message) {
                iSpy.helper.msg("s.Message", data.message, "info");
            }
            //refresh object list
            iSpy.api.command(obj, "loadObjects", iSpy.api.refreshObjectList);
            if (obj.type === "Device") {
                iSpy.live.controls.reload(obj.parent.auth + "_" + obj.typeID + obj.id);
            }

        },
        processResult: function (renderObject) {
            if (!renderObject)
                return;
            var obj = renderObject.obj;
            if (obj.type === "Device")
                obj = obj.parent;

            var url = obj.url + "saveobject.json?auth=" + obj.auth + "&lc=" + iSpy.helper.languageCode();
            if (renderObject.obj.type === "Device") {
                url += "&ot=" + renderObject.obj.typeID + "&oid=" + renderObject.obj.id;
            }

            var json = renderObject.data;

            //convert times to minutes 
            var t = iSpy.helper.findID(json, "type", "Time");
            var d1 = (new Date()).getTimezoneOffset() * 60000;
            for (var i = 0; i < t.length; i++) {
                var d = t[i].value;
                t[i].value = (d.getTime() - d1) / 60000;
            }

            switch (json.okResult) {
                case "UploadJSON":
                    var jso = JSON.stringify(json);
                    $.ajax({
                        type: "POST",
                        url: url,
                        data: jso,
                        contentType: "application/json; charset=utf-8",
                        dataType: "json",
                        context: renderObject.obj,
                        success: function (data) {
                            iSpy.api.switchResult(this, data);
                        },
                        failure: iSpy.helper.webMethodFailed
                    });
                    break;
            }
        },
        tools: {
            add: function (sec) {
                iSpy.api.command(iSpy.currentRenderObject.obj, sec.editJSON + "&ident=new", iSpy.api.render);

            },
            edit: function (sec, itm) {
                iSpy.api.command(iSpy.currentRenderObject.obj, sec.editJSON + "&ident=" + itm.value, iSpy.api.render);

            },
            del: function (sec, itm) {
                iSpy.api.command(iSpy.currentRenderObject.obj, sec.deleteJSON + "&ident=" + itm.value, iSpy.api.switchResult);
            },
            editObject: function (obj) {
                iSpy.ObjectLoaded = false;
                iSpy.currentRenderObject = null;
                iSpy.currentScope.open("lg", "partials/ispy_render.html", null, null, iSpy.api.modal.dismissed);
                iSpy.api.command(obj, "editobject", iSpy.api.render);
            },
            deleteObject: function (obj, skipConfirm) {
                if (skipConfirm) {
                    iSpy.api.command(obj, "deleteobject", iSpy.api.switchResult);
                }
                else {
                    iSpy.currentScope.open("sm", "partials/ispy_confirm.html", obj, function (obj2) {
                        iSpy.api.command(obj2, "deleteobject", iSpy.api.switchResult);
                    });
                }
            },
            addObject: function (obj) {
                iSpy.currentScope.open("lg", "partials/ispy_render.html", null, null, iSpy.api.modal.dismissed);
                iSpy.currentRenderObject = null;
                iSpy.newObject = true;
                iSpy.api.command(iSpy.currentServer, "adddevice&ot=" + obj.typeID + "&sourceTypeID=" + obj.sourceTypeID, iSpy.api.switchResult);
            }
        }
    }
}

//prototypes
var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var dayNames = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];

// ReSharper disable once NativeTypePrototypeExtending
Date.prototype.addHours = function (h) {
    this.setTime(this.getTime() + (h * 60 * 60 * 1000));
    return this;
};
// ReSharper disable once NativeTypePrototypeExtending
Date.prototype.formatDate = function (format) {
    var date = this;
    if (!format)
        format = "MM/dd/yyyy";

    var month = date.getMonth() + 1;
    var year = date.getFullYear();

    if (format.indexOf("yyyy") > -1)
        format = format.replace("yyyy", year.toString());
    else if (format.indexOf("yy") > -1)
        format = format.replace("yy", year.toString().substr(2, 2));

    format = format.replace("dd", date.getDate().toString().padL(2, "0"));

    var hours = date.getHours();
    if (format.indexOf("t") > -1) {
        if (hours > 11)
            format = format.replace("t", " PM");
        else
            format = format.replace("t", " AM");
    }
    if (format.indexOf("HH") > -1)
        format = format.replace("HH", hours.toString().padL(2, "0"));
    if (format.indexOf("hh") > -1) {
        if (hours > 12) hours -= 12;
        if (hours === 0) hours = 12;
        format = format.replace("hh", hours.toString().padL(2, "0"));
    }
    if (format.indexOf("mm") > -1)
        format = format.replace("mm", date.getMinutes().toString().padL(2, "0"));
    if (format.indexOf("ss") > -1)
        format = format.replace("ss", date.getSeconds().toString().padL(2, "0"));

    format = format.replace("MMM", monthNames[month - 1]);
    format = format.replace("MM", month.toString().padL(2, "0"));

    return format;
};
String.repeat = function (chr, count) {
    var str = "";
    for (var x = 0; x < count; x++) {
        str += chr;
    };
    return str;
};
// ReSharper disable once NativeTypePrototypeExtending
String.prototype.padL = function (width, pad) {
    if (!width || width < 1)
        return this;

    if (!pad) pad = " ";
    var length = width - this.length;
    if (length < 1) return this.substr(0, width);

    return (String.repeat(pad, length) + this).substr(0, width);
};
// ReSharper disable once NativeTypePrototypeExtending
String.prototype.padR = function (width, pad) {
    if (!width || width < 1)
        return this;

    if (!pad) pad = " ";
    var length = width - this.length;
    if (length < 1) this.substr(0, width);

    return (this + String.repeat(pad, length)).substr(0, width);
};
// ReSharper disable once NativeTypePrototypeExtending
Array.prototype.hasObject = (
  !Array.indexOf ? function (o) {
      var l = this.length + 1;
      while (l === 1) {
          if (this[l - 1] === o) {
              return true;
          }
      }
      return false;
  } : function (o) {
      return (this.indexOf(o) !== -1);
  }
);

(function () {
    var lastTime = 0;
    var vendors = ["ms", "moz", "webkit", "o"];
    for (var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
        window.requestAnimationFrame = window[vendors[x] + "RequestAnimationFrame"];
        window.cancelAnimationFrame = window[vendors[x] + "CancelAnimationFrame"] || window[vendors[x] + "CancelRequestAnimationFrame"];
    }
    if (!window.requestAnimationFrame)
        window.requestAnimationFrame = function (callback) {
            var currTime = new Date().getTime();
            var timeToCall = Math.max(0, 16 - (currTime - lastTime));
            var id = window.setTimeout(function () {
                callback(currTime + timeToCall);
            },
            timeToCall);
            lastTime = currTime + timeToCall;
            return id;
        };
    if (!window.cancelAnimationFrame)
        window.cancelAnimationFrame = function (id) {
            clearTimeout(id);
        };
}());